"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ResizableStringInput = exports.StringInput = exports.IRIInput = exports.DatatypeRenderer = exports.DatatypeFrameRenderer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactBootstrap = require("react-bootstrap");

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

var _reactTextareaAutosize = _interopRequireDefault(require("react-textarea-autosize"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var DatatypeFrameRenderer = function DatatypeFrameRenderer(_ref) {
  var frame = _ref.frame,
      mode = _ref.mode;

  var _useState = (0, _react.useState)(frame.get()),
      _useState2 = _slicedToArray(_useState, 2),
      val = _useState2[0],
      setV = _useState2[1];

  var _useState3 = (0, _react.useState)(frame.getType()),
      _useState4 = _slicedToArray(_useState3, 2),
      type = _useState4[0],
      setT = _useState4[1];

  var _useState5 = (0, _react.useState)(frame.language || false),
      _useState6 = _slicedToArray(_useState5, 2),
      lang = _useState6[0],
      setL = _useState6[1];

  var opts = frame.display_options ? frame.display_options : {};

  if (typeof opts.placeholder == "undefined") {
    opts.placeholder = "Enter " + _terminusdbClient["default"].UTILS.shorten(frame.getType()).split(":")[1];
  }

  if (frame.status == "new") opts.autofocus = true;

  var _useState7 = (0, _react.useState)(opts),
      _useState8 = _slicedToArray(_useState7, 2),
      options = _useState8[0],
      setOptions = _useState8[1];

  (0, _react.useEffect)(function () {
    setV(frame.get());
    setT(frame.getType());
    setL(frame.language || false);
    setOptions(frame.display_options || {});
  }, [frame]);

  var upd = function upd(v, t, l) {
    if (frame.controls && frame.controls["delete"] && v != val && v === "") {
      frame.controls["delete"]();
    } else if (frame.controls && frame.controls.update) {
      if (v != val || t && t != type || l && lang != l) {
        frame.controls.update(v, t, l);
      }
    }
  };

  return /*#__PURE__*/_react["default"].createElement(DatatypeRenderer, {
    val: val,
    type: type,
    mode: mode,
    lang: lang,
    options: options,
    onChange: upd
  });
};

exports.DatatypeFrameRenderer = DatatypeFrameRenderer;

var DatatypeRenderer = function DatatypeRenderer(_ref2) {
  var val = _ref2.val,
      type = _ref2.type,
      lang = _ref2.lang,
      mode = _ref2.mode,
      options = _ref2.options,
      onChange = _ref2.onChange;

  var _useState9 = (0, _react.useState)(val),
      _useState10 = _slicedToArray(_useState9, 2),
      value = _useState10[0],
      setValue = _useState10[1];

  var _useState11 = (0, _react.useState)(type),
      _useState12 = _slicedToArray(_useState11, 2),
      dtype = _useState12[0],
      setDtype = _useState12[1];

  var _useState13 = (0, _react.useState)(lang),
      _useState14 = _slicedToArray(_useState13, 2),
      language = _useState14[0],
      setLanguage = _useState14[1];

  var onChangeValue = function onChangeValue(nv) {
    if (nv != value) {
      setValue(nv);
      onChange(nv, dtype, language);
    }
  };

  var viewer = getRendererForSituation(val, type, lang, mode, options); //let tmeta = getTypeStruct(type, types)

  var content = value;

  if (viewer == "resizable_string") {
    return /*#__PURE__*/_react["default"].createElement(ResizableStringInput, {
      val: value,
      onChange: onChangeValue,
      options: options
    });
  } else if (viewer == "iri") {
    return /*#__PURE__*/_react["default"].createElement(IRIInput, {
      mode: mode,
      val: value,
      onChange: onChangeValue,
      options: options
    });
  }

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-simple-value"
  }, value);
};

exports.DatatypeRenderer = DatatypeRenderer;

var IRIInput = function IRIInput(_ref3) {
  var val = _ref3.val,
      onChange = _ref3.onChange,
      options = _ref3.options;
  return /*#__PURE__*/_react["default"].createElement(StringInput, {
    val: val,
    onChange: onChange,
    options: options
  });
};

exports.IRIInput = IRIInput;

function getRendererForSituation(val, type, lang, mode, options) {
  if (options && options.dataviewer) return options.dataviewer;

  if (mode == "edit") {
    var longs = ['xdd:html', 'xdd:json', "xsd:string"];

    if (longs.indexOf(_terminusdbClient["default"].UTILS.shorten(type)) == -1) {
      options.singleline = true;
    }

    return "resizable_string";
  }

  return false;
}

var StringInput = function StringInput(_ref4) {
  var val = _ref4.val,
      onChange = _ref4.onChange,
      options = _ref4.options;
  var mv = val ? "" + val : "";
  var ph = options && options.placeholder ? options.placeholder : "";
  var cname = "wiki wiki-text wiki-input" + (options && options.className ? " " + options.className : "");

  var commitChange = function commitChange(e) {
    if (e.target.value != mv) {
      onChange(e.target.value);
    }
  };

  var checkSubmit = function checkSubmit(e) {
    if (e.key === 'Enter') {
      e.preventDefault();
      commitChange(e);
    }
  };

  return /*#__PURE__*/_react["default"].createElement("input", {
    onBlur: commitChange,
    onKeyPress: checkSubmit,
    className: cname,
    placeholder: ph,
    defaultValue: mv
  });
};

exports.StringInput = StringInput;

var ResizableStringInput = function ResizableStringInput(_ref5) {
  var val = _ref5.val,
      onChange = _ref5.onChange,
      options = _ref5.options;
  var ipRef = (0, _react.useRef)();
  var mv = val ? "" + val : "";
  var ph = options && options.placeholder ? options.placeholder : "";
  var cname = "wiki wiki-textarea wiki-input" + (options && options.className ? " " + options.className : "");

  var commitChange = function commitChange(e) {
    if (e.target.value != mv) {
      onChange(e.target.value);
    }
  };

  (0, _react.useEffect)(function () {
    if (options && options.autofocus) ipRef.current.focus();
  }, [options]);

  var checkSubmit = function checkSubmit(e) {
    if (e.key === 'Enter') {
      if (e.ctrlKey || options.singleline) {
        e.preventDefault();
        commitChange(e, false, false, true);
      }
    }
  };

  return /*#__PURE__*/_react["default"].createElement(_reactTextareaAutosize["default"], {
    defaultValue: val,
    minRows: 1,
    ref: ipRef,
    onBlur: commitChange,
    onKeyPress: checkSubmit,
    className: cname,
    placeholder: ph
  });
};

exports.ResizableStringInput = ResizableStringInput;