"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DocumentNavigation = exports.DocumentActionMenu = exports.DocumentActions = exports.DocumentDescription = exports.DocumentTitle = exports.DocumentTile = exports.DocumentRenderer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

var _ObjectRenderer = require("./ObjectRenderer");

var _DatatypeRenderer = require("./DatatypeRenderer");

var _reactOutsideClickHandler = _interopRequireDefault(require("react-outside-click-handler"));

var _ri = require("react-icons/ri");

var _utils = require("./utils");

var _ai = require("react-icons/ai");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var DocumentRenderer = function DocumentRenderer(_ref) {
  var val = _ref.val,
      onDelete = _ref.onDelete,
      mode = _ref.mode,
      frame = _ref.frame,
      expansion = _ref.expansion,
      index = _ref.index,
      view = _ref.view,
      types = _ref.types,
      docs = _ref.docs,
      client = _ref.client,
      autosave = _ref.autosave;
  if (!frame) return null;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      highlighted = _useState2[0],
      setHighlighted = _useState2[1];

  var _useState3 = (0, _react.useState)(1),
      _useState4 = _slicedToArray(_useState3, 2),
      redraw = _useState4[0],
      setRedraw = _useState4[1];

  var _useState5 = (0, _react.useState)(expansion),
      _useState6 = _slicedToArray(_useState5, 2),
      compressed = _useState6[0],
      setCompressed = _useState6[1];

  var flash = function flash() {
    (0, _utils.addFrameControl)(frame, "addProperty", addFrameProperty);
    setRedraw(redraw + 1);
  };

  var addFrameProperty = function addFrameProperty(onChange) {
    var getAddProp = function getAddProp(val) {
      if (val) {
        if (onChange) onChange();
        frame.addProperty(val);
        console.log("added " + val);
        setRedraw(redraw + 1);
      } else {
        console.log("empty property add");
      }
    };

    var txt = (0, _utils.getDocLabel)(frame, types, docs);
    txt = "Add property to " + txt;
    return (0, _utils.getMissingPropertySelector)(frame, getAddProp, txt);
  };

  (0, _utils.addFrameControl)(frame, "highlighted", highlighted);
  (0, _utils.addFrameControl)(frame, "setHighlighted", setHighlighted);
  (0, _utils.addFrameControl)(frame, "compressed", compressed);
  (0, _utils.addFrameControl)(frame, "setCompressed", setCompressed);
  (0, _utils.addFrameControl)(frame, "addProperty", addFrameProperty);

  if (autosave && autosave["delete"]) {
    var deldoc = function deldoc() {
      autosave["delete"](frame, "Document deleted with wiki console").then(function (r) {
        frame.status = "deleted";
        if (onDelete) onDelete();
      })["catch"](function (e) {
        tframe.status = "error";
        setStatus(tframe.status);
        console.log("delete error", e);
      });
    };

    (0, _utils.addFrameControl)(frame, "delete", deldoc);
  }

  if (compressed == "tile") return /*#__PURE__*/_react["default"].createElement(DocumentTile, {
    val: val,
    frame: frame,
    mode: mode,
    types: types,
    docs: docs
  });
  return /*#__PURE__*/_react["default"].createElement(_ObjectRenderer.ObjectRenderer, {
    compressed: compressed,
    document: true,
    frame: frame,
    ping: redraw,
    mode: mode,
    types: types,
    docs: docs,
    autosave: autosave
  });
  var docls = highlighted ? " wiki-document-highlighted" : "";
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-document" + docls
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-document-errors"
  }), compressed != "compressed" && /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-document-headers"
  }, /*#__PURE__*/_react["default"].createElement(DocumentTitle, {
    onUpdate: flash,
    frame: frame,
    mode: mode,
    types: types,
    docs: docs,
    autosave: autosave
  }), /*#__PURE__*/_react["default"].createElement(DocumentDescription, {
    onUpdate: flash,
    frame: frame,
    mode: mode,
    types: types,
    docs: docs,
    autosave: autosave
  })), /*#__PURE__*/_react["default"].createElement(_ObjectRenderer.ObjectRenderer, {
    compressed: compressed,
    frame: frame,
    ping: redraw,
    mode: mode,
    types: types,
    docs: docs,
    autosave: autosave
  }));
};

exports.DocumentRenderer = DocumentRenderer;

var DocumentTile = function DocumentTile(_ref2) {
  var val = _ref2.val,
      frame = _ref2.frame,
      mode = _ref2.mode,
      view = _ref2.view,
      types = _ref2.types,
      docs = _ref2.docs,
      autosave = _ref2.autosave;
  var lab = (0, _utils.getDocIDLabel)(val, docs);
  return /*#__PURE__*/_react["default"].createElement("span", null, lab);
};

exports.DocumentTile = DocumentTile;

var DocumentTitle = function DocumentTitle(_ref3) {
  var frame = _ref3.frame,
      mode = _ref3.mode,
      adVal = _ref3.adVal,
      types = _ref3.types,
      docs = _ref3.docs,
      autosave = _ref3.autosave;
  if (!frame) return null;

  var _useState7 = (0, _react.useState)(false),
      _useState8 = _slicedToArray(_useState7, 2),
      active = _useState8[0],
      setActive = _useState8[1];

  var _useState9 = (0, _react.useState)(frame.status),
      _useState10 = _slicedToArray(_useState9, 2),
      status = _useState10[0],
      setStatus = _useState10[1];

  var activate = function activate() {
    return setActive(true);
  };

  var deactivate = function deactivate() {
    return setActive(false);
  };

  var _useState11 = (0, _react.useState)(getFrameTitleProp(frame, "label")),
      _useState12 = _slicedToArray(_useState11, 2),
      titleProp = _useState12[0],
      setTitleProp = _useState12[1];

  (0, _react.useEffect)(function () {
    if (titleProp) {
      copyDocumentControls(titleProp, frame, adVal, updateTitle(titleProp), deleteTitle(titleProp));

      if (frame.controls && frame.controls.compressed) {
        (0, _utils.addFrameControl)(titleProp, "compressed", frame.controls.compressed);
      }

      if (frame.controls && frame.controls.setCompressed) {
        (0, _utils.addFrameControl)(titleProp, "setCompressed", frame.controls.setCompressed);
      }
    }
  }, [titleProp]);

  var updateTitle = function updateTitle(tframe) {
    return function (v, t, l) {
      if (autosave && autosave.save && v !== "") {
        setStatus("loading");
        autosave.save(tframe, "Title updated on console wiki", v, t, l).then(function (r) {
          tframe.status = "success";
          tframe.set(v);
          if (t) tframe.range = t;
          if (l) tframe.language = l;
          setStatus(tframe.status);
          setTimeout(function () {
            if (tframe.status == "success") {
              tframe.status = "ok";
              setStatus(tframe.status);
            }
          }, 300);
        })["catch"](function (e) {
          tframe.status = "error";
          setStatus(tframe.status);
          console.log("Update error", e);
        });
      } else {
        console.log("no save", tframe);
      }
    };
  };

  var deleteTitle = function deleteTitle(tframe) {
    return function () {
      setTitleProp();

      if (autosave && autosave["delete"]) {
        setStatus("loading");
        autosave["delete"](tframe, "Title deleted with console wiki").then(function (r) {
          tframe.status = "deleted";
          setStatus(tframe.status);
          frame.removePropertyValue("rdfs:label", tframe.get(), tframe.index);
          setTitleProp(getFrameTitleProp(frame, "label"));
        })["catch"](function (e) {
          tframe.status = "error";
          setStatus(tframe.status);
          console.log("Delete error", e);
        });
      } else {
        console.log("no save", tframe);
      }
    };
  };

  if (!titleProp) return null;

  var getPlaceHolder = function getPlaceHolder() {
    var tstruct = (0, _utils.getTypeStruct)(frame.cls, types);
    return "Enter " + tstruct.label + " Title";
  };

  var menus = /*#__PURE__*/_react["default"].createElement(DocumentActions, {
    active: active,
    frame: titleProp,
    mode: mode,
    status: status,
    type: "label",
    types: types,
    docs: docs
  });

  var navigation = /*#__PURE__*/_react["default"].createElement(DocumentNavigation, {
    active: active,
    frame: titleProp,
    status: status,
    mode: mode,
    types: types,
    docs: docs,
    type: "label"
  });

  if (!titleProp.display_options) titleProp.display_options = {};
  if (!titleProp.display_options.placeholder) titleProp.display_options.placeholder = getPlaceHolder();
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-document-title",
    onMouseEnter: activate,
    onMouseLeave: deactivate
  }, /*#__PURE__*/_react["default"].createElement(_utils.WikiRow, {
    menus: menus,
    navigation: navigation,
    active: active,
    type: "object"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-title"
  }, /*#__PURE__*/_react["default"].createElement(_DatatypeRenderer.DatatypeFrameRenderer, {
    frame: titleProp,
    mode: mode,
    types: types,
    docs: docs
  }))));
};

exports.DocumentTitle = DocumentTitle;

function copyDocumentControls(propframe, docframe, addValue, update, ddelete) {
  if (addValue) (0, _utils.addFrameControl)(propframe, "addValue", addValue);
  if (update) (0, _utils.addFrameControl)(propframe, "update", update);
  if (ddelete) (0, _utils.addFrameControl)(propframe, "delete", ddelete);

  if (docframe.controls && docframe.controls["delete"]) {
    (0, _utils.addFrameControl)(propframe, "deleteDocument", docframe.controls["delete"]);
  }

  if (docframe.controls && docframe.controls.duplicate) {
    (0, _utils.addFrameControl)(propframe, "duplicateDocument", docframe.controls.duplicate);
  }

  if (docframe.controls && docframe.controls.highlighted) {
    (0, _utils.addFrameControl)(propframe, "highlighted", docframe.controls.highlighted);
  }

  if (docframe.controls && docframe.controls.setHighlighted) {
    (0, _utils.addFrameControl)(propframe, "setHighlighted", docframe.controls.setHighlighted);
  }

  if (docframe.controls && docframe.controls.addProperty) {
    (0, _utils.addFrameControl)(propframe, "addProperty", docframe.controls.addProperty);
  }
}

var DocumentDescription = function DocumentDescription(_ref4) {
  var frame = _ref4.frame,
      mode = _ref4.mode,
      adVal = _ref4.adVal,
      types = _ref4.types,
      docs = _ref4.docs,
      autosave = _ref4.autosave;
  if (!frame) return null;

  var _useState13 = (0, _react.useState)(false),
      _useState14 = _slicedToArray(_useState13, 2),
      active = _useState14[0],
      setActive = _useState14[1];

  var _useState15 = (0, _react.useState)(frame.status),
      _useState16 = _slicedToArray(_useState15, 2),
      status = _useState16[0],
      setStatus = _useState16[1];

  var activate = function activate() {
    return setActive(true);
  };

  var deactivate = function deactivate() {
    return setActive(false);
  };

  var _useState17 = (0, _react.useState)(getFrameTitleProp(frame, "description")),
      _useState18 = _slicedToArray(_useState17, 2),
      titleProp = _useState18[0],
      setTitleProp = _useState18[1];

  (0, _react.useEffect)(function () {
    if (titleProp) {
      copyDocumentControls(titleProp, frame, adVal, updateDesc(titleProp), deleteDesc(titleProp));

      if (frame.controls && frame.controls.compressed) {
        (0, _utils.addFrameControl)(titleProp, "compressed", frame.controls.compressed);
      }

      if (frame.controls && frame.controls.setCompressed) {
        (0, _utils.addFrameControl)(titleProp, "setCompressed", frame.controls.setCompressed);
      }
    }
  }, [titleProp]);

  var updateDesc = function updateDesc(tframe) {
    return function (v, t, l) {
      if (autosave && autosave.save) {
        setStatus("loading");
        autosave.save(tframe, "Description updated on console wiki", v, t, l).then(function (r) {
          tframe.status = "success";
          setStatus(tframe.status);
          tframe.set(v);
          if (t) tframe.range = t;
          if (l) tframe.language = l;
          setTimeout(function () {
            if (tframe.status == "success") {
              tframe.status = "ok";
              setStatus(tframe.status);
            }
          }, 300);
        })["catch"](function (e) {
          console.log(e);
        });
      } else {
        console.log("no autosave", tframe);
      }
    };
  };

  var deleteDesc = function deleteDesc(tframe) {
    return function () {
      if (autosave && autosave["delete"]) {
        setStatus("loading");
        autosave["delete"](tframe, "Description deleted with console wiki").then(function (r) {
          frame.removePropertyValue("rdfs:label", tframe.get(), tframe.index);
          tframe.status = "deleted";
          setStatus(tframe.status);
        })["catch"](function (e) {
          tframe.status = "error";
          setStatus(tframe.status);
          console.log("Delete Error", e);
        });
      } else {
        console.log("no save", tframe);
      }
    };
  };

  var getPlaceHolder = function getPlaceHolder() {
    var tlab = (0, _utils.getDocLabel)(frame, types, docs);
    return "Enter " + tlab + " Description";
  };

  if (!titleProp) return null;

  var menus = /*#__PURE__*/_react["default"].createElement(DocumentActions, {
    active: active,
    frame: titleProp,
    mode: mode,
    types: types,
    docs: docs,
    status: status,
    type: "description"
  });

  var navigation = /*#__PURE__*/_react["default"].createElement(DocumentNavigation, {
    active: active,
    frame: titleProp,
    types: types,
    docs: docs,
    status: status,
    mode: mode,
    type: "description"
  });

  if (!titleProp.display_options) titleProp.display_options = {};
  if (!titleProp.display_options.placeholder) titleProp.display_options.placeholder = getPlaceHolder();
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-document-description",
    onMouseEnter: activate,
    onMouseLeave: deactivate
  }, /*#__PURE__*/_react["default"].createElement(_utils.WikiRow, {
    menus: menus,
    navigation: navigation,
    active: active,
    type: "object"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-description"
  }, /*#__PURE__*/_react["default"].createElement(_DatatypeRenderer.DatatypeFrameRenderer, {
    frame: titleProp,
    mode: mode,
    types: types,
    docs: docs
  }))));
};

exports.DocumentDescription = DocumentDescription;

var DocumentActions = function DocumentActions(_ref5) {
  var frame = _ref5.frame,
      mode = _ref5.mode,
      type = _ref5.type,
      status = _ref5.status,
      types = _ref5.types,
      docs = _ref5.docs,
      active = _ref5.active;

  var _useState19 = (0, _react.useState)(status == "loading"),
      _useState20 = _slicedToArray(_useState19, 2),
      showMenu = _useState20[0],
      setShowMenu = _useState20[1];

  var toggleMenu = function toggleMenu() {
    if (status != "loading") {
      window.global_popup_lock = !showMenu;
      setShowMenu(!showMenu);
      if ((0, _utils.hasControl)(frame, "setHighlighted")) frame.controls.setHighlighted(!showMenu);
    } else setShowMenu(false);
  };

  var addEntry = function addEntry() {
    if (frame.controls && frame.controls.addValue) {
      frame.controls.addValue();
    }
  };

  var see_actions = active && frame && mode == "edit" && !window.global_popup_lock;
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-left-contents"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-dummy-icon"
  }), active && /*#__PURE__*/_react["default"].createElement(_utils.StatusIndicator, {
    type: "data",
    status: status
  }), see_actions && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-left-icon",
    onClick: toggleMenu
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineMenu, null)), /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-left-icon",
    onClick: addEntry
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlinePlus, null))), showMenu && /*#__PURE__*/_react["default"].createElement(DocumentActionMenu, {
    frame: frame,
    type: type,
    toggle: toggleMenu,
    types: types,
    docs: docs
  }));
};

exports.DocumentActions = DocumentActions;

var DocumentActionMenu = function DocumentActionMenu(_ref6) {
  var frame = _ref6.frame,
      toggle = _ref6.toggle,
      type = _ref6.type,
      types = _ref6.types,
      docs = _ref6.docs;
  var what = frame.getLabel() || type;
  var docname = (0, _utils.getDocLabel)(frame.parent.parent, types, docs);

  var getAction = function getAction(which) {
    return function () {
      (0, _utils.hasControl)(frame, which)();
      toggle();
    };
  };

  return /*#__PURE__*/_react["default"].createElement(_reactOutsideClickHandler["default"], {
    onOutsideClick: toggle
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu"
  }, (0, _utils.hasControl)(frame, 'deleteDocument') && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-entry wiki-menu-delete",
    onClick: getAction('deleteDocument')
  }, /*#__PURE__*/_react["default"].createElement(_ri.RiDeleteBin5Line, {
    className: "wiki-menu-icon"
  }), " Delete ", docname), (0, _utils.hasControl)(frame, 'duplicateDocument') && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-entry wiki-menu-delete",
    onClick: getAction('duplicateDocument')
  }, /*#__PURE__*/_react["default"].createElement(AiOutlineCopy, {
    className: "wiki-menu-icon"
  }), " Clone ", docname), ((0, _utils.hasControl)(frame, 'duplicateDocument') || (0, _utils.hasControl)(frame, 'deleteDocument')) && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-spacer"
  }), (0, _utils.hasControl)(frame, 'delete') && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-entry wiki-menu-delete",
    onClick: getAction('delete')
  }, /*#__PURE__*/_react["default"].createElement(_ri.RiDeleteBin5Line, {
    className: "wiki-menu-icon"
  }), " Delete ", what), (0, _utils.hasControl)(frame, 'duplicate') && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-entry wiki-menu-duplicate",
    onClick: getAction('duplicate')
  }, /*#__PURE__*/_react["default"].createElement(AiOutlineCopy, {
    className: "wiki-menu-icon"
  }), " Clone ", what), ((0, _utils.hasControl)(frame, 'duplicate') || (0, _utils.hasControl)(frame, 'delete')) && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-spacer"
  }), (0, _utils.hasControl)(frame, 'addValue') && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-entry wiki-menu-add",
    onClick: getAction('addValue')
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlinePlus, {
    className: "wiki-menu-icon"
  }), " Add Alternative ", what), /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-spacer"
  })), (0, _utils.hasControl)(frame, 'getViewSelector') && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-selector wiki-menu-addparent"
  }, ViewChooser), /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-spacer"
  })), (0, _utils.hasControl)(frame, 'addProperty') && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-selector wiki-menu-addparent"
  }, getAction('addProperty')())));
};

exports.DocumentActionMenu = DocumentActionMenu;

var DocumentNavigation = function DocumentNavigation(_ref7) {
  var frame = _ref7.frame,
      mode = _ref7.mode,
      view = _ref7.view,
      types = _ref7.types,
      active = _ref7.active;
  if (!(frame && frame.controls)) return null;

  var _useState21 = (0, _react.useState)(frame.controls.compressed || "block"),
      _useState22 = _slicedToArray(_useState21, 2),
      compressed = _useState22[0],
      setCompressed = _useState22[1];

  var toggle = function toggle() {
    if (compressed != "compressed") {
      frame.controls.setCompressed("compressed");
      setCompressed("compressed");
    } else {
      frame.controls.setCompressed("block");
      setCompressed("block");
    }
  };

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-right-contents"
  }, compressed != "compressed" && /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-right-icon",
    onClick: toggle
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineDown, null)), compressed == "compressed" && /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-right-icon",
    onClick: toggle
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineRight, null)));
};

exports.DocumentNavigation = DocumentNavigation;

function getFrameTitleProp(frame, which) {
  var tag = which == "label" ? "rdfs:label" : "rdfs:comment";

  var prop = frame.properties[tag] || frame.properties[_terminusdbClient["default"].UTILS.unshorten(tag)];

  if (!prop) prop = frame.addProperty(tag);
  var vprop = prop ? prop.values[0] : false;
  return vprop;
}