"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FancyRenderer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

var _DocumentRenderer = require("./DocumentRenderer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var FancyRenderer = function FancyRenderer(_ref) {
  var frame = _ref.frame,
      mode = _ref.mode,
      view = _ref.view,
      errors = _ref.errors,
      client = _ref.client;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      types = _useState2[0],
      setTypes = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      docs = _useState4[0],
      setDocs = _useState4[1];

  var wq = _terminusdbClient["default"].WOQL;
  (0, _react.useEffect)(function () {
    if (frame) {
      var ntypes = {};
      var ndocs = {};
      var all_classes = frame.document.getPossibleContainedClasses();
      var q1 = wq.and(wq.lib().classes(), wq.member("v:Class ID", all_classes));
      client.query(q1).then(function (r) {
        for (var i = 0; i < r.bindings.length; i++) {
          ntypes[r.bindings[i]["Class ID"]] = r.bindings[i];
        }

        setTypes(ntypes);
      });
      var all_docs = frame.document.getDocumentLinks();

      if (all_docs) {
        var q2 = wq.and(wq.lib().document_metadata(), wq.member("v:Document ID", all_docs));
        client.query(q2).then(function (r2) {
          for (var i = 0; i < r2.bindings.length; i++) {
            ndocs[r2.bindings[i]["Document ID"]] = r2.bindings[i];
          }

          setDocs(ndocs);
        });
      } else {
        console.log("No docs", frame.document);
      }
    }
  }, [client]);

  var getAutoSave = function getAutoSave() {
    return {
      save: function save(frame, msg, newval, newtype, newlang) {
        return client.query(frame.saveQuery(newval, newtype, newlang), msg);
      },
      "delete": function _delete(frame, msg) {
        return client.query(frame.deleteQuery(), msg);
      },
      load: function load(frame, msg) {
        return client.query(_terminusdbClient["default"].WOQL.read_object(frame.subjid));
      }
    };
  };

  if (!frame) return false;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-full-page"
  }, /*#__PURE__*/_react["default"].createElement(_DocumentRenderer.DocumentRenderer, {
    expansion: "block",
    frame: frame.document,
    mode: mode,
    types: types,
    docs: docs,
    errors: errors,
    client: client,
    autosave: getAutoSave(),
    view: view
  }));
};
/*
export const FancyPageHeader = ({frame, mode, view, types}) => {
    const [active, setActive] = useState(false)
    const toggleActive = () => setActive(!active) 


    let id = TerminusClient.UTILS.shorten(frame.subject())

    let edittit =  <TextareaAutosize minRows={1} className="wiki wiki-title" placeholder={"Enter " + type + "  name"} >{lab}</TextareaAutosize>
    let readtit = <span className="wiki wiki-title">{lab}</span>

    let editdesc = <TextareaAutosize minRows={1} className="wiki wiki-description" placeholder={"Enter " + type + " description"} >{desc}</TextareaAutosize>
    let readdesc = <span className="wiki wiki-description">{desc}</span>


    return <span className="wiki-title-row" onMouseEnter={toggleActive} onMouseLeave={toggleActive}>
        <ValueRow frame={frame} readversion={readtit} editversion={edittit} mode={mode} />
        <ValueRow frame={frame} readversion={readdesc} editversion={editdesc} mode={mode} />
    </span>
}
*/


exports.FancyRenderer = FancyRenderer;