"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ObjectNavigation = exports.ObjectActionMenu = exports.ObjectActions = exports.ObjectStatus = exports.SummarySample = exports.ObjectSummary = exports.ObjectStats = exports.IDRenderer = exports.TypeRenderer = exports.ObjectTitle = exports.ObjectHeader = exports.DocumentHeader = exports.ObjectRenderer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactBootstrap = require("react-bootstrap");

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

var _ai = require("react-icons/ai");

var _PropertyRenderer = require("./PropertyRenderer");

var _utils = require("./utils");

var _reactOutsideClickHandler = _interopRequireDefault(require("react-outside-click-handler"));

var _DatatypeRenderer = require("./DatatypeRenderer");

var _CellRenderer = require("../table/CellRenderer");

var _ri = require("react-icons/ri");

var _DocumentRenderer = require("./DocumentRenderer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ObjectRenderer = function ObjectRenderer(_ref) {
  var frame = _ref.frame,
      mode = _ref.mode,
      docs = _ref.docs,
      document = _ref.document,
      types = _ref.types,
      autosave = _ref.autosave,
      ping = _ref.ping,
      onDelete = _ref.onDelete,
      index = _ref.index,
      compressed = _ref.compressed;
  if (!frame) return null;

  var initiallyExpanded = function initiallyExpanded(frame) {
    if (compressed == "compressed") return false;
    return !(frame.display_options && frame.display_options.collapse);
  };

  var initialViewer = function initialViewer(frame) {
    return "frame";
  };

  var _useState = (0, _react.useState)(1),
      _useState2 = _slicedToArray(_useState, 2),
      redraw = _useState2[0],
      setRedraw = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      active = _useState4[0],
      setActive = _useState4[1];

  var _useState5 = (0, _react.useState)(),
      _useState6 = _slicedToArray(_useState5, 2),
      highlighted = _useState6[0],
      setHighlighted = _useState6[1];

  var _useState7 = (0, _react.useState)(initiallyExpanded(frame)),
      _useState8 = _slicedToArray(_useState7, 2),
      expanded = _useState8[0],
      setExpanded = _useState8[1];

  var _useState9 = (0, _react.useState)(initialViewer(frame)),
      _useState10 = _slicedToArray(_useState9, 2),
      viewer = _useState10[0],
      setViewer = _useState10[1];

  var _useState11 = (0, _react.useState)(),
      _useState12 = _slicedToArray(_useState11, 2),
      props = _useState12[0],
      setProps = _useState12[1];

  var activate = function activate() {
    return setActive(true);
  };

  var deactivate = function deactivate() {
    return setActive(false);
  };

  (0, _react.useEffect)(function () {
    if (compressed) {
      setExpanded(compressed != "compressed");
    }
  }, [compressed]);

  var renderProperties = function renderProperties() {
    setProps();
    var xprops = frame.sortProperties();
    var nprops = [];

    for (var i = 0; i < xprops.length; i++) {
      var vframe = frame.properties[xprops[i]];

      if (vframe && !(vframe.display_options && vframe.display_options.hidden)) {
        //vframe.controls = getPropertyFrameControls(props[i], vframe)
        if (xprops[i] == _terminusdbClient["default"].UTILS.unshorten("rdfs:label")) {//console.log("rpl", vframe.values)
          //alert("rpl")
        }

        var nprop = /*#__PURE__*/_react["default"].createElement(_PropertyRenderer.PropertyRenderer, {
          redraw: ping + redraw,
          types: types,
          docs: docs,
          key: xprops[i] + "_property",
          frame: vframe,
          mode: mode,
          autosave: autosave
        });

        if (nprop) nprops = nprops.concat(nprop);
      }
    } //return nprops


    setProps(nprops);
  };

  var addFrameProperty = function addFrameProperty(onChange) {
    var getAddProp = function getAddProp(val) {
      if (val) {
        setProps();
        if (onChange) onChange();
        frame.addProperty(val);
        renderProperties();
        setRedraw(redraw + 1);
      }
    };

    var txt = (0, _utils.getDocLabel)(frame, types, docs);
    txt = "Add property to " + txt;
    return (0, _utils.getMissingPropertySelector)(frame, getAddProp, txt);
  };

  (0, _react.useEffect)(function () {
    if (frame) {
      if (!frame.controls) {
        frame.controls = {};
      }

      if (autosave && autosave["delete"]) {
        var deldoc = function deldoc() {
          autosave["delete"](frame, "Document deleted with wiki console").then(function (r) {
            frame.status = "deleted";
            if (onDelete) onDelete();
          })["catch"](function (e) {
            frame.status = "error";
            setStatus(frame.status);
            console.log(e);
          });
        };

        (0, _utils.addFrameControl)(frame, "delete", deldoc);
      }

      if (autosave && autosave.save) {
        var upddoc = function upddoc() {
          autosave.save(frame, "Document updated with wiki console").then(function (r) {
            frame.status = "deleted";
            if (onDelete) onDelete();
          })["catch"](function (e) {
            frame.status = "error";
            setStatus(frame.status);
            console.log(e);
          });
        };

        (0, _utils.addFrameControl)(frame, "update", upddoc);
      }

      (0, _utils.addFrameControl)(frame, "addProperty", addFrameProperty);
      (0, _utils.addFrameControl)(frame, "highlighted", highlighted);
      (0, _utils.addFrameControl)(frame, "setHighlighted", setHighlighted);
      (0, _utils.addFrameControl)(frame, "expanded", expanded);
      (0, _utils.addFrameControl)(frame, "setExpanded", setExpanded);

      for (var p in frame.properties) {
        addControlsToPropertyFrame(frame, frame.properties[p]);
      }

      setProps(renderProperties(frame));
    } else {
      console.log("No frame!!");
    }
  }, [frame, ping, types, docs, mode]);

  var getViewSelector = function getViewSelector() {
    var built_in_opts = [{
      'label': "Wiki View",
      value: "frame"
    }, {
      'label': "Table",
      value: "table"
    }, {
      'label': "JSON",
      value: "json"
    }];

    function onChangeView(e) {
      alert("view " + e.value);
    }

    var text = viewer + " selected";
    return /*#__PURE__*/_react["default"].createElement(Select, {
      defaultValue: viewer,
      onChange: onChangeView,
      options: built_in_opts,
      placeholder: text
    });
  };

  function flash() {
    alert("x " + mode);
  }

  var wrapper_class = highlighted ? "wiki-object-highlighted" : active ? "wiki-object-selected" : "";
  var tindex = index || false;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-object-wrapper " + wrapper_class,
    onMouseEnter: activate,
    onMouseLeave: deactivate
  }, document && expanded && /*#__PURE__*/_react["default"].createElement(DocumentHeader, {
    flash: flash,
    frame: frame,
    mode: mode,
    autosave: autosave,
    docs: docs,
    types: types,
    active: active
  }), (!expanded || frame.depth() > 0) && types && /*#__PURE__*/_react["default"].createElement(ObjectHeader, {
    expanded: expanded,
    index: tindex,
    frame: frame,
    mode: mode,
    types: types,
    docs: docs,
    active: active
  }), expanded && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-object-wrapper-properties" + wrapper_class ? " " + wrapper_class + "-properties" : ""
  }, props));
};

exports.ObjectRenderer = ObjectRenderer;

var DocumentHeader = function DocumentHeader(_ref2) {
  var frame = _ref2.frame,
      mode = _ref2.mode,
      types = _ref2.types,
      flash = _ref2.flash,
      active = _ref2.active,
      docs = _ref2.docs,
      autosave = _ref2.autosave;
  if (!frame) return null;

  var addLabel = function addLabel() {
    frame.addPropertyValue("rdfs:label");
  };

  var addComment = function addComment() {
    frame.addPropertyValue("rdfs:comment");
  };

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-document-headers"
  }, /*#__PURE__*/_react["default"].createElement(_DocumentRenderer.DocumentTitle, {
    adVal: addLabel,
    frame: frame,
    mode: mode,
    types: types,
    docs: docs,
    autosave: autosave
  }), /*#__PURE__*/_react["default"].createElement(_DocumentRenderer.DocumentDescription, {
    adVal: addComment,
    frame: frame,
    mode: mode,
    types: types,
    docs: docs,
    autosave: autosave
  }));
};

exports.DocumentHeader = DocumentHeader;

function addControlsToPropertyFrame(frame, vframe) {
  if (!frame.controls) return;
  if (!vframe.controls) vframe.controls = {};
  if (frame.controls.addProperty) vframe.controls.addProperty = frame.controls.addProperty;
}

var ObjectHeader = function ObjectHeader(_ref3) {
  var frame = _ref3.frame,
      index = _ref3.index,
      mode = _ref3.mode,
      types = _ref3.types,
      docs = _ref3.docs,
      active = _ref3.active,
      expanded = _ref3.expanded;

  var _useState13 = (0, _react.useState)(false),
      _useState14 = _slicedToArray(_useState13, 2),
      localActive = _useState14[0],
      setActive = _useState14[1];

  var activate = function activate() {
    return setActive(true);
  };

  var deactivate = function deactivate() {
    return setActive(false);
  };

  var menus = /*#__PURE__*/_react["default"].createElement(ObjectActions, {
    frame: frame,
    mode: mode,
    types: types,
    docs: docs,
    active: localActive
  });

  var navigation = /*#__PURE__*/_react["default"].createElement(ObjectNavigation, {
    expanded: expanded,
    frame: frame,
    mode: mode,
    types: types,
    docs: docs,
    active: active
  });

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-object-header",
    onMouseEnter: activate,
    onMouseLeave: deactivate
  }, /*#__PURE__*/_react["default"].createElement(_utils.WikiRow, {
    menus: menus,
    navigation: navigation,
    active: active,
    index: index,
    type: "object"
  }, /*#__PURE__*/_react["default"].createElement(ObjectTitle, {
    frame: frame,
    mode: mode,
    types: types,
    docs: docs,
    expanded: expanded
  }), !expanded && /*#__PURE__*/_react["default"].createElement(ObjectSummary, {
    frame: frame,
    mode: mode,
    types: types,
    docs: docs
  })));
};

exports.ObjectHeader = ObjectHeader;

var ObjectTitle = function ObjectTitle(_ref4) {
  var frame = _ref4.frame,
      mode = _ref4.mode,
      types = _ref4.types,
      docs = _ref4.docs,
      expanded = _ref4.expanded;

  var _useState15 = (0, _react.useState)(frame.subject()),
      _useState16 = _slicedToArray(_useState15, 2),
      oid = _useState16[0],
      setOid = _useState16[1];

  var showid = false;
  var showtype = false;

  var updateID = function updateID(nid) {
    frame.subjid = nid;
    setOid(nid);
  };

  var updateType = function updateType(ntype) {
    frame.cls = ntype;
    setOtype(ntype);
  };

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-object-title"
  }, /*#__PURE__*/_react["default"].createElement(TypeRenderer, {
    frame: frame,
    mode: mode,
    types: types,
    docs: docs
  }), showid && /*#__PURE__*/_react["default"].createElement(IDRenderer, {
    frame: frame,
    mode: mode,
    types: types,
    docs: docs
  }), !expanded && /*#__PURE__*/_react["default"].createElement(ObjectStats, {
    frame: frame,
    mode: mode,
    types: types,
    docs: docs
  }));
};

exports.ObjectTitle = ObjectTitle;

var TypeRenderer = function TypeRenderer(_ref5) {
  var frame = _ref5.frame,
      mode = _ref5.mode,
      types = _ref5.types,
      docs = _ref5.docs;
  var tstruct = (0, _utils.getTypeStruct)(frame.cls, types);
  var desc = "";
  if (tstruct.description) desc += tstruct.description + " ~ ";
  desc += _terminusdbClient["default"].UTILS.unshorten(frame.cls);
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-type-tile",
    title: desc
  }, tstruct.label);
};

exports.TypeRenderer = TypeRenderer;

var IDRenderer = function IDRenderer(_ref6) {
  var frame = _ref6.frame,
      mode = _ref6.mode,
      types = _ref6.types,
      docs = _ref6.docs;

  var onc = function onc(val) {
    if (val.indexOf(":") == -1) val = "doc:" + val;
    frame.subjid = _terminusdbClient["default"].UTILS.unshorten(val);
  };

  var tstruct = (0, _utils.getTypeStruct)(frame.cls, types);

  var val = _terminusdbClient["default"].UTILS.shorten(frame.subjid);

  if (mode == "edit") {
    if (!frame.display_options) frame.display_options = {};
    frame.display_options.placeholder = "Enter " + tstruct.label + " ID";
    frame.display_options.dataviewer = "iri";
  }

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-id-tile"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-icon"
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineIdcard, null)), /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-id-editor"
  }, /*#__PURE__*/_react["default"].createElement(_DatatypeRenderer.DatatypeRenderer, {
    val: val,
    mode: mode,
    options: frame.display_options,
    onChange: onc
  })));
};

exports.IDRenderer = IDRenderer;

var ObjectStats = function ObjectStats(_ref7) {
  var frame = _ref7.frame,
      mode = _ref7.mode,
      types = _ref7.types,
      docs = _ref7.docs;
  var props = Object.keys(frame.properties).length;
  var ptitle = props == 1 ? "Property" : "Properties";
  var vals = 0;

  for (var k in frame.properties) {
    vals += frame.properties[k].values.length;
  }

  var sz = _terminusdbClient["default"].UTILS.TypeHelper.formatBytes(JSON.stringify(frame.extract()).length);

  var vtitle = vals == 1 ? "Value" : "Values";
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-object-stats"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-icon wiki-stats-icon wiki-props-icon",
    title: ptitle
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineUnorderedList, {
    className: "wiki-ricon"
  }), " ", props), /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-icon wiki-stats-icon wiki-values-icon",
    title: vtitle
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineBuild, {
    className: "wiki-ricon"
  }), " ", vals), /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-icon wiki-stats-icon wiki-size-icon",
    title: sz
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiFillBuild, {
    className: "wiki-ricon"
  }), " ", sz));
};

exports.ObjectStats = ObjectStats;

var ObjectSummary = function ObjectSummary(_ref8) {
  var frame = _ref8.frame,
      mode = _ref8.mode,
      view = _ref8.view,
      types = _ref8.types,
      docs = _ref8.docs;

  var _useState17 = (0, _react.useState)(false),
      _useState18 = _slicedToArray(_useState17, 2),
      active = _useState18[0],
      setActive = _useState18[1];

  var toggleActive = function toggleActive() {
    setActive(!active);
  };

  var ps = frame.getProperties("filled");
  var sample1, sample2, s1name, s2name;

  if (ps.length > 0) {
    sample1 = frame.properties[ps[0]].values[0];
    s1name = frame.properties[ps[0]].getLabel();

    if (ps.length > 1) {
      sample2 = frame.properties[ps[1]].values[0];
      s2name = frame.properties[ps[1]].getLabel();
    } else {
      if (frame.properties[ps[0]].values.length > 1) {
        sample2 = frame.properties[ps[0]].values[1];
        s2name = s1name;
      }
    }
  }

  if (!sample1) return null;
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-summary-tiles"
  }, /*#__PURE__*/_react["default"].createElement(SummarySample, {
    label: s1name,
    value: sample1
  }), sample2 && /*#__PURE__*/_react["default"].createElement(SummarySample, {
    label: s2name,
    value: sample2
  }));
};

exports.ObjectSummary = ObjectSummary;

var SummarySample = function SummarySample(_ref9) {
  var label = _ref9.label,
      value = _ref9.value;
  var x = value.get();
  var val = (0, _CellRenderer.shortenedText)(x, 20);
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-summary-sample"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-summary-label"
  }, label, " "), /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-summary-value"
  }, " ", val));
};

exports.SummarySample = SummarySample;

var ObjectStatus = function ObjectStatus(_ref10) {
  var frame = _ref10.frame,
      mode = _ref10.mode;
  var ptitle = frame.status;
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-object-status"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-icon wiki-status-icon",
    title: ptitle
  }, ptitle));
};

exports.ObjectStatus = ObjectStatus;

var ObjectActions = function ObjectActions(_ref11) {
  var frame = _ref11.frame,
      mode = _ref11.mode,
      status = _ref11.status,
      types = _ref11.types,
      docs = _ref11.docs,
      active = _ref11.active;

  var _useState19 = (0, _react.useState)(status == "loading"),
      _useState20 = _slicedToArray(_useState19, 2),
      showMenu = _useState20[0],
      setShowMenu = _useState20[1];

  var toggleMenu = function toggleMenu() {
    if (status != "loading") {
      window.global_popup_lock = !showMenu;
      setShowMenu(!showMenu);
      if ((0, _utils.hasControl)(frame, "setHighlighted")) frame.controls.setHighlighted(!showMenu);
    } else setShowMenu(false);
  };

  var see_actions = active && frame && mode == "edit" && !window.global_popup_lock;
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-left-contents"
  }, active && /*#__PURE__*/_react["default"].createElement(_utils.StatusIndicator, {
    type: "object",
    status: status
  }), see_actions && /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-left-icon",
    onClick: toggleMenu
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineMenu, null)), showMenu && /*#__PURE__*/_react["default"].createElement(ObjectActionMenu, {
    frame: frame,
    toggle: toggleMenu,
    types: types,
    docs: docs
  }));
};

exports.ObjectActions = ObjectActions;

var ObjectActionMenu = function ObjectActionMenu(_ref12) {
  var frame = _ref12.frame,
      toggle = _ref12.toggle,
      types = _ref12.types,
      docs = _ref12.docs;
  var what = frame.getLabel() || type;
  var docname = (0, _utils.getDocLabel)(frame, types, docs);

  var getAction = function getAction(which) {
    return function () {
      (0, _utils.hasControl)(frame, which)();
      toggle();
    };
  };

  return /*#__PURE__*/_react["default"].createElement(_reactOutsideClickHandler["default"], {
    onOutsideClick: toggle
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu"
  }, (0, _utils.hasControl)(frame, 'delete') && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-entry wiki-menu-delete",
    onClick: getAction('delete')
  }, /*#__PURE__*/_react["default"].createElement(_ri.RiDeleteBin5Line, {
    className: "wiki-menu-icon"
  }), " Delete ", docname), (0, _utils.hasControl)(frame, 'duplicate') && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-entry wiki-menu-duplicate",
    onClick: getAction('duplicate')
  }, /*#__PURE__*/_react["default"].createElement(AiOutlineCopy, {
    className: "wiki-menu-icon"
  }), " Clone ", docname), ((0, _utils.hasControl)(frame, 'duplicate') || (0, _utils.hasControl)(frame, 'delete')) && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-spacer"
  }), (0, _utils.hasControl)(frame, 'addValue') && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-entry wiki-menu-add",
    onClick: getAction('addValue')
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlinePlus, {
    className: "wiki-menu-icon"
  }), " Add ", what), /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-spacer"
  })), (0, _utils.hasControl)(frame, 'getViewSelector') && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-selector wiki-menu-addparent"
  }, ViewChooser), /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-spacer"
  })), (0, _utils.hasControl)(frame, 'addProperty') && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-selector wiki-menu-addparent"
  }, getAction('addProperty')(toggle))));
};

exports.ObjectActionMenu = ObjectActionMenu;

var ObjectNavigation = function ObjectNavigation(_ref13) {
  var frame = _ref13.frame,
      mode = _ref13.mode,
      view = _ref13.view,
      types = _ref13.types,
      expanded = _ref13.expanded;
  if (!(frame && frame.controls)) return null;

  var toggle = function toggle() {
    frame.controls.setExpanded(!expanded);
  };

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-right-contents"
  }, expanded && /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-right-icon",
    onClick: toggle
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineDown, null)), !expanded && /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-right-icon",
    onClick: toggle
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineRight, null)));
};

exports.ObjectNavigation = ObjectNavigation;