"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PropertyNavigation = exports.PropertyActionMenu = exports.PropertyActions = exports.PropertyStats = exports.PropertySummarySample = exports.PropertySummary = exports.PropertyTitle = exports.PropertyHeader = exports.PropertyRenderer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactBootstrap = require("react-bootstrap");

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

var _reactTextareaAutosize = _interopRequireDefault(require("react-textarea-autosize"));

var _ai = require("react-icons/ai");

var _ValueRenderer = require("./ValueRenderer");

var _utils = require("./utils");

var _reactOutsideClickHandler = _interopRequireDefault(require("react-outside-click-handler"));

var _ri = require("react-icons/ri");

var _reactSelect = _interopRequireDefault(require("react-select"));

var _CellRenderer = require("../table/CellRenderer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var PropertyRenderer = function PropertyRenderer(_ref) {
  var frame = _ref.frame,
      mode = _ref.mode,
      view = _ref.view,
      types = _ref.types,
      docs = _ref.docs,
      autosave = _ref.autosave,
      onDelete = _ref.onDelete,
      ping = _ref.ping;
  return function (onDelete) {
    if (!frame) return null;

    if (!frame.getLabel) {
      console.log("strange frame", frame);
      return null;
    }

    if (frame.depth() == 0) {
      //displayed in title pane
      if (frame.predicate == _terminusdbClient["default"].UTILS.unshorten("rdfs:label") && frame.values.length == 1) return null;
      if (frame.predicate == _terminusdbClient["default"].UTILS.unshorten("rdfs:comment") && frame.values.length == 1) return null;
    }

    var _useState = (0, _react.useState)(),
        _useState2 = _slicedToArray(_useState, 2),
        redraw = _useState2[0],
        setRedraw = _useState2[1];

    var _useState3 = (0, _react.useState)(),
        _useState4 = _slicedToArray(_useState3, 2),
        rvals = _useState4[0],
        setRvals = _useState4[1];

    var _useState5 = (0, _react.useState)(getInitialFrameExpansion(frame, view, types, docs)),
        _useState6 = _slicedToArray(_useState5, 2),
        expansion = _useState6[0],
        setExpansion = _useState6[1];

    var _useState7 = (0, _react.useState)(false),
        _useState8 = _slicedToArray(_useState7, 2),
        active = _useState8[0],
        setActive = _useState8[1];

    var toggleActive = function toggleActive() {
      return setActive(!active);
    };

    var activeOn = function activeOn() {
      return setActive(true);
    };

    var activeOff = function activeOff() {
      return setActive(false);
    };

    var _useState9 = (0, _react.useState)(),
        _useState10 = _slicedToArray(_useState9, 2),
        highlighted = _useState10[0],
        setHighlighted = _useState10[1];

    var _useState11 = (0, _react.useState)(),
        _useState12 = _slicedToArray(_useState11, 2),
        vrows = _useState12[0],
        setVRows = _useState12[1];

    function addValue() {
      frame.addValueFrame(frame.createEmpty());
      setRvals(getPvals());
      setRedraw(redraw + 1);
    }

    function onDelete() {
      setRvals(getPvals());
      setRedraw(redraw + 1);
    }

    (0, _react.useEffect)(function () {
      if (rvals) {
        var rows = [];

        for (var i = 0; i < rvals.length; i++) {
          if (!((frame.predicate == _terminusdbClient["default"].UTILS.unshorten("rdfs:label") || frame.predicate == _terminusdbClient["default"].UTILS.unshorten("rdfs:comment")) && i == 0)) {
            var vframe = rvals[i];
            addControlsToValueFrame(frame, vframe);
            rows.push( /*#__PURE__*/_react["default"].createElement(_ValueRenderer.ValueRenderer, {
              redraw: redraw,
              index: i,
              expansion: expansion,
              key: frame.predicate + "_" + i,
              types: types,
              docs: docs,
              frame: vframe,
              mode: mode,
              onDelete: onDelete,
              autosave: autosave
            }));
          }
        }

        setVRows(rows);
      }
    }, [rvals]);
    (0, _react.useEffect)(function () {
      return setRvals(getPvals());
    }, [frame, mode]);
    (0, _react.useEffect)(function () {
      if (frame) {
        if (!frame.controls) {
          frame.controls = {};
        }

        (0, _utils.addFrameControl)(frame, "expanded", expansion);
        (0, _utils.addFrameControl)(frame, "setExpanded", setExpansion);

        if (autosave && autosave["delete"]) {
          var delprop = function delprop() {
            autosave["delete"](frame, "Document deleted with wiki console").then(function (r) {
              frame.status = "deleted";
              frame.parent.removeProperty(frame.predicate);
              if (onDelete) onDelete();
            })["catch"](function (e) {
              frame.status = "error";
              setStatus(frame.status);
              console.log(e);
            });
          };

          (0, _utils.addFrameControl)(frame, "delete", delprop);
        }

        if (autosave && autosave.save) {
          var upddoc = function upddoc() {
            autosave.save(frame, "Document updated with wiki console").then(function (r) {
              frame.status = "success";
            })["catch"](function (e) {
              frame.status = "error";
              setStatus(frame.status);
              console.log(e);
            });
          };

          (0, _utils.addFrameControl)(frame, "update", upddoc);
        }

        (0, _utils.addFrameControl)(frame, "addValue", addValue);
        (0, _utils.addFrameControl)(frame, "highlighted", highlighted);
        (0, _utils.addFrameControl)(frame, "setHighlighted", setHighlighted);
      }
    }, [frame]);
    if (!rvals || !rvals.length) return null;

    var toggleExpanded = function toggleExpanded() {
      if (expansion == 'compressed') {
        setExpansion(getInitialFrameExpansion(frame, view, types, docs));
      } else {
        setExpansion('compressed');
      }
    };

    var deleteValue = function deleteValue(val, index) {
      frame.removeValue(val);
      setRvals(getPvals());
      setRedraw(redraw + 1);
    };

    function getPvals() {
      var vals = [];

      var isDup = function isDup(val) {
        if (vals.indexOf(val) == -1) {
          vals.push(val);
          return false;
        }

        return true;
      };

      var rvals = [];

      for (var i = 0; i < frame.values.length; i++) {
        if (!isDup(frame.values[i].get())) {
          rvals.push(frame.values[i]);
        }
      }

      return rvals;
    }

    function addControlsToValueFrame(frame, vframe) {
      if (!frame.controls) return;
      if (!vframe.controls) vframe.controls = {};
      if (frame.controls.addProperty) vframe.controls.addProperty = frame.controls.addProperty;
      if (frame.controls.addValue) vframe.controls.addValue = frame.controls.addValue;
    }

    var wrapper_class = highlighted ? "wiki-property-highlighted" : active ? "wiki-property-selected" : "";
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "wiki-property-wrapper " + wrapper_class,
      onMouseEnter: activeOn,
      onMouseLeave: activeOff
    }, /*#__PURE__*/_react["default"].createElement(PropertyHeader, {
      toggleExpanded: toggleExpanded,
      active: active,
      expansion: expansion,
      frame: frame,
      mode: mode,
      types: types,
      docs: docs
    }), expansion != "compressed" && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, vrows));
  }(onDelete);
};

exports.PropertyRenderer = PropertyRenderer;

function getInitialFrameExpansion(frame, view, types, docs) {
  if (!frame) return "list";
  var longs = ["xdd:json", "xdd:html", "xdd:coordinatePolyline", "xdd:coordinatePolygon"];
  var t = frame.range();

  if (frame.display_options && typeof frame.display_options.collapse != "undefined") {
    if (frame.display_options.collapse) return "compressed";
    return "list";
  }

  if (frame.isObject()) return "list";

  if (frame.values.length > 1) {
    if (frame.display_options && typeof frame.display_options.args != "undefined") {
      if (frame.display_options && frame.display_options.args['block']) return "block-list";
    }

    if (longs.indexOf(_terminusdbClient["default"].UTILS.shorten(t)) != -1) return "block-list";
    return "list";
  } else {
    if (frame.display_options && typeof frame.display_options.args != "undefined") {
      if (frame.display_options.args['block']) return "block";
    } //if(longs.indexOf(TerminusClient.UTILS.shorten(t)) == -1) return "compressed"


    return "block";
  }
}

var PropertyHeader = function PropertyHeader(_ref2) {
  var frame = _ref2.frame,
      mode = _ref2.mode,
      types = _ref2.types,
      docs = _ref2.docs,
      active = _ref2.active,
      expansion = _ref2.expansion,
      index = _ref2.index;

  var _useState13 = (0, _react.useState)(false),
      _useState14 = _slicedToArray(_useState13, 2),
      localActive = _useState14[0],
      setActive = _useState14[1];

  var activate = function activate() {
    return setActive(true);
  };

  var deactivate = function deactivate() {
    return setActive(false);
  };

  var menus = /*#__PURE__*/_react["default"].createElement(PropertyActions, {
    frame: frame,
    mode: mode,
    types: types,
    docs: docs,
    active: localActive
  });

  var navigation = /*#__PURE__*/_react["default"].createElement(PropertyNavigation, {
    frame: frame,
    mode: mode,
    types: types,
    docs: docs,
    active: active
  });

  var tindex = expansion == "block-list" ? index ? index + 1 : 1 : false;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-property-header",
    onMouseEnter: activate,
    onMouseLeave: deactivate
  }, /*#__PURE__*/_react["default"].createElement(_utils.WikiRow, {
    menus: menus,
    navigation: navigation,
    active: active,
    index: tindex,
    type: "property"
  }, /*#__PURE__*/_react["default"].createElement(PropertyTitle, {
    frame: frame,
    mode: mode,
    expansion: expansion,
    types: types,
    docs: docs,
    index: tindex
  }), expansion == "compressed" && /*#__PURE__*/_react["default"].createElement(PropertySummary, {
    frame: frame,
    mode: mode,
    expansion: expansion,
    types: types,
    docs: docs
  })));
};

exports.PropertyHeader = PropertyHeader;

var PropertyTitle = function PropertyTitle(_ref3) {
  var frame = _ref3.frame,
      mode = _ref3.mode,
      types = _ref3.types,
      docs = _ref3.docs,
      expansion = _ref3.expansion,
      index = _ref3.index;
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-property-title"
  }, getHeaderTag(frame, expansion, index));
};

exports.PropertyTitle = PropertyTitle;

var getHeaderTag = function getHeaderTag(frame, compressed, index) {
  var l = frame.depth() + 2;
  var cname = frame.isObject() || frame.isClassChoice() ? "wiki-property-header wiki-propery-header-" + l : "wiki-property-label wiki-propery-label-" + l;
  var lab = frame.getLabel();

  var p = _terminusdbClient["default"].UTILS.shorten(frame.predicate);

  if (frame.depth() == 0 && (p == "rdfs:label" || p == "rdfs:comment")) {
    lab = "Alternative " + lab;
  }

  if (index) lab += " (" + index + ")";
  var tit = p + " " + (frame.getComment() || "");
  if (compressed) return /*#__PURE__*/_react["default"].createElement("span", {
    title: tit,
    className: cname
  }, lab);
  return /*#__PURE__*/_react["default"].createElement("div", {
    title: tit,
    className: cname
  }, lab);
};

var PropertySummary = function PropertySummary(_ref4) {
  var frame = _ref4.frame,
      mode = _ref4.mode,
      view = _ref4.view,
      types = _ref4.types,
      docs = _ref4.docs,
      toggleExpanded = _ref4.toggleExpanded;

  var _useState15 = (0, _react.useState)(false),
      _useState16 = _slicedToArray(_useState15, 2),
      active = _useState16[0],
      setActive = _useState16[1];

  var toggleActive = function toggleActive() {
    setActive(!active);
  };

  var sname = frame.getLabel();
  var sample1, sample2;

  if (frame.values.length > 0) {
    sample1 = frame.values[0];

    if (frame.values.length > 1) {
      sample2 = frame.values[1];
    }
  }

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-property-summary"
  }, /*#__PURE__*/_react["default"].createElement(PropertyStats, {
    frame: frame,
    mode: mode,
    types: types,
    docs: docs
  }), /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-property-summary-tiles"
  }, /*#__PURE__*/_react["default"].createElement(PropertySummarySample, {
    label: sname,
    value: sample1,
    value2: sample2
  })));
};

exports.PropertySummary = PropertySummary;

var PropertySummarySample = function PropertySummarySample(_ref5) {
  var label = _ref5.label,
      value = _ref5.value,
      value2 = _ref5.value2;
  var x = value.get();
  var val = x ? (0, _CellRenderer.shortenedText)(x, 20) : "";

  if (value2) {
    x = value2.get();
    if (x) val += ", " + (0, _CellRenderer.shortenedText)(x, 20);
  }

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-summary-sample"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-summary-label"
  }, label, " "), /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-summary-value"
  }, " ", val));
};

exports.PropertySummarySample = PropertySummarySample;

var PropertyStats = function PropertyStats(_ref6) {
  var frame = _ref6.frame,
      mode = _ref6.mode,
      types = _ref6.types,
      docs = _ref6.docs;
  var vals = frame.values.length;

  var sz = _terminusdbClient["default"].UTILS.TypeHelper.formatBytes(JSON.stringify(frame.extract()).length);

  var vtitle = vals == 1 ? "Value" : "Values";
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-property-stats"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-icon wiki-stats-icon wiki-values-icon",
    title: vtitle
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineBuild, {
    className: "wiki-ricon"
  }), " ", vals), /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-icon wiki-stats-icon wiki-size-icon",
    title: sz
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiFillBuild, {
    className: "wiki-ricon"
  }), " ", sz));
};

exports.PropertyStats = PropertyStats;

var PropertyActions = function PropertyActions(_ref7) {
  var frame = _ref7.frame,
      mode = _ref7.mode,
      status = _ref7.status,
      types = _ref7.types,
      docs = _ref7.docs,
      active = _ref7.active;

  var _useState17 = (0, _react.useState)(status == "loading"),
      _useState18 = _slicedToArray(_useState17, 2),
      showMenu = _useState18[0],
      setShowMenu = _useState18[1];

  var toggleMenu = function toggleMenu() {
    if (status != "loading") {
      window.global_popup_lock = !showMenu;
      setShowMenu(!showMenu);
      if ((0, _utils.hasControl)(frame, "setHighlighted")) frame.controls.setHighlighted(!showMenu);
    } else setShowMenu(false);
  };

  var addEntry = function addEntry() {
    if (frame.controls && frame.controls.addValue) {
      frame.controls.addValue();
    }
  };

  var see_actions = active && frame && mode == "edit" && !window.global_popup_lock;
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-left-contents"
  }, active && /*#__PURE__*/_react["default"].createElement(_utils.StatusIndicator, {
    type: "object",
    status: status
  }), see_actions && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-left-icon",
    onClick: toggleMenu
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineMenu, null)), /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-left-icon",
    onClick: addEntry
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlinePlus, null))), showMenu && /*#__PURE__*/_react["default"].createElement(PropertyActionMenu, {
    frame: frame,
    toggle: toggleMenu,
    types: types,
    docs: docs
  }));
};

exports.PropertyActions = PropertyActions;

var PropertyActionMenu = function PropertyActionMenu(_ref8) {
  var frame = _ref8.frame,
      toggle = _ref8.toggle,
      types = _ref8.types,
      docs = _ref8.docs;
  var what = frame.getLabel();

  var getAction = function getAction(which) {
    return function () {
      (0, _utils.hasControl)(frame, which)();
      toggle();
    };
  };

  return /*#__PURE__*/_react["default"].createElement(_reactOutsideClickHandler["default"], {
    onOutsideClick: toggle
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu"
  }, (0, _utils.hasControl)(frame, 'addValue') && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-entry wiki-menu-add",
    onClick: getAction('addValue')
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlinePlus, {
    className: "wiki-menu-icon"
  }), " Add ", what, " value"), /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-spacer"
  })), (0, _utils.hasControl)(frame, 'delete') && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-entry wiki-menu-delete",
    onClick: getAction('delete')
  }, /*#__PURE__*/_react["default"].createElement(_ri.RiDeleteBin5Line, {
    className: "wiki-menu-icon"
  }), " Delete all ", what, " values"), ((0, _utils.hasControl)(frame, 'addValue') || (0, _utils.hasControl)(frame, 'delete')) && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-spacer"
  }), (0, _utils.hasControl)(frame, 'getViewSelector') && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-selector wiki-menu-addparent"
  }, ViewChooser), /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-spacer"
  })), (0, _utils.hasControl)(frame, 'addProperty') && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-selector wiki-menu-addparent"
  }, (0, _utils.hasControl)(frame, 'addProperty')(toggle))));
};

exports.PropertyActionMenu = PropertyActionMenu;

var PropertyNavigation = function PropertyNavigation(_ref9) {
  var frame = _ref9.frame,
      expansion = _ref9.expansion;
  if (!(frame && frame.controls)) return null;

  var toggle = function toggle() {
    if (frame.controls.setCompressed) {
      if (expansion != "compressed") {
        frame.controls.setCompressed("compressed");
      } else {
        frame.controls.setCompressed("block");
      }
    }
  };

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-right-contents"
  }, expansion != "compressed" && /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-right-icon",
    onClick: toggle
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineDown, null)), expansion == "compressed" && /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-right-icon",
    onClick: toggle
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineRight, null)));
};

exports.PropertyNavigation = PropertyNavigation;