"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ValueNavigation = exports.ValueActionsMenu = exports.ValueActions = exports.ValueRenderer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactBootstrap = require("react-bootstrap");

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

var _reactTextareaAutosize = _interopRequireDefault(require("react-textarea-autosize"));

var _ai = require("react-icons/ai");

var _PropertyRenderer = require("./PropertyRenderer");

var _DatatypeRenderer = require("./DatatypeRenderer");

var _ChoiceRenderer = require("./ChoiceRenderer");

var _DocumentRenderer = require("./DocumentRenderer");

var _ObjectRenderer = require("./ObjectRenderer");

var _reactOutsideClickHandler = _interopRequireDefault(require("react-outside-click-handler"));

var _ri = require("react-icons/ri");

var _reactSelect = _interopRequireDefault(require("react-select"));

var _utils = require("./utils");

var _CellRenderer = require("../table/CellRenderer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ValueRenderer = function ValueRenderer(_ref) {
  var expansion = _ref.expansion,
      redraw = _ref.redraw,
      index = _ref.index,
      frame = _ref.frame,
      mode = _ref.mode,
      types = _ref.types,
      docs = _ref.docs,
      autosave = _ref.autosave,
      onDelete = _ref.onDelete;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      active = _useState2[0],
      setActive = _useState2[1];

  var _useState3 = (0, _react.useState)(frame.status),
      _useState4 = _slicedToArray(_useState3, 2),
      status = _useState4[0],
      setStatus = _useState4[1];

  var toggleActive = function toggleActive() {
    return setActive(!active);
  };

  var activeOn = function activeOn() {
    return setActive(true);
  };

  var activeOff = function activeOff() {
    return setActive(false);
  };

  var _useState5 = (0, _react.useState)(),
      _useState6 = _slicedToArray(_useState5, 2),
      highlighted = _useState6[0],
      setHighlighted = _useState6[1];

  (0, _react.useEffect)(function () {
    if (frame) {
      if (!frame.controls) {
        frame.controls = {};
      }

      if (!frame.controls.expanded) {//addFrameControl(frame, "expanded",expansion)
      }

      if (!frame.controls.setExpanded) {//addFrameControl(frame, "setExpanded", setExpansion)
      }

      if (autosave && autosave["delete"]) {
        var delval = function delval() {
          autosave["delete"](frame, "Document deleted with wiki console").then(function (r) {
            frame.parent.removeValue(frame.get(), frame.index);
            frame.status = "deleted";
            if (onDelete) onDelete();
          })["catch"](function (e) {
            frame.status = "error";
            setStatus(frame.status);
            console.log(e);
          });
        };

        (0, _utils.addFrameControl)(frame, "delete", delval);
      }

      if (autosave && autosave.save && !frame.controls.save) {
        var _updval = function _updval(v, t, l) {
          setStatus("loading");
          autosave.save(frame, "Value updated on console wiki", v, t, l).then(function (r) {
            frame.status = "success";
            frame.set(v);
            if (t) frame.range = t;
            if (l) frame.language = l;
            setStatus(frame.status);
            setTimeout(function () {
              if (frame.status == "success") {
                frame.status = "ok";
                setStatus(frame.status);
              }
            }, 300);
          })["catch"](function (e) {
            frame.status = "error";
            setStatus(frame.status);
            console.log(e);
          });
        };

        (0, _utils.addFrameControl)(frame, "update", _updval);
      }

      (0, _utils.addFrameControl)(frame, "highlighted", highlighted);
      (0, _utils.addFrameControl)(frame, "setHighlighted", setHighlighted);
    }
  }, [frame]);

  var updval = function updval(v, t, l) {
    frame.controls.update(v, t, l);
  };

  var ret = null;

  if (frame.isObject()) {
    return /*#__PURE__*/_react["default"].createElement(_ObjectRenderer.ObjectRenderer, {
      ping: redraw,
      index: index,
      expansion: expansion,
      frame: frame,
      mode: mode,
      types: types,
      docs: docs,
      autosave: autosave
    });
  } else if (frame.isChoice()) {
    ret = /*#__PURE__*/_react["default"].createElement(_ChoiceRenderer.ChoiceRenderer, {
      redraw: redraw,
      expansion: expansion,
      onChange: updval,
      index: index,
      val: frame.get(),
      frame: frame,
      mode: mode,
      types: types,
      docs: docs
    });
  } else if (frame.isDocument()) {
    ret = /*#__PURE__*/_react["default"].createElement(_DocumentRenderer.DocumentRenderer, {
      redraw: redraw,
      expansion: "tile",
      index: index,
      val: frame.get(),
      frame: frame,
      mode: mode,
      onChange: updval,
      types: types,
      docs: docs
    });
  } else if (frame.isData()) {
    ret = /*#__PURE__*/_react["default"].createElement(_DatatypeRenderer.DatatypeFrameRenderer, {
      redraw: redraw,
      expansion: expansion,
      frame: frame,
      mode: mode,
      types: types,
      docs: docs
    });
  } else {
    alert("Frame has no known type");
    ret = /*#__PURE__*/_react["default"].createElement("span", null, "no frame");
    console.log(frame);
  }

  var menus = /*#__PURE__*/_react["default"].createElement(ValueActions, {
    frame: frame,
    mode: mode,
    types: types,
    docs: docs,
    active: active
  });

  var navigation = /*#__PURE__*/_react["default"].createElement(ValueNavigation, {
    frame: frame,
    mode: mode,
    types: types,
    docs: docs,
    active: active
  });

  var tindex = expansion != "block-list" && expansion != "block" ? index ? index + 1 : 1 : false;

  if (expansion && expansion == "block-list" && index > 0) {
    return /*#__PURE__*/_react["default"].createElement("span", {
      className: "property-block"
    }, /*#__PURE__*/_react["default"].createElement(_PropertyRenderer.PropertyHeader, {
      index: index,
      expansion: expansion,
      frame: frame,
      mode: mode,
      view: view,
      types: types,
      docs: docs
    }), ret);
  }

  var row = /*#__PURE__*/_react["default"].createElement(_utils.WikiRow, {
    menus: menus,
    navigation: navigation,
    active: active,
    index: tindex,
    type: "value"
  }, /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, ret));

  var wrapper_class = highlighted ? "wiki-value-highlighted" : active ? "wiki-value-selected" : frame.status == "new" ? "wiki-value-new" : "";

  if (expansion == "compressed") {
    return /*#__PURE__*/_react["default"].createElement("span", {
      className: "wiki-value-wrapper " + wrapper_class,
      onMouseEnter: activeOn,
      onMouseLeave: activeOff
    }, row);
  }

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-value-wrapper " + wrapper_class,
    onMouseEnter: activeOn,
    onMouseLeave: activeOff
  }, row);
};

exports.ValueRenderer = ValueRenderer;

var ValueActions = function ValueActions(_ref2) {
  var frame = _ref2.frame,
      mode = _ref2.mode,
      status = _ref2.status,
      types = _ref2.types,
      docs = _ref2.docs,
      active = _ref2.active;

  var _useState7 = (0, _react.useState)(status == "loading"),
      _useState8 = _slicedToArray(_useState7, 2),
      showMenu = _useState8[0],
      setShowMenu = _useState8[1];

  var toggleMenu = function toggleMenu() {
    if (status != "loading") {
      window.global_popup_lock = !showMenu;
      setShowMenu(!showMenu);
      if ((0, _utils.hasControl)(frame, "setHighlighted")) frame.controls.setHighlighted(!showMenu);
    } else setShowMenu(false);
  };

  var addEntry = function addEntry() {
    if (frame.controls && frame.controls.addValue) {
      frame.controls.addValue();
    }
  };

  var see_actions = active && frame && mode == "edit" && !window.global_popup_lock;
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-left-contents"
  }, active && /*#__PURE__*/_react["default"].createElement(_utils.StatusIndicator, {
    type: "object",
    status: status
  }), see_actions && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-left-icon",
    onClick: toggleMenu
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineMenu, null)), /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-left-icon",
    onClick: addEntry
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlinePlus, null))), showMenu && frame && /*#__PURE__*/_react["default"].createElement(ValueActionsMenu, {
    frame: frame,
    toggle: toggleMenu,
    types: types,
    docs: docs
  }));
};

exports.ValueActions = ValueActions;

var ValueActionsMenu = function ValueActionsMenu(_ref3) {
  var frame = _ref3.frame,
      toggle = _ref3.toggle,
      types = _ref3.types,
      docs = _ref3.docs;
  var what = frame.parent.getLabel();

  var getAction = function getAction(which) {
    return function () {
      (0, _utils.hasControl)(frame, which)();
      toggle();
    };
  };

  var ting = (0, _CellRenderer.shortenedText)(frame.get(), 12);
  return /*#__PURE__*/_react["default"].createElement(_reactOutsideClickHandler["default"], {
    onOutsideClick: toggle
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu"
  }, (0, _utils.hasControl)(frame, 'delete') && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-entry wiki-menu-delete",
    onClick: getAction('delete')
  }, /*#__PURE__*/_react["default"].createElement(_ri.RiDeleteBin5Line, {
    className: "wiki-menu-icon"
  }), " Delete ", ting), (0, _utils.hasControl)(frame, 'duplicate') && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-entry wiki-menu-duplicate",
    onClick: getAction('duplicate')
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineCopy, {
    className: "wiki-menu-icon"
  }), " Clone ", ting), ((0, _utils.hasControl)(frame, 'duplicate') || (0, _utils.hasControl)(frame, 'delete')) && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-spacer"
  }), (0, _utils.hasControl)(frame, 'addValue') && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-entry wiki-menu-add",
    onClick: getAction('addValue')
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlinePlus, {
    className: "wiki-menu-icon"
  }), " Add ", what), /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-spacer"
  })), (0, _utils.hasControl)(frame, 'getViewSelector') && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-selector wiki-menu-addparent"
  }, ViewChooser), /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-spacer"
  })), (0, _utils.hasControl)(frame, 'addProperty') && /*#__PURE__*/_react["default"].createElement("div", {
    className: "wiki-menu-selector wiki-menu-addparent"
  }, getAction('addProperty')(toggle))));
};

exports.ValueActionsMenu = ValueActionsMenu;

var ValueNavigation = function ValueNavigation(_ref4) {
  var frame = _ref4.frame,
      onCollapse = _ref4.onCollapse,
      expansion = _ref4.expansion;
  if (!(frame && frame.controls)) return null;

  var toggle = function toggle() {
    onCollapse();

    if (frame.controls.setCompressed) {
      if (expansion != "compressed") {
        frame.controls.setCompressed("compressed");
      } else {
        frame.controls.setCompressed("block");
      }
    }
  };

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-right-contents"
  }, expansion != "compressed" && /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-right-icon",
    onClick: toggle
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineDown, null)), expansion == "compressed" && /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-right-icon",
    onClick: toggle
  }, /*#__PURE__*/_react["default"].createElement(AiOutlineRight, null)));
};

exports.ValueNavigation = ValueNavigation;