"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTypeStruct = getTypeStruct;
exports.getDocStruct = getDocStruct;
exports.getDocLabel = getDocLabel;
exports.getDocIDLabel = getDocIDLabel;
exports.addFrameControl = addFrameControl;
exports.getMissingPropertySelector = getMissingPropertySelector;
exports.getFilledPropertySelector = getFilledPropertySelector;
exports.hasControl = hasControl;
exports.WikiRow = exports.FrameErrors = exports.StatusIndicator = exports.FrameError = void 0;

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

var _react = _interopRequireWildcard(require("react"));

var _reactBootstrap = require("react-bootstrap");

var _reactSelect = _interopRequireDefault(require("react-select"));

var _ai = require("react-icons/ai");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

//replace
function getTypeStruct(type, types) {
  type = _terminusdbClient["default"].UTILS.unshorten(type);
  var rec = false;

  if (types) {
    rec = types[type] || types[_terminusdbClient["default"].UTILS.shorten(type)];
  }

  var meta = {};
  meta.id = _terminusdbClient["default"].UTILS.shorten(type);

  if (rec) {
    meta.label = rec && rec['Class Name'] ? rec['Class Name']["@value"] : meta.id;
    meta.comment = rec && rec['Description'] ? rec['Description']["@value"] : "";
  } else {
    meta.label = _terminusdbClient["default"].UTILS.labelFromURL(type);
    meta.comment = "";
  }

  return meta;
}

function getDocStruct(docid, docs) {
  docid = _terminusdbClient["default"].UTILS.unshorten(docid);
  if (!docs) return false;

  var rec = docs[docid] || docs[_terminusdbClient["default"].UTILS.shorten(docid)];

  if (!rec) return false;
  var meta = {};
  meta.id = _terminusdbClient["default"].UTILS.shorten(docid);

  if (rec && rec['Name'] && rec['Name']["@value"]) {
    meta.label = rec['Name']["@value"];
  }

  if (rec && rec['Description'] && rec['Description']["@value"]) {
    meta.comment = rec['Description']["@value"];
  }

  return meta;
}

function getDocLabel(frame, types, docs) {
  var tstruct = getTypeStruct(frame.cls, types);
  var lab = tstruct.label;
  var docstruct = getDocStruct(frame.subjid, docs);

  if (docstruct && docstruct.label) {
    lab = docstruct.label;
  } else {
    var dlab = frame.first ? frame.first("rdfs:label") : false;

    if (dlab) {
      lab = dlab;
    }
  }

  return lab;
}

function getDocIDLabel(val, docs) {
  var lab = val;
  var docstruct = getDocStruct(val, docs);

  if (docstruct && docstruct.label) {
    lab = docstruct.label;
  }

  return lab;
}

function addFrameControl(frame, cname, func) {
  if (!frame.controls) frame.controls = {};
  frame.controls[cname] = func;
}

var FrameError = function FrameError(_ref) {
  var error = _ref.error;
  var msg = error && error['vio:message'] ? error['vio:message']["@value"] : error && error['api:message'] ? error['api:message'] : "Error with field";
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-error-contents"
  }, msg);
};

exports.FrameError = FrameError;

var StatusIndicator = function StatusIndicator(_ref2) {
  var type = _ref2.type,
      status = _ref2.status;
  //if(!status) return null
  var sname = status || "ok";
  if (sname == "ok") return null;
  var cname = "wiki-status-" + sname;
  return /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineSave, {
    title: sname,
    className: 'wiki-status-icon ' + cname
  });
};

exports.StatusIndicator = StatusIndicator;

var FrameErrors = function FrameErrors(_ref3) {
  var frame = _ref3.frame,
      view = _ref3.view;

  if (!frame.errors) {
    return null;
  }

  var fes = [];

  for (var i = 0; i < frame.errors.length; i++) {
    fes.push( /*#__PURE__*/_react["default"].createElement(FrameError, {
      error: frame.errors[i]
    }));
  }

  return /*#__PURE__*/_react["default"].createElement("span", null, fes);
};

exports.FrameErrors = FrameErrors;

var WikiRow = function WikiRow(_ref4) {
  var menus = _ref4.menus,
      navigation = _ref4.navigation,
      active = _ref4.active,
      type = _ref4.type,
      index = _ref4.index,
      children = _ref4.children;
  var cname = type ? "wiki-" + type + "-row" : "wiki-value-row";
  return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, {
    className: "wiki-row " + cname
  }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
    className: "wiki-action-column " + cname + "-actions",
    md: 1
  }, menus), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
    className: "wiki-main-column",
    md: 10
  }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, {
    className: "wiki-main-column-inner"
  }, index && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
    className: "wiki-index-col"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-index wiki-data-index"
  }, index)), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
    className: "wiki-content-col"
  }, children))), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
    className: "wiki-navigation-column",
    md: 1
  }, active && /*#__PURE__*/_react["default"].createElement("span", {
    className: "wiki-right-contents"
  }, navigation)));
};

exports.WikiRow = WikiRow;

function getMissingPropertySelector(frame, onSelect, text) {
  text = text || "Add Property";

  var onAddProp = function onAddProp(e) {
    onSelect(e.value);
  };

  var mpl = frame.getMissingPropertyList();

  if (Object.keys(mpl).length) {
    return /*#__PURE__*/_react["default"].createElement("span", {
      className: "wiki-property-selector"
    }, /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], {
      onChange: onAddProp,
      options: mpl,
      placeholder: text
    }));
  }

  return null;
}

function getFilledPropertySelector(frame, onSelect, text) {
  text = text || "Go to Property";

  var onAddProp = function onAddProp(e) {
    onSelect(e.value);
  };

  var mpl = frame.getMissingPropertyList();

  if (Object.keys(mpl).length) {
    return /*#__PURE__*/_react["default"].createElement("span", {
      className: "wiki-property-selector"
    }, /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], {
      onChange: onAddProp,
      options: mpl,
      placeholder: text
    }));
  }

  return null;
}

function hasControl(frame, cname) {
  return frame.controls && frame.controls[cname];
}