"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Accordion = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _fa = require("react-icons/fa");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var Accordion = function Accordion(props) {
  var _useState = (0, _react.useState)(props.showBody || false),
      _useState2 = _slicedToArray(_useState, 2),
      showBody = _useState2[0],
      setShowBody = _useState2[1];

  var openBody = function openBody() {
    setShowBody(!showBody);
  };

  var itemClassName = "tdb__accordion ".concat(props.className);
  var arrowClassName = "tdb__accordion__arrow ".concat(props.arrowClassName);
  var bodyClassName = !showBody || props.isDisabled === true ? "tdb__accordion__body tdb__accordion__body--hidden" : "tdb__accordion__body";
  var openIconClass = showBody ? /*#__PURE__*/_react["default"].createElement(_fa.FaCaretUp, {
    className: arrowClassName
  }) : /*#__PURE__*/_react["default"].createElement(_fa.FaCaretDown, {
    className: arrowClassName
  });
  var titleClassName = "tdb__accordion__head ".concat(props.titleClassName);
  var tooltip = props.tooltip ? {
    title: props.tooltip
  } : {};
  var onClick = props.isDisabled === true ? {
    style: {
      color: '#e0e0e0'
    }
  } : {
    onClick: openBody
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: itemClassName
  }, /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: titleClassName
  }, onClick, tooltip), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__accordion__title"
  }, props.leftIconClassName && /*#__PURE__*/_react["default"].createElement("i", {
    className: "tdb__accordion__icon ".concat(props.leftIconClassName)
  }), /*#__PURE__*/_react["default"].createElement("div", null, props.title)), openIconClass), /*#__PURE__*/_react["default"].createElement("div", {
    className: bodyClassName
  }, props.children));
}; // <span className={openIconClass} role="presentation"></span> 


exports.Accordion = Accordion;
Accordion.propTypes = {
  className: _propTypes["default"].string,
  arrowClassName: _propTypes["default"].string,
  titleClassName: _propTypes["default"].string,
  title: _propTypes["default"].string,
  leftIconClassName: _propTypes["default"].string
};
Accordion.defaultProps = {
  title: 'title',
  className: '',
  arrowClassName: '',
  titleClassName: '',
  leftIconClassName: ''
};