"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Dropdown = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactOutsideClickHandler = _interopRequireDefault(require("react-outside-click-handler"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _fa = require("react-icons/fa");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var Dropdown = function Dropdown(_ref) {
  var className = _ref.className,
      children = _ref.children,
      title = _ref.title,
      isOpen = _ref.isOpen,
      toggle = _ref.toggle,
      mouseOverActive = _ref.mouseOverActive,
      onClickAction = _ref.onClickAction;

  var onOutsideClick = function onOutsideClick() {
    if (isOpen === true) {
      toggle(false);
    }
  };

  var onMouseEnter = function onMouseEnter() {
    toggle(true);
  };

  var onMouseLeave = function onMouseLeave() {
    toggle(false);
  };

  var onClick = function onClick() {
    toggle(!isOpen);
    if (onClickAction) onClickAction();
  };

  var mouseOver = mouseOverActive === true ? {
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave
  } : {};
  var dropdownContent = isOpen === true ? "tdb__dropdown__content  tdb__dropdown__content--show" : "tdb__dropdown__content tdb__dropdown__content--hide";
  return /*#__PURE__*/_react["default"].createElement(_reactOutsideClickHandler["default"], {
    onOutsideClick: onOutsideClick
  }, /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: "tdb__dropdown"
  }, mouseOver), /*#__PURE__*/_react["default"].createElement("button", {
    onClick: onClick,
    className: "tdb__dropdown__button tdb__dropdown__button--top ".concat(className)
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "tdb__dropdown__title"
  }, title), /*#__PURE__*/_react["default"].createElement(_fa.FaCaretDown, null)), /*#__PURE__*/_react["default"].createElement("div", {
    className: dropdownContent
  }, children)));
};

exports.Dropdown = Dropdown;
Dropdown.propTypes = {
  className: _propTypes["default"].string,
  title: _propTypes["default"].string,
  isOpen: _propTypes["default"].bool.isRequired,
  toggle: _propTypes["default"].func.isRequired
};
Dropdown.defaultProps = {
  className: '',
  title: "Select"
};