"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CodeEditor = exports.CodeViewer = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactCodemirror = require("react-codemirror2");

var _constants = require("./constants.querypane");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

require('codemirror/lib/codemirror.css');

require('codemirror/theme/mdn-like.css');

require('codemirror/mode/javascript/javascript.js');

require('codemirror/mode/python/python.js');

var CodeViewer = function CodeViewer(_ref) {
  var text = _ref.text,
      language = _ref.language;
  var cmoptions = _constants.EDITOR_READ_OPTIONS;
  cmoptions.language = getCMLanguage(language);

  if (language == "json") {
    cmoptions['json'] = true;
    cmoptions['jsonld'] = true;
  }

  return /*#__PURE__*/_react["default"].createElement(_reactCodemirror.UnControlled, {
    value: text,
    options: cmoptions,
    className: "readOnly"
  });
};

exports.CodeViewer = CodeViewer;

var CodeEditor = function CodeEditor(_ref2) {
  var text = _ref2.text,
      language = _ref2.language,
      _onChange = _ref2.onChange,
      _onBlur = _ref2.onBlur;

  function getThemeForEditor(lang) {
    return "mdn-like";
  }

  var cmoptions = _constants.EDITOR_WRITE_OPTIONS;
  cmoptions.language = getCMLanguage(language);

  if (language == "json") {
    cmoptions['json'] = true;
    cmoptions['jsonld'] = true;
  }

  return /*#__PURE__*/_react["default"].createElement(_reactCodemirror.UnControlled, {
    value: text,
    options: cmoptions,
    onChange: function onChange(editor, data, value) {
      if (_onChange) _onChange(value);
    },
    onBlur: function onBlur(editor, data) {
      if (_onBlur) _onBlur(editor.doc.getValue());
    }
  });
};

exports.CodeEditor = CodeEditor;

function getCMLanguage(language) {
  if (language == "python") return language;
  if (language == "json") return "javascript";
  return "javascript";
}