"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LanguageSwitcher = void 0;

var _react = _interopRequireWildcard(require("react"));

var _constants = require("./constants.querypane");

var _Dropdown = require("../form/Dropdown");

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var LanguageSwitcher = function LanguageSwitcher(_ref) {
  var currentLanguage = _ref.currentLanguage,
      showEditButton = _ref.showEditButton,
      languages = _ref.languages,
      onChange = _ref.onChange,
      onEdit = _ref.onEdit;
  LanguageSwitcher.propTypes = {
    currentLanguage: _propTypes["default"].string,
    showEditButton: _propTypes["default"].bool,
    languages: _propTypes["default"].array,
    onChange: _propTypes["default"].func.isRequired,
    onEdit: _propTypes["default"].func
  };
  LanguageSwitcher.defaultProps = {
    currentLanguage: "js",
    languages: ['js', 'json', 'python'],
    showEditButton: false
  };

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      dropdownOpen = _useState2[0],
      setDropdownOpen = _useState2[1];

  var toggle = function toggle() {
    return setDropdownOpen(function (prevState) {
      return !prevState;
    });
  };

  var setEditLanguage = function setEditLanguage() {
    onEdit(currentLanguage);
  };

  var buttonClass = showEditButton === true ? "tdb__button__base tdb__commit__bar--button" : "tdb__button__base tdb__commit__bar--button tdb__commit__bar__vis--hidden";

  var changeLanguage = function changeLanguage(lang) {
    toggle();
    onChange(lang);
  };

  var currentLabel = '';
  var entries = languages.map(function (lang, index) {
    var langname = _constants.LANGUAGE_NAMES[lang];
    var active = {};

    if (lang === currentLanguage) {
      active = {
        active: "active"
      };
      currentLabel = "".concat(langname, " ");
    }

    return /*#__PURE__*/_react["default"].createElement("button", _extends({
      onClick: function onClick() {
        changeLanguage(lang);
      }
    }, active, {
      className: "tdb__dropdown__button",
      key: lang
    }), " ", langname);
  });
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("button", {
    className: buttonClass,
    onClick: setEditLanguage
  }, _constants.EDIT_THIS_VERSION), /*#__PURE__*/_react["default"].createElement(_Dropdown.Dropdown, {
    toggle: toggle,
    isOpen: dropdownOpen,
    title: currentLabel,
    className: "nav__main__link tdb__commit__bar--drop"
  }, entries));
};

exports.LanguageSwitcher = LanguageSwitcher;