"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WOQLEditorControlled = void 0;

var _react = _interopRequireWildcard(require("react"));

var _WOQLEditor = require("./WOQLEditor");

var _LanguageSwitcher = require("./LanguageSwitcher");

var _useEditorControl2 = require("./hook/useEditorControl");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

//language, content, setMainError, setWOQLQuery, editable

/**
 * allow you to do use a query editor with multi language
 *
 * @param {WOQLQuery object} 
 * @param {String}           - startLanguage type
 * ..
 */
var WOQLEditorControlled = function WOQLEditorControlled(_ref) {
  var query = _ref.query,
      startLanguage = _ref.startLanguage,
      initcontent = _ref.initcontent,
      editable = _ref.editable,
      languages = _ref.languages,
      setWOQLQuery = _ref.setWOQLQuery,
      mainError = _ref.mainError;

  var _useEditorControl = (0, _useEditorControl2.useEditorControl)(startLanguage, mainError, initcontent, editable),
      changeEditableLanguage = _useEditorControl.changeEditableLanguage,
      changeCurrentLanguage = _useEditorControl.changeCurrentLanguage,
      editorContent = _useEditorControl.editorContent,
      editorLanguage = _useEditorControl.editorLanguage,
      isEditable = _useEditorControl.isEditable,
      changeEditorContent = _useEditorControl.changeEditorContent,
      showEditableButton = _useEditorControl.showEditableButton;

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__qpane__editor"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__commit__bar"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__commit__bar__tools"
  }, /*#__PURE__*/_react["default"].createElement(_LanguageSwitcher.LanguageSwitcher, {
    currentLanguage: editorLanguage,
    showEditButton: showEditableButton,
    languages: languages,
    onChange: changeCurrentLanguage,
    onEdit: changeEditableLanguage
  }))), /*#__PURE__*/_react["default"].createElement(_WOQLEditor.WOQLEditor, {
    setEditorContent: changeEditorContent,
    content: editorContent,
    language: editorLanguage,
    editable: isEditable,
    setMainError: mainError,
    setWOQLQuery: setWOQLQuery
  }));
};

exports.WOQLEditorControlled = WOQLEditorControlled;