"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useEditorControl = void 0;

var _react = _interopRequireWildcard(require("react"));

var _queryPaneUtils = require("../queryPaneUtils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useEditorControl = function useEditorControl(initEditableLanguage, setError) {
  var initEditablecontent = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  var editable = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;

  var _useState = (0, _react.useState)(initEditableLanguage || "js"),
      _useState2 = _slicedToArray(_useState, 2),
      editableLanguage = _useState2[0],
      setEditableLanguage = _useState2[1];

  var _useState3 = (0, _react.useState)(initEditablecontent),
      _useState4 = _slicedToArray(_useState3, 2),
      editableContent = _useState4[0],
      setEditableContent = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      showLanguage = _useState6[0],
      setShowLanguage = _useState6[1];

  var _useState7 = (0, _react.useState)(""),
      _useState8 = _slicedToArray(_useState7, 2),
      showContent = _useState8[0],
      setShowContent = _useState8[1];

  var _useState9 = (0, _react.useState)(editable),
      _useState10 = _slicedToArray(_useState9, 2),
      isEditable = _useState10[0],
      setIsEditable = _useState10[1];

  var _useState11 = (0, _react.useState)(editableContent),
      _useState12 = _slicedToArray(_useState11, 2),
      editorContent = _useState12[0],
      setEditorContent = _useState12[1];

  var _useState13 = (0, _react.useState)(editableLanguage),
      _useState14 = _slicedToArray(_useState13, 2),
      editorLanguage = _useState14[0],
      setEditorLanguage = _useState14[1];

  var _useState15 = (0, _react.useState)(false),
      _useState16 = _slicedToArray(_useState15, 2),
      showEditableButton = _useState16[0],
      setShowEditableButton = _useState16[1]; //


  (0, _react.useEffect)(function () {
    if (showLanguage) {
      var showedit = isEditable && showLanguage && ["js", "json"].indexOf(showLanguage) !== -1;
      setEditorLanguage(showLanguage);
      setEditorContent(showContent);
      setShowEditableButton(showedit);
      setIsEditable(false);
    } else {
      setEditableLanguage(editableLanguage);
      setEditorContent(editableContent);
      setShowEditableButton(false);
      setIsEditable(true);
    }
  }, [showLanguage]);
  /*
  * change the current editable language
  */

  var changeEditableLanguage = function changeEditableLanguage(lang) {
    /*
    * change the edit language and set the content like editable
    */
    setEditableLanguage(lang);
    setEditableContent(showContent);
    setShowContent("");
    setShowLanguage(false);
  };
  /*
  * the current language visualized
  */


  var changeCurrentLanguage = function changeCurrentLanguage(lang) {
    if (lang === editableLanguage) {
      setShowContent("");
      setShowLanguage(false);
    } else {
      if (typeof editableContent !== "string" || editableContent === "") {
        setShowContent("");
        setShowLanguage(lang);
      } else {
        try {
          var woql = (0, _queryPaneUtils.makeWOQLFromString)(editableContent, editableLanguage);

          if (woql) {
            setShowContent((0, _queryPaneUtils.makeWOQLIntoString)(woql, lang));
            setShowLanguage(lang);
          }
        } catch (err) {
          console.log(err);
          setError(err);
        }
      }
    }
  };

  return {
    changeEditorContent: function changeEditorContent(text) {
      setEditableContent(text);
    },
    changeEditableLanguage: changeEditableLanguage,
    changeCurrentLanguage: changeCurrentLanguage,
    editorContent: editorContent,
    editorLanguage: editorLanguage,
    isEditable: isEditable,
    showEditableButton: showEditableButton
  };
};

exports.useEditorControl = useEditorControl;