"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeWOQLIntoString = exports.makeWOQLFromString = void 0;

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var makeWOQLFromString = function makeWOQLFromString(str, lang) {
  switch (lang) {
    case "json":
      var myj = JSON.parse(str);
      return new _terminusdbClient["default"].WOQL.json(myj);

    case "js":
      var WOQL = _terminusdbClient["default"].WOQL;
      var prelude = WOQL.emerge();
      var nw = eval(prelude + "\n" + str);
      return nw;

    case "python":
      throw "Python is not supported for editing queries through the console";
  }
};

exports.makeWOQLFromString = makeWOQLFromString;

var makeWOQLIntoString = function makeWOQLIntoString(woql, lang) {
  if (lang === "js" || lang === "python" && woql) {
    return woql.prettyPrint(lang);
  } else if (lang === "json" && woql) {
    return JSON.stringify(woql.json(), undefined, 2);
  } else return "";
};

exports.makeWOQLIntoString = makeWOQLIntoString;