"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactMotion = require("react-motion");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * The markup Information for an event Line. You can stack multiple lines on top of eachother
 *
 * @param  {object} props The props from parent, styling and positioning
 * @return {StatelessFunctionalReactComponent} Markup Information for the event line.
 */
var EventLine = function EventLine(_ref) {
  var left = _ref.left,
      width = _ref.width,
      fillingMotion = _ref.fillingMotion,
      backgroundColor = _ref.backgroundColor;
  return /*#__PURE__*/_react["default"].createElement(_reactMotion.Motion, {
    style: {
      tWidth: (0, _reactMotion.spring)(width, fillingMotion),
      tLeft: (0, _reactMotion.spring)(left, fillingMotion)
    }
  }, function (_ref2) {
    var tWidth = _ref2.tWidth,
        tLeft = _ref2.tLeft;
    return /*#__PURE__*/_react["default"].createElement("span", {
      "aria-hidden": "true",
      className: "timeline-eventline",
      style: {
        position: 'absolute',
        left: "".concat(tLeft, "px"),
        top: 0,
        height: '100%',
        width: "".concat(tWidth, "px"),
        transformOrigin: 'left center',
        backgroundColor: backgroundColor
      }
    });
  });
};

EventLine.propTypes = {
  // Location and dimension
  left: _propTypes["default"].number,
  width: _propTypes["default"].number,
  // how the filling motion will look like when in action
  fillingMotion: _propTypes["default"].shape({
    stiffness: _propTypes["default"].number,
    damping: _propTypes["default"].number
  }),
  // What color the line should have
  backgroundColor: _propTypes["default"].string
};
var _default = EventLine;
exports["default"] = _default;