"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _helpers = require("../helpers");

var _TimelineDot = require("./TimelineDot");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * The markup Information for all the events on the horizontal timeline.
 *
 * @param  {object} props The props from parent mainly styles
 * @return {StatelessFunctionalReactComponent} Markup Information for the fader
 */
var EventsBar = function EventsBar(_ref) {
  var events = _ref.events,
      selectedIndex = _ref.selectedIndex,
      handleDateClick = _ref.handleDateClick,
      labelWidth = _ref.labelWidth;
  return /*#__PURE__*/_react["default"].createElement("ol", {
    className: "events-bar",
    style: {
      listStyle: 'none'
    }
  }, events.map(function (event, index) {
    return /*#__PURE__*/_react["default"].createElement(_TimelineDot.TimelineDot, {
      distanceFromOrigin: event.distance,
      label: event.label,
      datetime: event.datetime,
      index: index,
      key: index,
      onClick: handleDateClick,
      selected: selectedIndex,
      labelWidth: labelWidth
    });
  }));
};
/**
 * The styles that parent will provide
 * @type {Object}
 */


EventsBar.propTypes = {
  // Array containing the events
  events: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    distance: _propTypes["default"].number.isRequired,
    label: _propTypes["default"].string.isRequired,
    datetime: _propTypes["default"].number.isRequired
  })).isRequired,
  // The index of the selected event
  selectedIndex: _propTypes["default"].number,
  // a handler for clicks on a datapoint
  handleDateClick: _propTypes["default"].func,
  // The width you want the labels to be
  labelWidth: _propTypes["default"].number.isRequired,
  // Custom styling
  styles: _propTypes["default"].object
};
var _default = EventsBar;
exports["default"] = _default;