"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EventsBar = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactMotion = require("react-motion");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Events = _interopRequireDefault(require("./Events"));

var _EventLine = _interopRequireDefault(require("./EventLine"));

var _Faders = require("./Faders");

var _LinkButtons = require("./LinkButtons");

var _Constants = _interopRequireDefault(require("../Constants"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var EventsBar = function EventsBar(props) {
  var _useState = (0, _react.useState)(0),
      _useState2 = _slicedToArray(_useState, 2),
      position = _useState2[0],
      setPosition = _useState2[1];

  var _useState3 = (0, _react.useState)(Math.min(props.visibleWidth - props.totalWidth, 0)),
      _useState4 = _slicedToArray(_useState3, 2),
      maxPosition = _useState4[0],
      setMaxPosition = _useState4[1];

  var touch = {
    coors: {
      x: 0,
      y: 0
    },
    isSwiping: false,
    started: false,
    threshold: 3
  };

  var slideToPosition = function slideToPosition(position) {
    var isClick = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    //the width of the timeline component between the two buttons (prev and next)
    //const selectedEvent = props.events[props.index];
    var currentMaxPosition = Math.min(props.visibleWidth - props.totalWidth, 0); // NEVER scroll to the right

    var positionValue = Math.max(Math.min(0, position), currentMaxPosition);
    setPosition(positionValue);
    setMaxPosition(currentMaxPosition);
    /*
    * I have to reload the next page 
    */

    if (positionValue === currentMaxPosition && isClick) {
      var firstEvent = props.events.slice(-1)[0];

      if (firstEvent.isLastCommit === false) {
        props.loadNextPage({
          lastPosition: positionValue,
          maxPosition: currentMaxPosition
        });
      }
    }
    /*
    * I have to reload the previous page 
    */


    if (positionValue === 0 && isClick) {
      var lastEvent = props.events[0];

      if (lastEvent.parent !== "") {
        props.loadPreviousPage({
          lastPosition: positionValue,
          maxPosition: currentMaxPosition
        });
      }
    }
  };

  (0, _react.useMemo)(function () {
    if (props.gotoPosition !== null) {
      var selectedEvent = props.events[props.gotoPosition];
      slideToPosition(-(selectedEvent.distance - props.visibleWidth / 2));
    } //setCandies(allCandies => allCandies.filter(c => c !== candy))

  }, [props.gotoPosition]);
  (0, _react.useEffect)(function () {
    var selectedEvent = props.events[props.index];
    slideToPosition(-(selectedEvent.distance - props.visibleWidth / 2));
  }, []);

  var handleTouchStart = function handleTouchStart(event) {
    var touchObj = event.touches[0];
    touch.coors.x = touchObj.pageX;
    touch.coors.y = touchObj.pageY;
    touch.isSwiping = false;
    touch.started = true;
  };

  var handleTouchMove = function handleTouchMove(event) {
    if (!touch.started) {
      handleTouchStart(event);
      return;
    }

    var touchObj = event.touches[0];
    var dx = Math.abs(touch.coors.x - touchObj.pageX);
    var dy = Math.abs(touch.coors.y - touchObj.pageY);
    var isSwiping = dx > dy && dx > touch.threshold;

    if (isSwiping === true || dx > touch.threshold || dy > touch.threshold) {
      touch.isSwiping = isSwiping;
      var dX = touch.coors.x - touchObj.pageX; // amount scrolled

      touch.coors.x = touchObj.pageX;
      setState({
        position: position - dX // set new position

      });
    }

    if (touch.isSwiping !== true) {
      return;
    } // Prevent native scrolling


    event.preventDefault();
  };

  var handleTouchEnd = function handleTouchEnd(event) {
    // Make sure we are scrolled to a valid position
    slideToPosition(position);
    touch.coors.x = 0;
    touch.coors.y = 0;
    touch.isSwiping = false;
    touch.started = false;
  };
  /**
   * This method translates the timeline 
   * @param {string} direction |left|right|
   */


  var updateSlide = function updateSlide(direction) {
    if (direction === _Constants["default"].RIGHT) {
      slideToPosition(position - props.visibleWidth + props.labelWidth, true);
    } else if (direction === _Constants["default"].LEFT) {
      slideToPosition(position + props.visibleWidth - props.labelWidth, true);
    }
  };

  var centerEvent = function centerEvent(index) {
    var event = props.events[index];
    slideToPosition(-event.distance);
  }; //  passing the index of the clicked entity.


  var touchEvents = props.isTouchEnabled ? {
    onTouchStart: handleTouchStart,
    onTouchMove: handleTouchMove,
    onTouchEnd: handleTouchEnd
  } : {}; // filled value = distane from origin to the selected event

  var filledValue = props.events[props.index].distance - props.barPaddingLeft;
  var eventLineWidth = props.totalWidth - props.barPaddingLeft - props.barPaddingRight;
  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    style: {
      width: "".concat(props.width, "px"),
      height: "".concat(props.height, "px")
    }
  }, touchEvents), /*#__PURE__*/_react["default"].createElement("div", {
    className: "history__nav__wrapper"
  }, /*#__PURE__*/_react["default"].createElement(_reactMotion.Motion, {
    style: {
      X: (0, _reactMotion.spring)(position)
    }
  }, function (_ref) {
    var X = _ref.X;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "history__nav__events",
      style: {
        width: props.totalWidth,
        WebkitTransform: "translate3d(".concat(X, ", 0, 0)px"),
        transform: "translate3d(".concat(X, "px, 0, 0)")
      }
    }, /*#__PURE__*/_react["default"].createElement(_EventLine["default"], {
      left: props.barPaddingLeft,
      width: eventLineWidth,
      fillingMotion: props.fillingMotion,
      backgroundColor: props.styles.outline
    }), /*#__PURE__*/_react["default"].createElement(_EventLine["default"], {
      left: props.barPaddingLeft,
      width: filledValue,
      fillingMotion: props.fillingMotion,
      backgroundColor: props.styles.foreground
    }), /*#__PURE__*/_react["default"].createElement(_Events["default"], {
      events: props.events,
      selectedIndex: props.index,
      handleDateClick: props.indexClick,
      labelWidth: props.labelWidth
    }));
  })), /*#__PURE__*/_react["default"].createElement(_LinkButtons.LinkButtons, {
    maxPosition: maxPosition,
    position: position,
    updateSlide: updateSlide,
    firstElement: props.events[0],
    lastElement: props.events.slice(-1)[0]
  })); //}
};

exports.EventsBar = EventsBar;
EventsBar.propTypes = {
  width: _propTypes["default"].number.isRequired,
  height: _propTypes["default"].number.isRequired,
  events: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    distance: _propTypes["default"].number.isRequired,
    label: _propTypes["default"].string.isRequired,
    datetime: _propTypes["default"].number.isRequired
  })).isRequired,
  isTouchEnabled: _propTypes["default"].bool.isRequired,
  totalWidth: _propTypes["default"].number.isRequired,
  visibleWidth: _propTypes["default"].number.isRequired,
  index: _propTypes["default"].number,
  styles: _propTypes["default"].object.isRequired,
  indexClick: _propTypes["default"].func.isRequired,
  labelWidth: _propTypes["default"].number.isRequired,
  fillingMotion: _propTypes["default"].object.isRequired,
  barPaddingRight: _propTypes["default"].number.isRequired,
  barPaddingLeft: _propTypes["default"].number.isRequired
};