"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LinkButtons = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Constants = _interopRequireDefault(require("../Constants"));

var _fa = require("react-icons/fa");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// icons
var LinkButtons = function LinkButtons(props) {
  var buttonBackEnabled = Math.round(props.position) < 0 || props.firstElement.parent !== "";
  var buttonForwardEnabled = Math.round(props.position) > Math.round(props.maxPosition) || props.lastElement.isLastCommit === false;
  var iconLeftActive = buttonBackEnabled ? '' : 'history__nav__link__icon--inactive';
  var iconRightActive = buttonForwardEnabled ? '' : 'history__nav__link__icon--inactive';
  var linkLeftActive = buttonBackEnabled ? '' : 'history__nav__link--inactive';
  var linkRightActive = buttonForwardEnabled ? '' : 'history__nav__link--inactive';
  return /*#__PURE__*/_react["default"].createElement("ul", {
    className: "history__nav__link__wrapper"
  }, /*#__PURE__*/_react["default"].createElement("li", {
    className: "history__nav__link history__nav__link--left ".concat(linkLeftActive),
    key: _Constants["default"].LEFT,
    onClick: function onClick() {
      return props.updateSlide(_Constants["default"].LEFT);
    }
  }, /*#__PURE__*/_react["default"].createElement(_fa.FaAngleLeft, {
    className: "history__nav__link__icon ".concat(iconLeftActive)
  })), /*#__PURE__*/_react["default"].createElement("li", {
    className: "history__nav__link history__nav__link--right ".concat(linkRightActive),
    onClick: function onClick() {
      return props.updateSlide(_Constants["default"].RIGHT);
    }
  }, /*#__PURE__*/_react["default"].createElement(_fa.FaAngleRight, {
    className: "history__nav__link__icon ".concat(iconRightActive)
  })));
};

exports.LinkButtons = LinkButtons;
LinkButtons.propTypes = {
  // The function to update the slide
  updateSlide: _propTypes["default"].func.isRequired,
  // Information about what portion of the timeline is visible between buttons
  position: _propTypes["default"].number.isRequired,
  // The maximum position in the timeline component 
  maxPosition: _propTypes["default"].number
};