"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.printts = exports.DATETIME_SSS = exports.DATETIME_SS = exports.DATETIME_HH_DD = exports.DATETIME_HHMM = exports.DATETIME_HOUR = exports.DATETIME_DD_MM = exports.DATETIME_YY = exports.DATETIME_YEAR_MONTH = exports.DATETIME_YEAR = exports.DATETIME_DATE = exports.DATETIME_SHORT = exports.DATETIME_REGULAR = exports.DATETIME_FULL = exports.DATETIME_COMPLETE = void 0;

var _dateFns = require("date-fns");

/**
 * These are date time format patterns that are sent to format 
 * function of date-fns package, to assist common date formats
 * used throughout the console
 */
var DATETIME_COMPLETE = "hh:mm:ss MMM d, yyyy";
exports.DATETIME_COMPLETE = DATETIME_COMPLETE;
var DATETIME_FULL = "hh:mm:ss, dd/MM/yy";
exports.DATETIME_FULL = DATETIME_FULL;
var DATETIME_REGULAR = "dd-MM-yy hh.mm";
exports.DATETIME_REGULAR = DATETIME_REGULAR;
var DATETIME_SHORT = 'h.mm d/MM';
exports.DATETIME_SHORT = DATETIME_SHORT;
var DATETIME_DATE = 'dd MMM yy';
exports.DATETIME_DATE = DATETIME_DATE;
var DATETIME_YEAR = 'yyyy';
exports.DATETIME_YEAR = DATETIME_YEAR;
var DATETIME_YEAR_MONTH = 'MMM yy';
exports.DATETIME_YEAR_MONTH = DATETIME_YEAR_MONTH;
var DATETIME_YY = "'yy";
exports.DATETIME_YY = DATETIME_YY;
var DATETIME_DD_MM = "MMM d";
exports.DATETIME_DD_MM = DATETIME_DD_MM;
var DATETIME_HOUR = "ha";
exports.DATETIME_HOUR = DATETIME_HOUR;
var DATETIME_HHMM = "hh:mm";
exports.DATETIME_HHMM = DATETIME_HHMM;
var DATETIME_HH_DD = "haaaaa'm' d/M";
exports.DATETIME_HH_DD = DATETIME_HH_DD;
var DATETIME_SS = "ss \s";
exports.DATETIME_SS = DATETIME_SS;
var DATETIME_SSS = "sss \s";
exports.DATETIME_SSS = DATETIME_SSS;

var printts = function printts(ts, f) {
  f = f || DATETIME_REGULAR;
  return (0, _dateFns.format)(new Date(ts * 1000), f);
};

exports.printts = printts;