"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useCommitsControl = void 0;

var _react = _interopRequireWildcard(require("react"));

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

var _moment = _interopRequireDefault(require("moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var DATETIME_FULL = "hh:mm:ss, DD-MM-YYYY";
var QUERY_TYPE_LOAD = 'QUERY_TYPE_LOAD';
var QUERY_TYPE_PREVIOUS = 'QUERY_TYPE_PREVIOUS';
var QUERY_TYPE_NEXT = 'QUERY_TYPE_NEXT';

var useCommitsControl = function useCommitsControl(woqlClient, setError) {
  var branch = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'main';
  var currentStartTime = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
  var currentCommit = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
  var firstCommit = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : null;
  var limit = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : 10;
  var page = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : 0;
  var WOQL = _terminusdbClient["default"].WOQL;

  var _useState = (0, _react.useState)(page),
      _useState2 = _slicedToArray(_useState, 2),
      currentPage = _useState2[0],
      setCurrentPage = _useState2[1]; // const [commit, setCurrentCommit] = useState(currentCommit);
  //const [dataProvider, setDataProvider] = useState([]);


  var _useState3 = (0, _react.useState)(currentStartTime),
      _useState4 = _slicedToArray(_useState3, 2),
      startTime = _useState4[0],
      setUpdateStartTime = _useState4[1];

  var _useState5 = (0, _react.useState)(null),
      _useState6 = _slicedToArray(_useState5, 2),
      gotoPosition = _useState6[0],
      setGotoPosition = _useState6[1];

  var _useState7 = (0, _react.useState)(0),
      _useState8 = _slicedToArray(_useState7, 2),
      reloadQuery = _useState8[0],
      setReloadQuery = _useState8[1];

  var _useState9 = (0, _react.useState)(QUERY_TYPE_LOAD),
      _useState10 = _slicedToArray(_useState9, 2),
      queryType = _useState10[0],
      setQueryType = _useState10[1];

  var _useState11 = (0, _react.useState)({
    dataProvider: [],
    selectedValue: 0
  }),
      _useState12 = _slicedToArray(_useState11, 2),
      dataProviderValues = _useState12[0],
      setDataProviderValues = _useState12[1];

  var setSelectedValue = function setSelectedValue(value) {
    var newValue = {
      dataProvider: dataProviderValues.dataProvider,
      selectedValue: value
    };
    setDataProviderValues(newValue);
  };
  /*ss
  * move the commit search from time
  */


  var getPage = function getPage() {
    return limit * currentPage;
  };

  var setStartTime = function setStartTime(time) {
    setCurrentPage(0);
    setGotoPosition(null); //setCurrentCommit(null)

    setUpdateStartTime(time);
  };
  /*
  *the result the first is the last commit the last last is the older
  */
  //next_commits
  //previous_commits
  //load commit Count

  /*
  * first render
  * commit ref or is the last commit
  */


  (0, _react.useEffect)(function () {
    //WOQL.eq("v:Branch","master"),
    //start from
    var queryObj = WOQL.query();

    switch (queryType) {
      case QUERY_TYPE_NEXT:
        var firstElement = dataProviderValues.dataProvider.slice(-1)[0];
        queryObj = WOQL.lib().next_commits(firstElement.commit, branch, limit);
        break;

      case QUERY_TYPE_PREVIOUS:
        var lastElement = dataProviderValues.dataProvider[0];
        queryObj = WOQL.lib().previous_commits(lastElement.commit, limit);
        break;

      default:
        if (currentCommit) {
          queryObj = WOQL.lib().commit_timeline(currentCommit, branch, limit);
        } else {
          queryObj.and(WOQL.lib().active_commit_id(branch, startTime, "Active Commit ID"), WOQL.lib().commit_timeline("v:Active Commit ID", branch, limit));
        }

    }

    woqlClient.query(queryObj).then(function (result) {
      if (result.bindings) {
        var dataFormatted = formatResult(result.bindings);
        var newPoss = dataFormatted.newPoss;
        var selVal = dataFormatted.toBeSelect;
        /*
        * if I have the time set and I'm in the first page
        * I'm not in append mode
        */
        //if(startTime && currentPage===0){
        //newPoss=selVal;
        //}

        setDataProviderValues({
          dataProvider: dataFormatted.dataP,
          selectedValue: selVal
        });
        setQueryType(QUERY_TYPE_LOAD);
        setGotoPosition(newPoss);
      }
    })["catch"](function (err) {
      if (setError) setError(err);
      console.log(err);
    });
  }, [reloadQuery, startTime, branch, currentCommit]);
  /*
  * the result comes order by time so the first is the last commits.
  * we need to reverse the array for the time travel
  * (the last in the right position must be the last in the array),
  * the 0 post have to be the oldest of the result commits
  */

  var formatResult = function formatResult(result) {
    var dataP = [];
    var resLength = Math.max(result.length - 1, 0);
    /*
    * head of the commit
    */

    var toBeSelect = resLength;

    if (queryType === QUERY_TYPE_PREVIOUS || queryType === QUERY_TYPE_NEXT) {
      dataP = dataProviderValues.dataProvider;
    } else {
      result.reverse();
    }

    result.forEach(function (entry, index) {
      var time = entry.Time['@value']; //* 1000;

      var commitValue = entry['Commit ID']['@value'];
      var branchId = entry['Branch ID']['@value'];
      if (currentCommit && currentCommit === commitValue) toBeSelect = index;
      var isLastCommit = branchId === branch ? true : false;
      var item = {
        datetime: time * 1000,
        time: time,
        label: _moment["default"].unix(time).format(DATETIME_FULL),
        message: entry['Message']['@value'],
        commit: commitValue,
        author: entry['Author']['@value'],
        parent: entry['Parent ID']['@value'],
        isLastCommit: isLastCommit
      };

      if (queryType === QUERY_TYPE_PREVIOUS) {
        /*
        *I need to prepend if already I have some data
        */
        dataP.unshift(item);
      } else {
        dataP.push(item);
      }
    });
    var newPoss = toBeSelect;

    if (queryType === QUERY_TYPE_PREVIOUS) {
      toBeSelect = dataProviderValues.selectedValue + resLength + 1;
      newPoss = 5;
      if (resLength < 5) newPoss = 0;
    }

    if (queryType === QUERY_TYPE_NEXT) {
      toBeSelect = dataProviderValues.selectedValue; //if(resLength<5)

      newPoss = Math.max(dataP.length - 1, 0);
    }

    return {
      dataP: dataP,
      toBeSelect: toBeSelect,
      newPoss: newPoss
    };
  };

  var loadPreviousPage = function loadPreviousPage(obj) {
    // {lastPosition:positionValue,maxPosition:maxPosition}
    setQueryType(QUERY_TYPE_PREVIOUS);
    setReloadQuery(Date.now());
  };

  var loadNextPage = function loadNextPage(obj) {
    // {lastPosition:positionValue,maxPosition:maxPosition}
    setQueryType(QUERY_TYPE_NEXT);
    setReloadQuery(Date.now());
  };

  return {
    dataProviderValues: dataProviderValues,
    gotoPosition: gotoPosition,
    // dataProvider,
    // selectedValue,
    loadPreviousPage: loadPreviousPage,
    startTime: startTime,
    setStartTime: setStartTime,
    setSelectedValue: setSelectedValue,
    loadNextPage: loadNextPage //:()=>{setCurrentPage(currentPage+1)}

  };
};

exports.useCommitsControl = useCommitsControl;