"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MainGraphObject = void 0;

var NODE_ACTION_NAME = _interopRequireWildcard(require("./utils/actionType"));

var _modelTreeUtils = require("./utils/modelTreeUtils");

var _FormatDataForTree = require("./FormatDataForTree");

var _graphUpdateObject2 = require("./utils/graphUpdateObject");

var _elementsName = require("./utils/elementsName");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var MainGraphObject = function MainGraphObject(mainGraphDataProvider, dbName) {
  var _objectTypeList = [];
  var _documentTypeList = [];
  var _objectChoiceList = [];
  /*
  * the list of all the property
  */

  var _propertiesList = new Map();
  /*
  * properties organized by domain
  * {domaidName:[{propertyObj001},{propertyObj002}]}
  */


  var _domainToProperties = {};
  /*
  * the list of all the class for the link properties
  */

  var _objectPropertyList = [];
  /*
  * Link Properties/Enum Property organized by range
  * {rangeidName:[{propertyObj001},{propertyObj002}]}
  */

  var _objectPropertyToRange = {};
  /*
  * all the node elements
  */

  var _rootIndexObj = {};

  var _descendantsNode = new Map();

  var _mainGraphElementsJson = {};
  /*
  * this object registers all the graph changes 
  */

  var _graphUpdateObject = new _graphUpdateObject2.graphUpdateObject();

  var getElementsNumber = function getElementsNumber() {
    return {
      properties: _propertiesList.size,
      entities: _documentTypeList.length,
      classes: _objectTypeList.length,
      choiceClasses: _objectChoiceList.length
    };
  };

  var getObjectProperties = function getObjectProperties() {
    return _objectPropertyList;
  };

  var getObjectChoices = function getObjectChoices() {
    return _objectChoiceList;
  };

  var getRoot = function getRoot() {
    var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

    switch (type) {
      case _elementsName.CLASS_TYPE_NAME.OBJECT_CLASS:
      case _elementsName.CLASS_TYPE_NAME.OBJECT_CLASSES:
        return _rootIndexObj[_elementsName.CLASS_TYPE_NAME.OBJECT_CLASSES];

      case _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASS:
      case _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASSES:
        return _rootIndexObj[_elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASSES];

      case _elementsName.CLASS_TYPE_NAME.CHOICE_CLASS:
      case _elementsName.CLASS_TYPE_NAME.CHOICE_CLASSES:
        return _rootIndexObj[_elementsName.CLASS_TYPE_NAME.CHOICE_CLASSES];

      default:
        return _rootIndexObj.ROOT;
    }
  };

  var uniqueName = function uniqueName(newID) {};

  var objectPropertyToRange = function objectPropertyToRange() {
    return _objectPropertyToRange;
  };

  var getObjPropsRelatedToClass = function getObjPropsRelatedToClass(nodeId) {
    if (_objectPropertyToRange[nodeId]) {
      return _objectPropertyToRange[nodeId];
    }

    return [];
  };

  var getDescendantsNode = function getDescendantsNode() {
    return _descendantsNode;
  };
  /*
  * maybe I have to get it from _descendantsNode
  */


  var getElement = function getElement(key) {
    if (_rootIndexObj && _rootIndexObj[key]) {
      return _rootIndexObj[key];
    }

    return undefined;
  };

  var createNewMainGraph = function createNewMainGraph() {
    _mainGraphElementsJson = mainGraphDataProvider;
    _rootIndexObj = (0, _FormatDataForTree.formatData)(mainGraphDataProvider.classesResult, dbName);

    var _formatProperties = (0, _FormatDataForTree.formatProperties)(mainGraphDataProvider.propsResult, mainGraphDataProvider.restResult, _rootIndexObj),
        _formatProperties2 = _slicedToArray(_formatProperties, 3),
        propertyByDomain = _formatProperties2[0],
        objectPropertyRange = _formatProperties2[1],
        propertiesList = _formatProperties2[2];

    _domainToProperties = propertyByDomain;
    _objectPropertyToRange = objectPropertyRange;
    _propertiesList = propertiesList;
    formatDataForTree();
  };

  createNewMainGraph();

  var getAvailableParentsList = function getAvailableParentsList(nodeId) {
    var nodeObject = getElement(nodeId);
    return (0, _FormatDataForTree.availableParentsList)(nodeObject, _objectTypeList, _documentTypeList, _rootIndexObj);
  };

  var addNewPropertyToClass = function addNewPropertyToClass(nodeName, propertyType, propertyRange) {
    if (nodeName !== null && _rootIndexObj[nodeName]) {
      var newProperty = _graphUpdateObject.addPropertyToClass(nodeName, propertyType, propertyRange);

      if (!_domainToProperties[nodeName]) {
        _domainToProperties[nodeName] = [];
      }

      _domainToProperties[nodeName].unshift(newProperty);

      _propertiesList.set(newProperty.name, newProperty);

      return _domainToProperties[nodeName].slice();
    }

    return [];
  };

  var nodeApplyAction = function nodeApplyAction(actionName, nodeName) {
    if (nodeName !== null && _rootIndexObj[nodeName]) {
      var currentNode = _rootIndexObj[nodeName];
      var elementType = currentNode.type;
      var actionType = actionName;
      var isChoiceClass = false;

      switch (actionName) {
        case NODE_ACTION_NAME.ADD_NEW_ENTITY:
          elementType = _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASS;
          nodeName = _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASSES;
          /*
          * I get as currentNode the DocumentClasses node 
          */

          currentNode = getRoot(nodeName);
          actionType = NODE_ACTION_NAME.ADD_CHILD;
          break;

        case NODE_ACTION_NAME.ADD_NEW_CLASS:
          elementType = _elementsName.CLASS_TYPE_NAME.OBJECT_CLASS;
          nodeName = _elementsName.CLASS_TYPE_NAME.OBJECT_CLASSES;
          currentNode = getRoot(elementType);
          actionType = NODE_ACTION_NAME.ADD_CHILD;
          break;

        case NODE_ACTION_NAME.ADD_NEW_CHOICE_CLASS:
          elementType = _elementsName.CLASS_TYPE_NAME.CHOICE_CLASS;
          nodeName = _elementsName.CLASS_TYPE_NAME.CHOICE_CLASSES;
          currentNode = getRoot(elementType);
          actionType = NODE_ACTION_NAME.ADD_CHILD;
          isChoiceClass = true;
          break;
      }

      var newNodeObj = {};

      if (actionName === NODE_ACTION_NAME.ADD_PARENT) {
        /*
        *I have two case current node child of one Group Node
        *NEW PARENT IS CHILD OF Group Node and has as child the currentNode
        */
        var rootParentNode = getRoot(elementType);
        newNodeObj = _graphUpdateObject.addNodeToTree(rootParentNode, currentNode);
        rootParentNode.children.push(newNodeObj);
        newNodeObj.children.push(currentNode);
        newNodeObj.allChildren.push(currentNode);
        /*
        * check if I have to remove the child from the root node
        */

        removeChildFromRoot(currentNode);
        nodeName = rootParentNode.name;
      } else {
        newNodeObj = _graphUpdateObject.addNodeToTree(currentNode, null, isChoiceClass);

        if (currentNode.type === "Group") {
          currentNode.children.push(newNodeObj);
        } else {
          /*
          * currentNode is the parent node
          	*/
          currentNode.children.push(newNodeObj);
          currentNode.allChildren.push(newNodeObj);
        }
      }

      _rootIndexObj[newNodeObj.name] = newNodeObj;
      /*
      * to be review...
      */

      addNodeToclassList(newNodeObj);
      setNewElementPosition(nodeName, newNodeObj);
      return newNodeObj;
    }
  };

  var addNodeToclassList = function addNodeToclassList(elementObj) {
    switch (elementObj.type) {
      case _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASS:
        _documentTypeList.push(elementObj.name);

        (0, _FormatDataForTree.addElementToPropertyList)(elementObj, _objectPropertyList);
        break;

      case _elementsName.CLASS_TYPE_NAME.OBJECT_CLASS:
        _objectTypeList.push(elementObj.name);

        (0, _FormatDataForTree.addElementToPropertyList)(elementObj, _objectPropertyList);
        break;

      case _elementsName.CLASS_TYPE_NAME.CHOICE_CLASS:
        (0, _FormatDataForTree.addElementToPropertyList)(elementObj, _objectChoiceList);
        break;
      //_classesList.set(elementObj.name,{value:node.data.name,name:node.data.name,label:node.data.label});
    }
  };
  /*
     *I have to check if the new parent and the node have the same parents.....
     *in this case I have to remove the direct parent
     */


  var checkRelatedParents = function checkRelatedParents(elementObjClass, parentObjClass) {
    parentObjClass.parents.forEach(function (parentName) {
      var parentOfParentObj = _rootIndexObj[parentName];
      var parentRelated = (0, _modelTreeUtils.removeElementToArr)(elementObjClass.parents, parentName);

      if (parentRelated) {
        /*
        * remove child from parent
        */
        (0, _modelTreeUtils.removeElementToArr)(parentOfParentObj.children, elementObjClass.name);

        if (parentOfParentObj.allChildren) {
          (0, _modelTreeUtils.removeElementToArr)(parentOfParentObj.children, elementObjClass.name);
        }
        /*
        * register to be save to schema
        */


        _graphUpdateObject.changeNodeParent(elementObjClass.name, parentName, NODE_ACTION_NAME.REMOVE_PARENT);
      }

      checkRelatedParents(elementObjClass, parentOfParentObj);
    });
  };

  var updateNodeParents = function updateNodeParents(elementName, parentName, actionName) {
    var elementObjClass = _rootIndexObj[elementName];
    var parentObjClass = _rootIndexObj[parentName];
    checkRelatedParents(elementObjClass, parentObjClass);

    _graphUpdateObject.changeNodeParent(elementName, parentName, actionName);

    if (actionName === NODE_ACTION_NAME.ADD_PARENT) {
      //the node could be children of another node or children of root node 
      if (parentObjClass.type === elementObjClass.type) {
        removeChildFromRoot(elementObjClass);

        if (elementObjClass.parents.length === 0) {
          parentObjClass.children.push(elementObjClass);
        }
      }

      elementObjClass.parents.push(parentObjClass.name);
      parentObjClass.allChildren.push(elementObjClass);
    } else {
      (0, _modelTreeUtils.removeElementToArr)(elementObjClass.parents, parentName);
      (0, _modelTreeUtils.removeElementToArr)(parentObjClass.children, elementName);
      if (parentObjClass.allChildren) (0, _modelTreeUtils.removeElementToArr)(parentObjClass.allChildren, elementName);
      /*
      * if the parents array is empty I move the node under the root group
      */

      if (elementObjClass.parents.length === 0) {
        parentName = addToParentGroup(elementObjClass);
      } else if (elementObjClass.type === _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASS) {
        var docParent = elementObjClass.parents.findIndex(function (pName) {
          var pElement = _rootIndexObj[pName];
          return pElement.type === _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASS;
        });

        if (docParent === -1) {
          parentName = addToParentGroup(elementObjClass);
        }
      }
    }
    /*
    * this is for save the change
    */


    moveNodeUnderParent(parentName, elementName);
    return elementObjClass;
  };

  var addToParentGroup = function addToParentGroup(elementObjClass) {
    var parentRoot = getRoot(elementObjClass.type);
    parentRoot.children.push(elementObjClass);

    if (elementObjClass.type === 'Document') {
      _graphUpdateObject.changeNodeParent(elementObjClass.name, 'Document', NODE_ACTION_NAME.ADD_PARENT);
    }

    return parentRoot.name;
  };

  var _removeClassElement = function _removeClassElement(elementName) {
    var classElement = _rootIndexObj[elementName];

    if (classElement) {
      /*
      *register the remove 
      	*/

      /*
      * if this is an UNDO action (ex UNDO of add Parent)
      * I could remove a node with a child
      * so I have to move the child node under 
      * a new parent before delete it 
      */

      /*	if(classElement._childrenObj.size>0){
      	for (let childObj of classElement._childrenObj.values()){
      		updateNodeParents(childObj.id,elementName,NODE_ACTION_NAME.REMOVE_PARENT)
      	}
      }*/
      // I have to remove the node from the nodeParents list
      classElement.parents.forEach(function (parentName) {
        var parentObj = _rootIndexObj[parentName];
        (0, _modelTreeUtils.removeElementToArr)(parentObj.children, elementName);
        if (parentObj.allChildren) (0, _modelTreeUtils.removeElementToArr)(parentObj.allChildren, elementName);
      });
      /*
      * I have to remove from the itemlists
      */

      delete _rootIndexObj[elementName];

      var nodeElement = _descendantsNode.get(elementName);

      _descendantsNode["delete"](elementName);

      switch (classElement.type) {
        case _elementsName.CLASS_TYPE_NAME.OBJECT_CLASS:
          (0, _modelTreeUtils.removeElementToArr)(_objectTypeList, elementName);
          (0, _modelTreeUtils.removeElementToArr)(_objectPropertyList, elementName); //_classesList.delete(elementName);

          break;

        case _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASS:
          (0, _modelTreeUtils.removeElementToArr)(_documentTypeList, elementName);
          (0, _modelTreeUtils.removeElementToArr)(_objectPropertyList, elementName);
          break;

        case _elementsName.CLASS_TYPE_NAME.CHOICE_CLASS:
          (0, _modelTreeUtils.removeElementToArr)(_objectChoiceList, elementName);
      }

      _graphUpdateObject.removeNode(classElement); // I need the node element for UNDO action
      //return nodeElement;

    }
  };
  /*
  * I can remove a node if it hasn't
  * children and it is not a target in a relationship 
  * (this node can not be a range in a property link)
  */


  var removeElementInMainGraph = function removeElementInMainGraph(elementName) {
    var listOfProperty = _domainToProperties[elementName] ? _domainToProperties[elementName].slice() : [];

    if (listOfProperty.length > 0) {
      listOfProperty.forEach(function (property, key) {
        removePropertyToClass(elementName, property.name);
      });
    }

    return _removeClassElement(elementName);
  };

  var removePropertyToClass = function removePropertyToClass(domainClassName, propertyName) {
    var propertyObject = _propertiesList.get(propertyName);

    var propertyByDomain = _domainToProperties[domainClassName] || []; //remove by domain

    (0, _modelTreeUtils.removeElementToArr)(propertyByDomain, propertyName); // remove by range

    var propertyByRange = _objectPropertyToRange[propertyObject.range];
    (0, _modelTreeUtils.removeElementToArr)(propertyByRange, propertyName); //remove from property list

    _propertiesList["delete"](propertyName);

    _graphUpdateObject.removePropertyToClass(propertyObject);

    return propertyByDomain.slice();
  };
  /*
       *if I remove a parent 
       *I have to remove child from parent too(children Obj)  
       */


  var removeChildFromRoot = function removeChildFromRoot(currentNode) {
    var rootNode = getRoot(currentNode.type);
    if (!rootNode.children || rootNode.children.length === 0) return;
    (0, _modelTreeUtils.removeElementToArr)(rootNode.children, currentNode.name);
  };

  var moveNodeUnderParent = function moveNodeUnderParent(parentId, nodeId) {
    var parentNode = _descendantsNode.get(parentId);

    var elementNode = _descendantsNode.get(nodeId);

    elementNode.parent = parentNode;
    elementNode.depth = parentNode.depth + 1;
    elementNode.x = parentNode.x + 100;
    elementNode.y = parentNode.y + 100;
  };

  var setNewElementPosition = function setNewElementPosition(parentId, newNodeObj, asType) {
    var parentNode = _descendantsNode.get(parentId);

    var yStep = parentNode.y + 100;
    var xStep = parentNode.x + 100;
    var newNode = {};
    newNode.parent = parentNode;
    newNode.depth = parentNode.depth + 1;
    newNode.x = xStep;
    newNode.y = yStep;
    newNode.data = newNodeObj;

    _descendantsNode.set(newNodeObj.name, newNode);
  };

  var getPropertyListByDomain = function getPropertyListByDomain(domainClassName) {
    if (_domainToProperties[domainClassName]) return _domainToProperties[domainClassName];
    return [];
  };

  var getProperty = function getProperty(propertyName) {
    return _propertiesList.get(propertyName);
  };

  var getPropertyDomain = function getPropertyDomain(property) {
    return property.domain && property.domain.length > 0 ? property.domain[0] : undefined;
  };

  function formatDataForTree() {
    var _formatDataForTreeCha = new _FormatDataForTree.formatDataForTreeChart(getRoot()),
        _formatDataForTreeCha2 = _slicedToArray(_formatDataForTreeCha, 5),
        descendantsNode = _formatDataForTreeCha2[0],
        objectTypeList = _formatDataForTreeCha2[1],
        documentTypeList = _formatDataForTreeCha2[2],
        objectPropertyList = _formatDataForTreeCha2[3],
        objectChoiceList = _formatDataForTreeCha2[4];

    _descendantsNode = descendantsNode; //_classesList=classesList;
    //_entitiesList=entitiesList;

    _documentTypeList = documentTypeList;
    _objectTypeList = objectTypeList;
    _objectPropertyList = objectPropertyList;
    _objectChoiceList = objectChoiceList;
  }

  var descendantsNodeAsArray = function descendantsNodeAsArray() {
    return _toConsumableArray(_descendantsNode.values());
  };

  var savedObjectToWOQL = function savedObjectToWOQL() {
    return _graphUpdateObject.savedObjectToWOQL(_rootIndexObj, _propertiesList);
  };

  var updateChoices = function updateChoices(elementName, choicesList) {
    var choiceClass = _rootIndexObj[elementName];
    choiceClass['choices'] = choicesList;

    _graphUpdateObject.updateChoicesList(choiceClass);
  };

  var updateObjectPropertyListLabel = function updateObjectPropertyListLabel(objectPropList, elementDataObject) {
    var index = objectPropList.findIndex(function (item) {
      if (item.name === elementDataObject.name) {
        item.label = elementDataObject.label || elementDataObject.id;
      }

      return item.name === elementDataObject.name;
    });
  };

  var changeElementDataValue = function changeElementDataValue(propName, propValue, elementDataObject) {
    /*
    * put the data in the list to save
    */
    _graphUpdateObject.updateTripleElement(propName, propValue, elementDataObject);

    var objectPropList = _objectPropertyList;

    switch (elementDataObject.type) {
      case _elementsName.CLASS_TYPE_NAME.CHOICE_CLASS:
        objectPropList = _objectChoiceList;

      case _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASS:
      case _elementsName.CLASS_TYPE_NAME.OBJECT_CLASS:
        var currentNode = _rootIndexObj[elementDataObject.name];
        currentNode[propName] = propValue;

        if (propName === 'label') {
          updateObjectPropertyListLabel(objectPropList, elementDataObject);
        }

        break;
      //property case

      default:
        //objectPropertyRangeItem
        var currentProperty = _propertiesList.get(elementDataObject.name);

        var propRange = currentProperty.range;
        currentProperty[propName] = propValue;

        if (propName === 'range' && _rootIndexObj[propValue] !== undefined) {
          var classElement = _rootIndexObj[propValue];
          (0, _FormatDataForTree.addObjectPropertyRangeItem)(_objectPropertyToRange, currentProperty, classElement, propRange);
        }

    }
  };

  var getObjectTypeList = function getObjectTypeList() {
    return _objectTypeList;
  };

  var getDocumentTypeList = function getDocumentTypeList() {
    return _documentTypeList;
  };

  return {
    objectPropertyToRange: objectPropertyToRange,
    updateChoices: updateChoices,
    getObjectChoices: getObjectChoices,
    getObjectTypeList: getObjectTypeList,
    getDocumentTypeList: getDocumentTypeList,
    getElementsNumber: getElementsNumber,
    getElement: getElement,
    getPropertyListByDomain: getPropertyListByDomain,
    getObjPropsRelatedToClass: getObjPropsRelatedToClass,
    getAvailableParentsList: getAvailableParentsList,
    nodeApplyAction: nodeApplyAction,
    addNewPropertyToClass: addNewPropertyToClass,
    removePropertyToClass: removePropertyToClass,
    changeElementDataValue: changeElementDataValue,
    updateNodeParents: updateNodeParents,
    savedObjectToWOQL: savedObjectToWOQL,
    getObjectProperties: getObjectProperties,
    getDescendantsNode: getDescendantsNode,
    removeElementInMainGraph: removeElementInMainGraph
  };
};

exports.MainGraphObject = MainGraphObject;