"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ModelTreeComponent = void 0;

var _react = _interopRequireWildcard(require("react"));

var _graphTree = require("./graph/graphTree");

var _d3Hierarchy = require("d3-hierarchy");

var _d3Selection = require("d3-selection");

var _d3Zoom = require("d3-zoom");

var _d3Drag = require("d3-drag");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ModelTreeComponent = function ModelTreeComponent(props) {
  /**
   * Configures zoom upon graph with default or user provided values.<br/>
   * {@link https://github.com/d3/d3-zoom#zoom}
   * @returns {undefined}
   */
  var selectedNode = props.selectedNodeObject && props.selectedNodeObject.name ? props.selectedNodeObject.name : null;
  var treeGraphWrapper = (0, _react.useRef)(null);
  var treeGraphContainer = (0, _react.useRef)(null);

  var _useState = (0, _react.useState)(null),
      _useState2 = _slicedToArray(_useState, 2),
      upadateGraph = _useState2[0],
      setTick = _useState2[1];

  var _useState3 = (0, _react.useState)(),
      _useState4 = _slicedToArray(_useState3, 2),
      graphTransform = _useState4[0],
      setTransform = _useState4[1];

  var zoomElement = (0, _d3Zoom.zoom)().scaleExtent([0.1, 8]).on('zoom', function () {
    _zoomed();
  });

  var _useState5 = (0, _react.useState)(1),
      _useState6 = _slicedToArray(_useState5, 2),
      zoomFactor = _useState6[0],
      setZoomFactor = _useState6[1];

  var changeSelectedNode = function changeSelectedNode(nodeId) {
    if (selectedNode === nodeId) return;

    _moveNodeToFront(nodeId);

    if (props.changeCurrentNode) props.changeCurrentNode(nodeId);
  };

  var _moveNodeToFront = function _moveNodeToFront(nodeId) {
    var nodeElement = props.graphDataProvider.get(nodeId);

    if (nodeElement) {
      props.graphDataProvider["delete"](nodeId);
      props.graphDataProvider.set(nodeId, nodeElement); //_tick();
    }
  };

  var focusOnNode = function focusOnNode(nodeId) {
    var node = props.graphDataProvider.get(nodeId);

    if (node) {
      var _height = props.height || 500;

      var _width = props.width || 1000;

      var nodeR = 200;
      var widthHalf = _width / 2;
      var startOffset = 300;
      (0, _d3Selection.select)('#treeGraphWrapper').transition().duration(1000).tween("zoom", function () {
        return function (t) {
          var K = 1.2;
          var nodeX = widthHalf - node.x * K;
          var nodeY = 0 - (node.y * K - startOffset);

          var ts = _d3Zoom.zoomIdentity //.scale(4)
          .translate(nodeX, nodeY).scale(K);

          (0, _d3Selection.select)("#treeGraphWrapper").call(zoomElement.transform, ts);
        };
      });
    }
  };

  var _linkObjectToD3Action = function _linkObjectToD3Action() {
    var customNodeDrag = (0, _d3Drag.drag)().on('start', _onDragStart).on('drag', _onDragMove); // .on('end', _onDragEnd);

    (0, _d3Selection.select)('#treeGraph').selectAll('.node').call(customNodeDrag);
  };

  (0, _react.useEffect)(function () {
    //startDataProsition();      
    if (treeGraphWrapper.current && props.width) {
      _zoomConfig(treeGraphWrapper.current);
    }
  }, [treeGraphWrapper.current, props.width]);
  (0, _react.useEffect)(function () {
    //if(selectedNode && props.addedNewNode===true){
    _linkObjectToD3Action();

    if (props.isFocusOnNode) focusOnNode(selectedNode); //}
  }, [selectedNode, props.graphDataProvider]);
  (0, _react.useEffect)(function () {
    if (props.zoomEvent) {
      switch (props.zoomEvent.type) {
        case "ZOOM_IN":
          zoomIn();
          break;

        case "ZOOM_OUT":
          zoomOut();
          break;

        case "RESET_ZOOM":
          resetZoom();
          break;
      }
    }
  }, [props.zoomEvent]);
  /**
   * Handles d3 'drag' event.
   * {@link https://github.com/d3/d3-drag/blob/master/README.md#drag_subject|more about d3 drag}
   * @param  {Object} ev - if not undefined it will contain event data.
   * @param  {number} index - index of the node that is being dragged.
   * @param  {Array.<Object>} nodeList - array of d3 nodes. This list of nodes is provided by d3, each
   * node contains all information that was previously fed by rd3g.
   * @returns {undefined}
   */

  var _onDragMove = function _onDragMove(ev, index, nodeList) {
    var id = nodeList[index].id; // this is where d3 and react bind
    // graphData is a Map() 

    var draggedNode = props.graphDataProvider.get(id);
    draggedNode.x += _d3Selection.event.dx;
    draggedNode.y += _d3Selection.event.dy;

    _tick();
  };
  /**
   * The tick function simply calls React set state in order to update component and render nodes
   * along time as d3 calculates new node positioning.
   * @param {Object} state - new state to pass on.
   * @returns {undefined}
   */


  var _tick = function _tick() {
    setTick(Date.now());
  }; //d3Zoom


  var zoomIn = function zoomIn() {
    var height = props.height || 500;
    var width = props.width || 1000;
    var newZoom = graphTransform.k + 0.2; //const step= ((graphTransform.x/graphTransform.k)*0.2)/2
    //??
    //const xOffset=graphTransform.x-step;
    //const yOffset=graphTransform.y*newZoom;

    (0, _d3Selection.select)(treeGraphWrapper.current).call(zoomElement.transform, _d3Zoom.zoomIdentity.translate(graphTransform.x, graphTransform.y).scale(newZoom));
  };

  var zoomOut = function zoomOut() {
    var newZoom = Math.max(graphTransform.k - 0.2, 0.1);
    (0, _d3Selection.select)(treeGraphWrapper.current).call(zoomElement.transform, _d3Zoom.zoomIdentity.translate(graphTransform.x, graphTransform.y).scale(newZoom));
  };

  var resetZoom = function resetZoom() {
    //d3Select(domElement).call(zoomElement.transform, 
    // d3ZoomIdentity.translate(props.width/2,50).scale(0.8))
    (0, _d3Selection.select)(treeGraphWrapper.current).call(zoomElement.transform, _d3Zoom.zoomIdentity.translate(props.width / 2, 50, 50).scale(0.8));
  };
  /**
    * Handler for 'zoom' event within zoom config.
    * @returns {Object} returns the transformed elements within the svg graph area.
    */


  var _zoomed = function _zoomed() {
    var transform = _d3Selection.event.transform;
    (0, _d3Selection.selectAll)('#treeGraphContainer').attr('transform', transform);
    setTransform(transform);
  };

  var _zoomConfig = function _zoomConfig() {
    if (props.width) resetZoom();
    (0, _d3Selection.select)(treeGraphWrapper.current).call(zoomElement);
  };

  var _onDragStart = function _onDragStart() {
    var test;
  };

  var _onDrop = function onDrop(e, complete) {};

  var _onDragOver = function onDragOver(e) {
    var test = e;
    e.preventDefault();
  };

  var needRefresh = Date.now();
  var width = props.width;
  var height = props.height;
  var events = false;
  return /*#__PURE__*/_react["default"].createElement("div", {
    width: width,
    height: height,
    id: 'treeGraphWrapper',
    onDragOver: function onDragOver(e) {
      return _onDragOver(e);
    },
    onDrop: function onDrop(e) {
      return _onDrop(e, "complete");
    },
    ref: treeGraphWrapper
  }, /*#__PURE__*/_react["default"].createElement("svg", {
    width: width,
    height: height
  }, /*#__PURE__*/_react["default"].createElement("defs", null, /*#__PURE__*/_react["default"].createElement("marker", {
    className: "marker-small",
    id: "markerArrowEnd",
    viewBox: "0 -5 10 10",
    refX: "5",
    refY: "5",
    markerWidth: 4,
    markerHeight: 4,
    orient: "auto",
    fill: 'green'
  }, /*#__PURE__*/_react["default"].createElement("path", {
    d: "M0,-5L10,0L0,5",
    fill: "green"
  })), /*#__PURE__*/_react["default"].createElement("marker", {
    id: "markerArrowStart",
    viewBox: "0 0 10 10",
    refX: "5",
    refY: "5",
    markerWidth: "4",
    markerHeight: "4",
    orient: "auto-start-reverse"
  }, /*#__PURE__*/_react["default"].createElement("path", {
    d: "M 0 0 L 10 5 L 0 10 z",
    fill: "green"
  }))), /*#__PURE__*/_react["default"].createElement("g", {
    id: 'treeGraphContainer',
    ref: treeGraphContainer
  }, /*#__PURE__*/_react["default"].createElement("rect", {
    opacity: 0,
    width: width,
    height: height,
    fill: "#ffffff"
  }), /*#__PURE__*/_react["default"].createElement(_graphTree.Tree, {
    id: 'treeGraph',
    objectPropertyToRange: props.objectPropertyToRange,
    isEditMode: props.isEditMode,
    needRefresh: needRefresh,
    nodes: _toConsumableArray(props.graphDataProvider.values()),
    nodeClick: changeSelectedNode,
    selectedNode: selectedNode,
    setNodeAction: props.setNodeAction
  }))));
};

exports.ModelTreeComponent = ModelTreeComponent;