"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseElement = void 0;

var _react = _interopRequireWildcard(require("react"));

var _detailsLabels = require("../../constants/details-labels.js");

var _RemoveElementComponent = require("./RemoveElementComponent");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _HelpComponent = require("./HelpComponent");

var _BaseInputElement = require("./BaseInputElement");

var _BaseTextareaElement = require("./BaseTextareaElement");

var _BaseCheckboxElement = require("./BaseCheckboxElement");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/*
* I change the value in the dataprovider but don't render
*/
var BaseElement = function BaseElement(props) {
  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      indexError = _useState2[0],
      setIndexError = _useState2[1];

  var nodeJsonData = props.nodeJsonData || {};

  var changeElement = function changeElement(name, value) {
    var val = value;

    if (name === "id") {
      val = value.trim();

      if (val.indexOf(" ") > -1) {
        setIndexError("Please remove all the white space");
        return;
      }

      if (val === "") {
        setIndexError("Please enter a valid ID");
        return;
      }

      setIndexError(false);
    }

    if (props.updateValue) {
      props.updateValue(name, val, nodeJsonData);
    }
  };

  (0, _react.useEffect)(function () {
    setIndexError(false);
  }, [nodeJsonData]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__box"
  }, /*#__PURE__*/_react["default"].createElement(_RemoveElementComponent.RemoveElementComponent, {
    hasConstraints: props.hasConstraints,
    elementId: nodeJsonData.name,
    elementType: nodeJsonData.type,
    removeElement: props.removeElement
  }), props.isNodeObject && nodeJsonData.type !== 'ChoiceClass' && /*#__PURE__*/_react["default"].createElement(_BaseCheckboxElement.BaseCheckboxElement, {
    title: 'Abstract',
    help: "abstract",
    name: "abstract",
    defaultValue: nodeJsonData["abstract"] || false,
    onBlur: changeElement
  }), /*#__PURE__*/_react["default"].createElement(_BaseInputElement.BaseInputElement, {
    autoFocus: true,
    disabled: !nodeJsonData.newElement,
    title: "".concat(_detailsLabels.ELEMENT_BASE_CONST.ID_TEXT, " *"),
    placeholder: _detailsLabels.ELEMENT_BASE_CONST.ID_PLACEHOLDER,
    name: "id",
    panelName: nodeJsonData.name,
    help: "class_id",
    onBlur: changeElement,
    defaultValue: nodeJsonData.id || '',
    itemError: indexError
  }), /*#__PURE__*/_react["default"].createElement(_BaseInputElement.BaseInputElement, {
    title: _detailsLabels.ELEMENT_BASE_CONST.LABEL_TEXT,
    name: "label",
    placeholder: _detailsLabels.ELEMENT_BASE_CONST.LABEL_PLACEHOLDER,
    help: "class_label",
    onBlur: changeElement,
    defaultValue: nodeJsonData.label || ''
  }), props.children, /*#__PURE__*/_react["default"].createElement(_BaseTextareaElement.BaseTextareaElement, {
    placeholder: _detailsLabels.ELEMENT_BASE_CONST.DESCRIPTION_PLACEHOLDER,
    title: _detailsLabels.ELEMENT_BASE_CONST.DESCRIPTION_TEXT,
    name: "comment",
    help: "class_comment",
    onBlur: changeElement,
    defaultValue: nodeJsonData.comment || ''
  }));
};

exports.BaseElement = BaseElement;
BaseElement.propTypes = {
  nodeJsonData: _propTypes["default"].object,
  isNodeObject: _propTypes["default"].bool,
  hasConstraints: _propTypes["default"].bool
};
BaseElement.defaultProps = {
  nodeJsonData: {},
  isNodeObject: true,
  hasConstraints: false
};