"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseInputElement = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _HelpComponent = require("./HelpComponent");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var BaseInputElement = function BaseInputElement(props) {
  var _useState = (0, _react.useState)(''),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setInputValue = _useState2[1]; //const [autoFocus,setAutoFocus] = useState({})


  var inputElement = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    if (props.defaultValue !== value) {
      setInputValue(props.defaultValue);
    }
  }, [props.defaultValue]);
  (0, _react.useEffect)(function () {
    if (inputElement.current && props.defaultValue === "" && props.autoFocus === true && props.disabled !== true) {
      inputElement.current.focus();
    }
  }, [inputElement.current, props.panelName]);

  var onBlur = function onBlur(evt) {
    var valueChecked = true;

    if (typeof props.checkValue === 'function') {
      valueChecked = props.checkValue(props.name, value);
    }

    if (typeof props.onBlur === 'function' && valueChecked) props.onBlur(props.name, value);
  };

  var onChange = function onChange(evt) {
    setInputValue(evt.currentTarget.value);
  };

  var disabled = props.disabled === true ? {
    disabled: true
  } : {}; //const autoFocus= props.disabled!==true && props.autoFocus === true ? {autoFocus:true} :{}

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: props.groupClassName
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__form__help"
  }, /*#__PURE__*/_react["default"].createElement("label", {
    className: props.labelClassName,
    htmlFor: props.name
  }, props.title), /*#__PURE__*/_react["default"].createElement(_HelpComponent.HelpComponent, {
    text: props.help
  })), /*#__PURE__*/_react["default"].createElement("input", _extends({
    ref: inputElement,
    placeholder: props.placeholder,
    onBlur: onBlur
  }, disabled, {
    onChange: onChange,
    value: value,
    name: props.name,
    id: props.name,
    className: props.inputClassName
  })), /*#__PURE__*/_react["default"].createElement("span", {
    className: "tdb__form__error"
  }, props.itemError));
}; //pattern="[0-9]{4}" required


exports.BaseInputElement = BaseInputElement;
BaseInputElement.propTypes = {
  title: _propTypes["default"].string,
  defaultValue: _propTypes["default"].string,
  groupClassName: _propTypes["default"].string,
  inputClassName: _propTypes["default"].string,
  labelClassName: _propTypes["default"].string,
  name: _propTypes["default"].string.isRequired,
  onBlur: _propTypes["default"].func,
  disabled: _propTypes["default"].bool,
  placeholder: _propTypes["default"].string
};
BaseInputElement.defaultProps = {
  title: '',
  defaultValue: '',
  groupClassName: 'tdb__form__group',
  inputClassName: 'tdb__form__element',
  labelClassName: 'tdb__form__label',
  disabled: false,
  placeholder: ''
};