"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BasePropertyComponent = void 0;

var _react = _interopRequireWildcard(require("react"));

var _BaseElement = require("./BaseElement");

var _Accordion = require("../../form/Accordion");

var _detailsLabels = require("../../constants/details-labels");

var _BaseSelectComponent = require("./BaseSelectComponent");

var _BaseNumericInput = require("./BaseNumericInput");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _HelpComponent = require("./HelpComponent");

var _BaseInputElement = require("./BaseInputElement");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var BasePropertyComponent = function BasePropertyComponent(props) {
  var _useState = (0, _react.useState)(''),
      _useState2 = _slicedToArray(_useState, 2),
      minError = _useState2[0],
      setMinError = _useState2[1];

  var _useState3 = (0, _react.useState)(''),
      _useState4 = _slicedToArray(_useState3, 2),
      maxError = _useState4[0],
      setMaxError = _useState4[1];

  var currentNodeJson = props.currentNodeJson || {};
  var title = currentNodeJson.label || currentNodeJson.id;
  var viewBaseSchema = props.viewBaseSchema === false ? false : true;
  var showAllButton = props.showAllButton || {};
  var leftIconClassName = _detailsLabels.GET_ICON_NAME[currentNodeJson.type] || "custom-img-string";

  var changePropertyValue = function changePropertyValue(propName, propValue) {
    if (propName === 'label') {
      title = propValue;
    }

    props.updateValue(propName, propValue, currentNodeJson);
  };

  var cardCheckValue = function cardCheckValue(propName, propValue) {
    if (propValue.trim() === '' || parseFloat(propValue) > 0) {
      if (propName === 'min') setMinError("");
      if (propName === 'max') setMaxError("");
      return true;
    }

    if (propName === 'min') setMinError("Please enter a valid number >0");
    if (propName === 'max') setMaxError("Please enter a valid number >0");
    return false;
  };

  return /*#__PURE__*/_react["default"].createElement(_Accordion.Accordion, {
    showBody: props.showBody,
    arrowOpenClassName: "accordion__arrow fa fa-caret-up",
    arrowCloseClassName: "accordion__arrow fa fa-caret-down",
    title: title,
    leftIconClassName: leftIconClassName,
    tooltip: currentNodeJson.type || ''
  }, viewBaseSchema && /*#__PURE__*/_react["default"].createElement(_BaseElement.BaseElement, {
    updateValue: changePropertyValue,
    removeElement: props.removeElement,
    nodeJsonData: currentNodeJson,
    showAllButton: showAllButton,
    isNodeObject: false
  }, props.selectDataProvider && /*#__PURE__*/_react["default"].createElement(_BaseSelectComponent.BaseSelectComponent, {
    help: props.help,
    optionChange: changePropertyValue,
    title: props.selectDataProvider.label,
    dataProvider: props.selectDataProvider.options,
    name: props.selectDataProvider.id,
    defaultValue: currentNodeJson.range || ''
  }), props.children), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__box"
  }, props.showCardinality && /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_BaseInputElement.BaseInputElement, {
    itemError: minError,
    help: "card_min",
    defaultValue: currentNodeJson.min || '',
    name: "min",
    title: _detailsLabels.CARDINALITY_MIN_TITLE,
    onBlur: changePropertyValue,
    checkValue: cardCheckValue
  }), /*#__PURE__*/_react["default"].createElement(_BaseInputElement.BaseInputElement, {
    itemError: maxError,
    help: "card_max",
    defaultValue: currentNodeJson.max || '',
    name: "max",
    title: _detailsLabels.CARDINALITY_MAX_TITLE,
    onBlur: changePropertyValue,
    checkValue: cardCheckValue
  }))));
};

exports.BasePropertyComponent = BasePropertyComponent;
BasePropertyComponent.propTypes = {
  showCardinality: _propTypes["default"].bool
};
BasePropertyComponent.defaultProps = {
  showCardinality: true
};