"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseSelectComponent = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _HelpComponent = require("./HelpComponent");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var BaseSelectComponent = function BaseSelectComponent(props) {
  var _useState = (0, _react.useState)(props.defaultValue),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  (0, _react.useEffect)(function () {
    if (value !== props.defaultValue) {
      setValue(props.defaultValue);
    }
  }, [props.defaultValue]);

  var getDisabledOptions = function getDisabledOptions(allowedValue, value) {
    if (!allowedValue || allowedValue === "ALL" || value === "") return {};
    if (allowedValue === "NONE") return {
      disabled: true
    };
    if (allowedValue && allowedValue === value) return {};
    return {
      disabled: true
    };
  };

  var getOptions = function getOptions(dataProvider, comboId, defaultValue, allowedValue) {
    return dataProvider.map(function (comboData, index) {
      var value = _typeof(comboData) === 'object' ? comboData.value : comboData; //|| index;

      var label = _typeof(comboData) === 'object' ? comboData.label : comboData; //|| index;
      // const selected=defaultValue === value ? {'selected':true} : {} ;

      var disabled = getDisabledOptions(allowedValue, value); // const 

      return /*#__PURE__*/_react["default"].createElement("option", _extends({}, disabled, {
        value: value,
        key: value + '__' + comboId + '__' + index
      }), label);
    });
  };

  var onChange = function onChange(evt) {
    var value = evt.currentTarget.value;
    setValue(value);
    props.optionChange(props.name, value);
  };

  var dataProvider = props.dataProvider || [];
  var comboId = props.name;
  var options = getOptions(dataProvider, comboId, props.defaultValue, props.allowedValue);
  var title = props.title || '';
  var isDisabled = props.isDisabled ? {
    disabled: true
  } : {};
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: props.groupClassName
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__form__help"
  }, /*#__PURE__*/_react["default"].createElement("label", {
    className: props.labelClassName,
    htmlFor: comboId
  }, title), props.addHelpComponent && /*#__PURE__*/_react["default"].createElement(_HelpComponent.HelpComponent, {
    text: props.help
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "hideEmpty"
  }, props.selErrorReporting), /*#__PURE__*/_react["default"].createElement("select", _extends({
    value: value
  }, isDisabled, {
    name: comboId,
    className: props.selectClassName,
    onChange: onChange
  }), options));
};

exports.BaseSelectComponent = BaseSelectComponent;
BaseSelectComponent.propTypes = {
  defaultValue: _propTypes["default"].string,
  groupClassName: _propTypes["default"].string,
  selectClassName: _propTypes["default"].string,
  labelClassName: _propTypes["default"].string,
  name: _propTypes["default"].string.isRequired,
  optionChange: _propTypes["default"].func.isRequired,
  title: _propTypes["default"].string,
  showLabel: _propTypes["default"].bool,
  selErrorReporting: _propTypes["default"].string,
  addHelpComponent: _propTypes["default"].bool,
  dataProvider: _propTypes["default"].array
};
BaseSelectComponent.defaultProps = {
  defaultValue: '',
  groupClassName: 'tdb__form__group',
  selectClassName: 'tdb__form__element',
  labelClassName: 'tdb__form__label',
  title: '',
  showLabel: true,
  addHelpComponent: true,
  selErrorReporting: '',
  dataProvider: []
};