"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseSelectReactElement = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactSelect = _interopRequireDefault(require("react-select"));

var _HelpComponent = require("./HelpComponent");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var BaseSelectReactElement = function BaseSelectReactElement(props) {
  var _useState = (0, _react.useState)(props.defaultValue),
      _useState2 = _slicedToArray(_useState, 2),
      selectedOption = _useState2[0],
      setSelectedOption = _useState2[1];

  var onChange = function onChange(selectedValue) {
    if (!selectedOption || selectedValue && selectedOption.value !== selectedValue.value) {
      if (props.resetSelection) {
        setSelectedOption(null);
      } else {
        setSelectedOption(selectedValue);
      }

      props.optionChange(props.name, selectedValue.value);
    }
  };

  (0, _react.useEffect)(function () {
    var defVal = props.defaultValue;

    if (selectedOption && defVal.value !== selectedOption.value) {
      setSelectedOption(props.defaultValue);
    }
  }, [props.defaultValue]);
  var dataProvider = props.dataProvider || [];
  var isClearable = props.isClearable === false ? false : true;
  var isDisabled = props.isDisabled ? true : false; //

  var value = selectedOption !== null ? {
    value: selectedOption
  } : {};
  var itemError = selectedOption === null ? props.itemError : '';
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: props.groupClassName
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__form__help"
  }, /*#__PURE__*/_react["default"].createElement("label", {
    className: props.labelClassName
  }, props.title), /*#__PURE__*/_react["default"].createElement(_HelpComponent.HelpComponent, {
    text: props.help
  })), /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], {
    value: selectedOption,
    isClearable: isClearable,
    onChange: onChange,
    options: dataProvider,
    placeholder: props.placeholder,
    isDisabled: isDisabled
  }), /*#__PURE__*/_react["default"].createElement("span", {
    className: "tdb__form__error"
  }, itemError));
};

exports.BaseSelectReactElement = BaseSelectReactElement;
BaseSelectReactElement.propTypes = {
  defaultValue: _propTypes["default"].object,
  groupClassName: _propTypes["default"].string,
  inputClassName: _propTypes["default"].string,
  name: _propTypes["default"].string.isRequired,
  optionChange: _propTypes["default"].func.isRequired,
  dataProvider: _propTypes["default"].array,
  placeholder: _propTypes["default"].string
};
BaseSelectReactElement.defaultProps = {
  groupClassName: 'tdb__form__group',
  labelClassName: 'tdb__form__label',
  title: '',
  placeholder: 'Select an Item',
  dataProvider: []
};