"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ChoiceList = void 0;

var _react = _interopRequireWildcard(require("react"));

var _BaseInputElement = require("./BaseInputElement");

var _Accordion = require("../../form/Accordion");

var _ListComponent = require("./ListComponent");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

//import Select from 'react-select';
//import {ADD_NEW_CHOICE,REMOVE_CHOICE} from '../../constants/ActionTypes'
var ChoiceList = function ChoiceList(props) {
  var _useState = (0, _react.useState)(props.choices || []),
      _useState2 = _slicedToArray(_useState, 2),
      choicesList = _useState2[0],
      setChoiceList = _useState2[1];

  var _useState3 = (0, _react.useState)(''),
      _useState4 = _slicedToArray(_useState3, 2),
      labelValue = _useState4[0],
      setLabel = _useState4[1];

  var _useState5 = (0, _react.useState)(''),
      _useState6 = _slicedToArray(_useState5, 2),
      commentValue = _useState6[0],
      setComment = _useState6[1];

  var _useState7 = (0, _react.useState)(''),
      _useState8 = _slicedToArray(_useState7, 2),
      idValue = _useState8[0],
      setId = _useState8[1];

  var _useState9 = (0, _react.useState)(''),
      _useState10 = _slicedToArray(_useState9, 2),
      idReqError = _useState10[0],
      setIdReqError = _useState10[1];

  var addNewBox = function addNewBox() {
    if (!idValue) {
      setIdReqError('This item is required');
    } else {
      var tmpList = choicesList.slice();
      tmpList.push({
        label: labelValue,
        comment: commentValue,
        id: idValue
      }); //setItemData({label:'',comment:'',id:''})

      setComment("");
      setLabel("");
      setId("");
      setChoiceList(tmpList);
      if (props.updateChoiseList) props.updateChoiseList(tmpList);
    }
  };

  var removeChoice = function removeChoice(choiceName) {
    var index = choicesList.findIndex(function (x) {
      return x.id === choiceName;
    });
    var tmpList = choicesList.slice();
    tmpList.splice(index, 1);
    setChoiceList(tmpList);
    if (props.updateChoiseList) props.updateChoiseList(tmpList);
  };

  var onBlur = function onBlur(name, value) {
    switch (name) {
      case "comment":
        setComment(value);
        break;

      case "label":
        setLabel(value);
        break;

      case "id":
        var idval = value.trim();
        setId(idval);

        if (idval.indexOf(" ") > -1) {
          setIdReqError("Please remove all the white space");
          return;
        }

        if (idval === "") {
          setIdReqError("Please enter a valid ID");
          return;
        }

        if (idval !== '') setIdReqError('');
        break;
    }
  };

  var title = 'Values';
  var choiceTitle = 'Add a value';
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__box"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "tdb__panel__subtitle"
  }, title), /*#__PURE__*/_react["default"].createElement(_ListComponent.ListComponent, {
    dataProvider: choicesList,
    removeItem: removeChoice
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__box"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "tdb__panel__subtitle"
  }, "New Value"), /*#__PURE__*/_react["default"].createElement(_BaseInputElement.BaseInputElement, {
    help: "choice_id",
    itemError: idReqError,
    title: "ID",
    name: "id",
    onBlur: onBlur,
    defaultValue: idValue
  }), /*#__PURE__*/_react["default"].createElement(_BaseInputElement.BaseInputElement, {
    help: "choice_label",
    title: "Label",
    name: "label",
    onBlur: onBlur,
    defaultValue: labelValue
  }), /*#__PURE__*/_react["default"].createElement(_BaseInputElement.BaseInputElement, {
    help: "choice_comment",
    title: "Comment",
    name: "comment",
    onBlur: onBlur,
    defaultValue: commentValue
  }), /*#__PURE__*/_react["default"].createElement("button", {
    className: "tdb__button__base tdb__button__base--green",
    onClick: addNewBox
  }, choiceTitle)));
}; //<Select onChange={this.onChangeSelection} isClearable={true} options={modelChoicesListValue} placeholder="Add a Choice"/>


exports.ChoiceList = ChoiceList;