"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DetailsModelComponent = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Accordion = require("../../form/Accordion");

var _reactResponsiveTabs = _interopRequireDefault(require("react-responsive-tabs"));

var _BaseElement = require("./BaseElement");

require("react-responsive-tabs/styles.css");

var _ConstraintsComponent = require("./ConstraintsComponent");

var _ParentsFilter = require("./ParentsFilter");

var _PropertiesComponent = require("./PropertiesComponent");

var _detailsLabels = require("../../constants/details-labels");

var _ChoiceList = require("./ChoiceList");

var _elementsName = require("../utils/elementsName");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var DetailsModelComponent = function DetailsModelComponent(props) {
  var _useState = (0, _react.useState)(1),
      _useState2 = _slicedToArray(_useState, 2),
      tabKey = _useState2[0],
      setTabKey = _useState2[1];

  var nodeData = props.currentNodeJson ? props.currentNodeJson : {};
  var objPropsRelatedToClass = props.objPropsRelatedToClass || [];
  var childrenArr = nodeData.allChildren || [];
  var hasConstraints = childrenArr.length > 0 || objPropsRelatedToClass.length > 0 ? true : false;
  var imageType = _detailsLabels.ELEMENT_ICONS[nodeData.type];
  var title = (0, _elementsName.getLabelByName)(nodeData.type);
  (0, _react.useEffect)(function () {
    setTabKey(1);
  }, [props.currentNodeJson]);

  var getTabs = function getTabs() {
    var tabsArr = [];
    tabsArr.push({
      title: title,
      getContent: function getContent() {
        return /*#__PURE__*/_react["default"].createElement(_BaseElement.BaseElement, {
          key: "base__".concat(nodeData.name),
          removeElement: props.removeElement,
          showCardinality: false,
          hasConstraints: hasConstraints,
          nodeJsonData: nodeData,
          updateValue: props.updateValue
        });
      },
      key: 1,
      tabClassName: 'tab',
      panelClassName: 'tdb__panel'
    });

    if (nodeData.type === 'ChoiceClass') {
      tabsArr.push({
        title: 'Values',
        getContent: function getContent() {
          return /*#__PURE__*/_react["default"].createElement(_ChoiceList.ChoiceList, {
            key: "choice__".concat(nodeData.name),
            updateChoiseList: props.updateChoices,
            choices: nodeData.choices
          });
        },
        key: 2,
        tabClassName: 'tab',
        panelClassName: 'tdb__panel'
      });
    } else if (nodeData.type !== 'ChoiceClass') {
      tabsArr.push({
        title: 'Properties',
        getContent: function getContent() {
          return /*#__PURE__*/_react["default"].createElement(_PropertiesComponent.PropertiesComponent, {
            key: "properties__".concat(nodeData.name)
          });
        },
        key: 2,
        tabClassName: 'tab',
        panelClassName: 'tdb__panel'
      });
    }

    tabsArr.push({
      title: 'Relationships',
      getContent: function getContent() {
        return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_ConstraintsComponent.ConstraintsComponent, {
          key: "const__".concat(nodeData.name)
        }), /*#__PURE__*/_react["default"].createElement(_ParentsFilter.ParentsFilter, {
          key: "parent__".concat(nodeData.name)
        }));
      },
      key: 3,
      tabClassName: 'tab',
      panelClassName: 'tdb__panel'
    });
    return tabsArr;
  };

  var changeTab = function changeTab(key) {
    if (!currentNodeJson.id) {
      alert('please add a valid ID');
    } else {
      setTabKey(key);
    }
  };

  var label = nodeData.label || nodeData.id;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__sidebar"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__title"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "tdb__panel__title__icon ".concat(imageType)
  }), /*#__PURE__*/_react["default"].createElement("p", {
    className: "tdb__panel__label",
    title: label
  }, " ", label)), /*#__PURE__*/_react["default"].createElement(_reactResponsiveTabs["default"], {
    items: getTabs(),
    transform: false,
    onChange: setTabKey,
    selectedTabKey: tabKey
  }));
};

exports.DetailsModelComponent = DetailsModelComponent;
DetailsModelComponent.propTypes = {
  currentNodeJson: _propTypes["default"].object
};
DetailsModelComponent.defaultProps = {
  currentNodeJson: {}
};