"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InfoBoxComponent = void 0;

var _react = _interopRequireWildcard(require("react"));

var _detailsLabels = require("../../constants/details-labels");

var _graphObjectContext = require("../hook/graphObjectContext");

var _elementsName = require("../utils/elementsName");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var InfoBoxComponent = function InfoBoxComponent(props) {
  var _GraphContextObj = (0, _graphObjectContext.GraphContextObj)(),
      mainGraphObj = _GraphContextObj.mainGraphObj;

  var elementsNumber = mainGraphObj ? mainGraphObj.getElementsNumber() : {};
  var propertiesNum = elementsNumber.properties || 0;
  var entitiesNum = elementsNumber.entities || 0;
  var ordinaryClassesNum = elementsNumber.classes || 0;
  var choiceClassesNum = elementsNumber.choiceClasses || 0;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "RRT__container RRT__container--viewmode"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__title"
  }, props.dbName, " - Schema"), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb_panel"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__box"
  }, _detailsLabels.mainGraphDescriptionText), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__box"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "numElementMain"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "numElementBox",
    title: _detailsLabels.ELEMENT_DESCRIPTIONS.Document
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "window-icon custom-img-entities"
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "titleElement"
  }, "".concat(entitiesNum, " ").concat(_elementsName.CLASS_TYPE_NAME_LABEL.DOCUMENT_CLASSES))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "numElementBox",
    title: _detailsLabels.ELEMENT_DESCRIPTIONS.Class
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "window-icon custom-img-classes"
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "titleElement"
  }, "".concat(ordinaryClassesNum, " ").concat(_elementsName.CLASS_TYPE_NAME_LABEL.OBJECT_CLASSES)))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "numElementMain"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "numElementBox",
    title: _detailsLabels.ELEMENT_DESCRIPTIONS.ChoiceClass
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "window-icon custom-img-choice"
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "titleElement"
  }, "".concat(choiceClassesNum, " ").concat(_elementsName.CLASS_TYPE_NAME_LABEL.CHOICE_CLASSES))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "numElementBox",
    title: _detailsLabels.ELEMENT_DESCRIPTIONS.Properties
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "window-icon custom-img-view"
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "titleElement"
  }, propertiesNum, " ", propertiesNum == 1 ? "Property" : "Properties"))))));
};

exports.InfoBoxComponent = InfoBoxComponent;