"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InfoObjectComponent = void 0;

var _react = _interopRequireWildcard(require("react"));

var _detailsLabels = require("../../constants/details-labels");

var _graphObjectContext = require("../hook/graphObjectContext");

var _elementsName = require("../utils/elementsName");

var _BaseLabelsElementViewMode = require("./viewMode/BaseLabelsElementViewMode");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var InfoObjectComponent = function InfoObjectComponent(props) {
  var _GraphContextObj = (0, _graphObjectContext.GraphContextObj)(),
      mainGraphObj = _GraphContextObj.mainGraphObj,
      changeCurrentNode = _GraphContextObj.changeCurrentNode;

  var imageType = _detailsLabels.ELEMENT_ICONS[props.panelType];
  var elementList = [];
  var title = '';
  var description = '';

  switch (props.panelType) {
    case _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASSES:
      title = _elementsName.CLASS_TYPE_NAME_LABEL.DOCUMENT_CLASSES;
      description = _detailsLabels.ELEMENT_DESCRIPTIONS.Document;
      elementList = mainGraphObj.getDocumentTypeList();
      break;

    case _elementsName.CLASS_TYPE_NAME.OBJECT_CLASSES:
      title = _elementsName.CLASS_TYPE_NAME_LABEL.OBJECT_CLASSES;
      description = _detailsLabels.ELEMENT_DESCRIPTIONS.Object;
      elementList = mainGraphObj.getObjectTypeList();
      break;

    case _elementsName.CLASS_TYPE_NAME.CHOICE_CLASSES:
      title = _elementsName.CLASS_TYPE_NAME_LABEL.CHOICE_CLASSES;
      description = _detailsLabels.ELEMENT_DESCRIPTIONS.ChoiceClass;
      elementList = mainGraphObj.getObjectChoices();
      break;
  }

  var selectNode = function selectNode(elementName) {
    changeCurrentNode(elementName, true);
  };

  var getElementList = function getElementList() {
    return elementList.map(function (element, index) {
      var elementName = element.name || element;
      var nodeElement = mainGraphObj.getElement(elementName);
      if (nodeElement) return /*#__PURE__*/_react["default"].createElement(_BaseLabelsElementViewMode.BaseLabelsElementViewMode, {
        key: 'element__' + index,
        name: elementName,
        onClick: selectNode,
        value: nodeElement.label || nodeElement.id
      });else return '';
    });
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "RRT__container RRT__container--viewmode"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__title"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "tdb__panel__title__icon ".concat(imageType)
  }), title), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__box"
  }, description), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__box"
  }, getElementList())));
};

exports.InfoObjectComponent = InfoObjectComponent;