"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ModelMainHeaderComponent = void 0;

var _react = _interopRequireWildcard(require("react"));

var _ToogleButton = require("./ToogleButton");

var _detailsLabels = require("../../constants/details-labels");

var _actionType = require("../utils/actionType");

var _elementsName = require("../utils/elementsName");

var _graphObjectContext = require("../hook/graphObjectContext");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ModelMainHeaderComponent = function ModelMainHeaderComponent(props) {
  var _GraphContextObj = (0, _graphObjectContext.GraphContextObj)(),
      setNodeAction = _GraphContextObj.setNodeAction,
      resetTreeModel = _GraphContextObj.resetTreeModel;

  var viewEdit = props.isEditMode === true ? true : false;

  var _useState = (0, _react.useState)(''),
      _useState2 = _slicedToArray(_useState, 2),
      commitMessage = _useState2[0],
      setCommitMessage = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      showExtraTools = _useState4[0],
      setShowExtraTools = _useState4[1];

  var commitChange = function commitChange(evt) {
    var value = evt.currentTarget.value;
    setCommitMessage(value);
  };

  (0, _react.useEffect)(function () {
    setShowExtraTools(true);
  }, [props.extraTools]);
  var style = {
    style: {
      visibility: 'hidden'
    }
  };

  if (viewEdit) {
    style = {};
  }

  var saveData = function saveData() {
    props.saveData(commitMessage);
    setCommitMessage('');
  };

  var setZoomIn = function setZoomIn() {
    props.setZoomEvent({
      type: 'ZOOM_IN',
      'zoom': Date.now()
    });
  };

  var setZoomOut = function setZoomOut() {
    props.setZoomEvent({
      type: 'ZOOM_OUT',
      'zoom': Date.now()
    });
  };

  var setResetView = function setResetView() {
    props.setZoomEvent({
      type: 'RESET_ZOOM',
      'zoom': Date.now()
    });
  };

  var addDocumentType = function addDocumentType() {
    setNodeAction(_actionType.ADD_NEW_ENTITY, _elementsName.CLASS_TYPE_NAME.SCHEMA_ROOT, true);
  };

  var addObjectType = function addObjectType() {
    setNodeAction(_actionType.ADD_NEW_CLASS, _elementsName.CLASS_TYPE_NAME.SCHEMA_ROOT, true);
  };

  var addChoiceType = function addChoiceType() {
    setNodeAction(_actionType.ADD_NEW_CHOICE_CLASS, _elementsName.CLASS_TYPE_NAME.SCHEMA_ROOT, true);
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__hright"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__hright"
  }, showExtraTools && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, props.extraTools)), /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: "tdb__model__hright"
  }, style), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__node tdb__model__node--doc"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "custom-img-entities",
    title: "Add ".concat(_elementsName.CLASS_TYPE_NAME_LABEL.DOCUMENT_CLASSES),
    onClick: addDocumentType
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__node tdb__model__node--class"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "custom-img-classes",
    title: "Add ".concat(_elementsName.CLASS_TYPE_NAME_LABEL.OBJECT_CLASSES),
    onClick: addObjectType
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__node tdb__model__node--choice"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "custom-img-choice",
    title: "Add ".concat(_elementsName.CLASS_TYPE_NAME_LABEL.CHOICE_CLASSES),
    onClick: addChoiceType
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__hright"
  }, props.view == _detailsLabels.DEFAULT_SCHEMA_VIEW && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, " ", /*#__PURE__*/_react["default"].createElement("div", {
    className: "icon-header"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "fa fa-search-plus",
    title: _detailsLabels.TOOLBAR_LABELS.ZoomInTooltip,
    onClick: setZoomIn
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "icon-header"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "fa fa-search-minus",
    title: _detailsLabels.TOOLBAR_LABELS.ZoomOutTooltip,
    onClick: setZoomOut
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "icon-header"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "fa fa-circle-notch",
    title: _detailsLabels.TOOLBAR_LABELS.ResetViewPoint,
    onClick: setResetView
  })), " ")), /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: "tdb__model__hright"
  }, style), props.view == _detailsLabels.DEFAULT_SCHEMA_VIEW && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "icon-header"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "fa fa-sync",
    title: _detailsLabels.TOOLBAR_LABELS.ResetButtonTooltip,
    onClick: function onClick(e) {
      return window.confirm("If you continue, you'll lose the schema's changes") && resetTreeModel();
    }
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__savebox"
  }, /*#__PURE__*/_react["default"].createElement("input", {
    className: "tdb__form__element",
    value: commitMessage,
    onChange: commitChange,
    placeholder: "Add commit message"
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "icon-header--abs"
  }, /*#__PURE__*/_react["default"].createElement(_ToogleButton.ToogleButton, {
    baseTooltip: _detailsLabels.TOOLBAR_LABELS.SaveButtonTooltip,
    baseIcon: "fa fa-save",
    selectIcon: "fa fa-save",
    isSelected: false,
    selectClassName: "tdb__button__base tdb__panel__button",
    name: "SAVE_BUTTON",
    onSelectionChange: saveData
  }))))), props.view == _detailsLabels.DEFAULT_SCHEMA_VIEW && /*#__PURE__*/_react["default"].createElement("div", {
    className: "icon-header"
  }, /*#__PURE__*/_react["default"].createElement(_ToogleButton.ToogleButton, {
    onSelectionChange: props.changeMode,
    baseTooltip: _detailsLabels.TOOLBAR_LABELS.EditModeTooltip,
    selectedTooltip: _detailsLabels.TOOLBAR_LABELS.ViewModeTooltip,
    baseIcon: "fa fa-edit",
    selectIcon: "fa fa-edit",
    isSelected: viewEdit
  })), props.view == _detailsLabels.DEFAULT_SCHEMA_VIEW && /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__iclose"
  }, /*#__PURE__*/_react["default"].createElement(_ToogleButton.ToogleButton, {
    name: "PANEL_OPEN_BUTTON",
    isSelected: props.panelIsOpen,
    baseIcon: "fas fa-sign-in-alt fa-flip-horizontal",
    selectIcon: "fas fa-sign-in-alt",
    onSelectionChange: props.openClosePanel
  })));
};

exports.ModelMainHeaderComponent = ModelMainHeaderComponent;