"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ObjectProperty = void 0;

var _react = _interopRequireWildcard(require("react"));

var _BasePropertyComponent = require("./BasePropertyComponent");

var _BaseSelectReactElement = require("./BaseSelectReactElement");

var _detailsLabels = require("../../constants/details-labels");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ObjectProperty = function ObjectProperty(props) {
  var currentNodeJson = props.currentNodeJson || {};
  var id = props.id;
  var dataProvider = props.comboDataProvider || [];
  var errorMessage = "Please select an element";

  var getSelectedValue = function getSelectedValue() {
    if (currentNodeJson.range) {
      var rangeValue = dataProvider.find(function (element) {
        return element.name === currentNodeJson.range;
      });
      if (rangeValue) return {
        label: rangeValue.label,
        name: rangeValue.name,
        value: rangeValue.value
      };
    }

    return null;
  };

  var defaultValue = getSelectedValue();

  var onChangeValue = function onChangeValue(propName, newValue) {
    props.updateValue(propName, newValue, currentNodeJson);
  };
  /*
  * very Important the displayAll must be === false for complex property
  * because the complex property of an EntityClass can have
  * herself as range
  */


  return /*#__PURE__*/_react["default"].createElement(_BasePropertyComponent.BasePropertyComponent, props, /*#__PURE__*/_react["default"].createElement(_BaseSelectReactElement.BaseSelectReactElement, {
    itemError: errorMessage,
    title: props.title,
    optionChange: onChangeValue,
    defaultValue: defaultValue,
    placeholder: props.placeholder,
    resetSelection: false,
    isClearable: false,
    dataProvider: dataProvider,
    name: "range"
  }));
};

exports.ObjectProperty = ObjectProperty;