"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ParentsFilter = void 0;

var _react = _interopRequireWildcard(require("react"));

var _actionType = require("../utils/actionType");

var _ListComponent = require("./ListComponent");

var _BaseSelectReactElement = require("./BaseSelectReactElement");

var _BaseSelectComponent = require("./BaseSelectComponent");

var _ParentsElementViewMode = require("./viewMode/ParentsElementViewMode");

var _graphObjectContext = require("../hook/graphObjectContext");

var _Accordion = require("../../form/Accordion");

var _elementsName = require("../utils/elementsName");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ParentsFilter = function ParentsFilter(props) {
  var _GraphContextObj = (0, _graphObjectContext.GraphContextObj)(),
      selectedNodeObject = _GraphContextObj.selectedNodeObject,
      graphDataProvider = _GraphContextObj.graphDataProvider,
      updateParentsList = _GraphContextObj.updateParentsList,
      availableParentsList = _GraphContextObj.availableParentsList;

  var _useState = (0, _react.useState)(_elementsName.CLASS_TYPE_NAME.OBJECT_CLASSES),
      _useState2 = _slicedToArray(_useState, 2),
      classType = _useState2[0],
      setClassType = _useState2[1];

  var _useState3 = (0, _react.useState)(null),
      _useState4 = _slicedToArray(_useState3, 2),
      dataProvider = _useState4[0],
      setDataProvider = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      showAddParentsBox = _useState6[0],
      setShowAddParentsBox = _useState6[1];

  var _useState7 = (0, _react.useState)(false),
      _useState8 = _slicedToArray(_useState7, 2),
      showComboObjectType = _useState8[0],
      setShowComboObjectType = _useState8[1];

  var parentClassType = selectedNodeObject.type;
  var placeholder = "Add ".concat((0, _elementsName.getLabelByName)(classType), "  as Parent");

  var getClassDataProvider = function getClassDataProvider(classTypeName) {
    var dataProvider = [];

    switch (classTypeName) {
      case _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASS:
        classTypeName = _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASSES;

        if (availableParentsList.objectClassArr.length === 0) {
          setShowComboObjectType(false);
        } else {
          setShowComboObjectType(true);
        }

      case _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASSES:
        dataProvider = availableParentsList.documentClassArr;
        break;

      case _elementsName.CLASS_TYPE_NAME.CHOICE_CLASS:
      case _elementsName.CLASS_TYPE_NAME.OBJECT_CLASS:
        /*
        * if the object type === "Object"
        */
        setShowComboObjectType(false);

      default:
        dataProvider = availableParentsList.objectClassArr; //.concat(props.ordinaryClassDataP)

        break;
    }

    setClassType(classTypeName);
    setDataProvider(dataProvider);
  };

  (0, _react.useEffect)(function () {
    if (!availableParentsList || availableParentsList.objectClassArr.length === 0 && availableParentsList.documentClassArr.length === 0) {
      setShowAddParentsBox(false);
    } else {
      setShowAddParentsBox(true);
      getClassDataProvider(selectedNodeObject.type);
    }
  }, [availableParentsList]);

  var changeParentList = function changeParentList(elementId, elementValue) {
    getClassDataProvider(elementValue);
  };
  /*
  * to be review the parameter orders
  */


  var addParent = function addParent(elementId, parentName) {
    updateParentsList(parentName, _actionType.ADD_PARENT);
  };

  var removeParent = function removeParent(selectedValue) {
    updateParentsList(selectedValue, _actionType.REMOVE_PARENT);
  };

  var elementClassList = [{
    label: _elementsName.CLASS_TYPE_NAME_LABEL.DOCUMENT_CLASSES,
    value: _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASSES
  }, {
    label: _elementsName.CLASS_TYPE_NAME_LABEL.OBJECT_CLASSES,
    value: _elementsName.CLASS_TYPE_NAME.OBJECT_CLASSES
  }];
  var elementId = selectedNodeObject.name;
  var elementType = selectedNodeObject.type;
  var title = 'Edit Parents';
  var tooltip = 'Tooltip';

  var getParentList = function getParentList() {
    var parents = selectedNodeObject.parents || [];
    var listParent = [];
    parents.forEach(function (parentName, index) {
      var elementObj = graphDataProvider.get(parentName);
      var elementData = elementObj.data;
      var label = elementData.label || elementData.id;
      listParent.push({
        name: elementData.name,
        label: label
      });
    });
    return listParent;
  };

  var listDataProvider = getParentList();
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__title tdb__panel__title--parent"
  }, "Parent List"), listDataProvider.length > 0 && /*#__PURE__*/_react["default"].createElement(_ParentsElementViewMode.ParentsElementViewMode, null), /*#__PURE__*/_react["default"].createElement(_Accordion.Accordion, {
    titleClassName: "tdb__accordion__head",
    title: "Add/Remove Parents",
    tooltip: "Add/Remove Parents"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__box"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__list"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__list__items"
  }, listDataProvider.length === 0 && 'No Parents', /*#__PURE__*/_react["default"].createElement(_ListComponent.ListComponent, {
    removeItem: removeParent,
    elementId: elementId,
    elementType: elementType,
    dataProvider: listDataProvider
  })), showAddParentsBox && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, showComboObjectType && /*#__PURE__*/_react["default"].createElement(_BaseSelectComponent.BaseSelectComponent, {
    defaultValue: classType,
    dataProvider: elementClassList,
    optionChange: changeParentList,
    showLabel: false,
    name: "elementsType"
  }), /*#__PURE__*/_react["default"].createElement(_BaseSelectReactElement.BaseSelectReactElement, {
    name: "addParent",
    resetSelection: true,
    isClearable: false,
    onChange: addParent,
    placeholder: placeholder,
    dataProvider: dataProvider,
    optionChange: addParent
  }))))));
};

exports.ParentsFilter = ParentsFilter;