"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PropertiesComponent = void 0;

var _react = _interopRequireWildcard(require("react"));

var _BasePropertyComponent = require("./BasePropertyComponent");

var _ObjectProperty = require("./ObjectProperty");

var _PropertyMenuList = require("./PropertyMenuList");

var _elementsName = require("../utils/elementsName");

var _detailsLabels = require("../../constants/details-labels");

var _graphObjectContext = require("../hook/graphObjectContext");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var PropertiesComponent = function PropertiesComponent(props) {
  var _GraphContextObj = (0, _graphObjectContext.GraphContextObj)(),
      updateValue = _GraphContextObj.updateValue,
      nodePropertiesList = _GraphContextObj.nodePropertiesList,
      addNewProperty = _GraphContextObj.addNewProperty,
      removeElement = _GraphContextObj.removeElement,
      objectPropertyList = _GraphContextObj.objectPropertyList,
      objectChoicesList = _GraphContextObj.objectChoicesList,
      selectedNodeObject = _GraphContextObj.selectedNodeObject;

  var enumDisabled = !objectChoicesList || objectChoicesList.length === 0 ? true : false;

  var getPropertiesPanels = function getPropertiesPanels() {
    var showBody = true;
    /*
    *I open the first property
    */

    return nodePropertiesList.map(function (propertyItem, index) {
      if (index > 0) showBody = false;
      var baseObj = {
        showBody: showBody,
        currentNodeJson: propertyItem,
        removeElement: removeElement,
        updateValue: updateValue
      };

      switch (propertyItem.type) {
        case _elementsName.PROPERTY_TYPE_NAME.CHOICE_PROPERTY:
          baseObj['showCardinality'] = false;
          baseObj['comboDataProvider'] = objectChoicesList || [];
          baseObj['title'] = "".concat(_elementsName.CLASS_TYPE_NAME_LABEL.CHOICE_CLASS, " Type *");
          baseObj['placeholder'] = "Select ".concat(_elementsName.CLASS_TYPE_NAME_LABEL.CHOICE_CLASS, " Type");
          return /*#__PURE__*/_react["default"].createElement(_ObjectProperty.ObjectProperty, _extends({}, baseObj, {
            key: propertyItem.name
          }));

        case _elementsName.PROPERTY_TYPE_NAME.NUMERIC_PROPERTY:
          baseObj['selectDataProvider'] = _detailsLabels.NUMBER_PROPERTY_PRECISION_DATAPROVIDER;
          return /*#__PURE__*/_react["default"].createElement(_BasePropertyComponent.BasePropertyComponent, _extends({}, baseObj, {
            key: propertyItem.name
          }));

        case _elementsName.PROPERTY_TYPE_NAME.STRING_PROPERTY:
          baseObj['selectDataProvider'] = _detailsLabels.STRING_TYPE_DATAPROVIDER;
          return /*#__PURE__*/_react["default"].createElement(_BasePropertyComponent.BasePropertyComponent, _extends({}, baseObj, {
            key: propertyItem.name
          }));

        case _elementsName.PROPERTY_TYPE_NAME.GEO_PROPERTY:
          baseObj['selectDataProvider'] = _detailsLabels.GEOMETRY_PROPS_DATAPROVIDER;
          return /*#__PURE__*/_react["default"].createElement(_BasePropertyComponent.BasePropertyComponent, _extends({}, baseObj, {
            key: propertyItem.name
          }));

        case _elementsName.PROPERTY_TYPE_NAME.TEMPORAL_PROPERTY:
          baseObj['selectDataProvider'] = _detailsLabels.TEMPORAL_PROPERTY_DATAPROVIDER;
          return /*#__PURE__*/_react["default"].createElement(_BasePropertyComponent.BasePropertyComponent, _extends({}, baseObj, {
            key: propertyItem.name
          }));

        case _elementsName.PROPERTY_TYPE_NAME.OBJECT_PROPERTY:
          baseObj['title'] = 'Links To Type *';
          baseObj['placeholder'] = 'Select Type';
          baseObj['comboDataProvider'] = objectPropertyList || [];
          return /*#__PURE__*/_react["default"].createElement(_ObjectProperty.ObjectProperty, _extends({}, baseObj, {
            key: propertyItem.name
          }));

        default:
          return '';
      }
    });
  };

  var propertiesPanels = getPropertiesPanels(nodePropertiesList);
  return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_PropertyMenuList.PropertyMenuList, {
    enumDisabled: enumDisabled,
    buttonIconClassName: "menuWithLabel",
    iconClassName: "fa fa-caret-down iconWithLabel",
    dropdownMenuClassName: "dropdownMenuProperty rightPosition",
    addNewProperty: addNewProperty
  }), propertiesPanels);
};

exports.PropertiesComponent = PropertiesComponent;