"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RemoveElementComponent = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var RemoveElementComponent = function RemoveElementComponent(props) {
  var tooltip = props.hasConstraints ? "This node cannot be removed" : "Remove the current ".concat(props.elementType);

  var removeElement = function removeElement() {
    if (props.removeElement) {
      props.removeElement(props.elementId, props.elementType);
    }
  };

  var onClick = props.hasConstraints === true ? {
    disabled: true
  } : {
    onClick: removeElement
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__row"
  }, /*#__PURE__*/_react["default"].createElement("button", _extends({}, onClick, {
    className: "tdb__button__base tdb__panel__button tdb__panel__button--red fas fa-trash-alt",
    title: props.tooltip
  }), props.children));
};

exports.RemoveElementComponent = RemoveElementComponent;