"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ToogleButton = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var ToogleButton = function ToogleButton(props) {
  var isSelected = props.isSelected === true ? true : false;
  var baseTooltip = props.baseTooltip || '';
  var selectedTooltip = props.selectedTooltip || baseTooltip;
  var className = isSelected ? "".concat(props.selectIcon, " ").concat(props.selectClassName) : "".concat(props.baseIcon, " ").concat(props.baseClassName);
  var tooltip = isSelected ? selectedTooltip : baseTooltip;

  var onClick = function onClick() {
    if (props.onSelectionChange) props.onSelectionChange(!isSelected);
  };

  return /*#__PURE__*/_react["default"].createElement("button", {
    name: props.name,
    onClick: onClick,
    className: className,
    title: tooltip
  }, props.children);
};

exports.ToogleButton = ToogleButton;
ToogleButton.propTypes = {
  baseTooltip: _propTypes["default"].string,
  selectedTooltip: _propTypes["default"].string,
  baseClassName: _propTypes["default"].string,
  selectClassName: _propTypes["default"].string,
  buttonIsSelected: _propTypes["default"].bool,
  onSelectionChange: _propTypes["default"].func,
  baseIcon: _propTypes["default"].string,
  selectIcon: _propTypes["default"].string
};
ToogleButton.defaultProps = {
  baseClassName: 'tdb__button__base tdb__panel__button',
  selectClassName: 'tdb__button__base tdb__panel__button tdb__panel__button--selected',
  buttonIsSelected: false,
  baseIcon: '',
  selectIcon: ''
};