"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseSchemaElementViewMode = void 0;

var _react = _interopRequireDefault(require("react"));

var _BaseLabelsElementViewMode = require("./BaseLabelsElementViewMode");

var _detailsLabels = require("../../../constants/details-labels");

var _bi = require("react-icons/bi");

var _elementsName = require("../../utils/elementsName");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var BaseSchemaElementViewMode = function BaseSchemaElementViewMode(props) {
  var onClickEvent = {};
  var currentNodeJson = props.currentNodeJson || {};

  var selectNode = function selectNode(elementName) {
    props.changeCurrentNode(elementName, true);
  };

  var filterRangeValue = function filterRangeValue() {
    var rangeStr = currentNodeJson.range; //I have to review this

    if (currentNodeJson.type === _elementsName.PROPERTY_TYPE_NAME.CHOICE_PROPERTY || _elementsName.PROPERTY_TYPE_NAME.OBJECT_PROPERTY) {
      if (props.mainGraphObj) {
        var node = props.mainGraphObj.getElement(currentNodeJson.range);

        if (node) {
          rangeStr = node.id;
        }
      }

      onClickEvent = {
        onClick: selectNode
      };
    }

    return rangeStr;
  };

  var onClickId = props.idLink === true ? {
    onClick: selectNode
  } : {};
  var rangeValue = currentNodeJson.range ? filterRangeValue() : '';
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__box tdb__panel__box--hideEmpty"
  }, currentNodeJson["abstract"] && /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__row"
  }, /*#__PURE__*/_react["default"].createElement(_bi.BiBorderNone, {
    className: "tdb__panel__title__icon",
    title: "Abstract Class"
  })), currentNodeJson.id && /*#__PURE__*/_react["default"].createElement(_BaseLabelsElementViewMode.BaseLabelsElementViewMode, _extends({
    name: currentNodeJson.name
  }, onClickId, {
    label: _detailsLabels.ELEMENT_BASE_CONST.ID_TEXT,
    value: currentNodeJson.id
  })), currentNodeJson.comment && /*#__PURE__*/_react["default"].createElement(_BaseLabelsElementViewMode.BaseLabelsElementViewMode, {
    label: _detailsLabels.ELEMENT_BASE_CONST.DESCRIPTION_TEXT,
    value: currentNodeJson.comment
  }), currentNodeJson.min && /*#__PURE__*/_react["default"].createElement(_BaseLabelsElementViewMode.BaseLabelsElementViewMode, {
    label: _detailsLabels.CARDINALITY_MIN_TITLE,
    value: currentNodeJson.min
  }), currentNodeJson.max && /*#__PURE__*/_react["default"].createElement(_BaseLabelsElementViewMode.BaseLabelsElementViewMode, {
    label: _detailsLabels.CARDINALITY_MAX_TITLE,
    value: currentNodeJson.max
  }), currentNodeJson.range && /*#__PURE__*/_react["default"].createElement(_BaseLabelsElementViewMode.BaseLabelsElementViewMode, _extends({}, onClickEvent, {
    name: currentNodeJson.range,
    label: "Range Type",
    value: rangeValue
  })));
};

exports.BaseSchemaElementViewMode = BaseSchemaElementViewMode;