"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ObjectClassModelViewMode = void 0;

var _react = _interopRequireWildcard(require("react"));

var _BaseSchemaElementViewMode = require("./BaseSchemaElementViewMode");

var _PropertiesComponentViewMode = require("./PropertiesComponentViewMode");

var _ParentsElementViewMode = require("./ParentsElementViewMode");

var _elementsName = require("../../utils/elementsName");

var _detailsLabels = require("../../../constants/details-labels");

var _ListComponent = require("../ListComponent");

var _graphObjectContext = require("../../hook/graphObjectContext");

var _ConstraintsComponent = require("../ConstraintsComponent");

var _RelationshipView = require("../../relationshipView/RelationshipView");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ObjectClassModelViewMode = function ObjectClassModelViewMode(props) {
  var _GraphContextObj = (0, _graphObjectContext.GraphContextObj)(),
      selectedNodeObject = _GraphContextObj.selectedNodeObject,
      nodePropertiesList = _GraphContextObj.nodePropertiesList,
      changeCurrentNode = _GraphContextObj.changeCurrentNode,
      mainGraphObj = _GraphContextObj.mainGraphObj;

  var currentNodeJson = selectedNodeObject || {};
  var imageType = _detailsLabels.ELEMENT_ICONS[currentNodeJson.type];
  var childrenArr = currentNodeJson.allChildren || [];
  var id = currentNodeJson.id;
  var label = currentNodeJson.label || currentNodeJson.id;
  var propertiesDataProvider = [];
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "RRT__container RRT__container--viewmode"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__title"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "tdb__panel__title__icon ".concat(imageType)
  }), /*#__PURE__*/_react["default"].createElement("p", {
    className: "tdb__panel__label",
    title: label
  }, " ", label)), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel"
  }, /*#__PURE__*/_react["default"].createElement(_BaseSchemaElementViewMode.BaseSchemaElementViewMode, {
    currentNodeJson: currentNodeJson
  }), currentNodeJson.type === _elementsName.CLASS_TYPE_NAME.CHOICE_CLASS && /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("span", {
    className: "tdb__panel__title tdb__panel__title--parent"
  }, "Values"), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__box"
  }, /*#__PURE__*/_react["default"].createElement(_ListComponent.ListComponent, {
    dataProvider: currentNodeJson.choices
  }))), nodePropertiesList && nodePropertiesList.length > 0 && /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__title tdb__panel__title--prop"
  }, "Properties"), /*#__PURE__*/_react["default"].createElement(_PropertiesComponentViewMode.PropertiesComponentViewMode, {
    mainGraphObj: mainGraphObj,
    changeCurrentNode: changeCurrentNode,
    dataProvider: nodePropertiesList || []
  })), currentNodeJson.parents && currentNodeJson.parents.length > 0 && /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__title tdb__panel__title--parent"
  }, "Parent List"), /*#__PURE__*/_react["default"].createElement(_ParentsElementViewMode.ParentsElementViewMode, {
    id: props.id,
    title: 'Parents'
  })), /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__title tdb__panel__title--prop"
  }, "Relationships"), /*#__PURE__*/_react["default"].createElement(_ConstraintsComponent.ConstraintsComponent, null))));
};

exports.ObjectClassModelViewMode = ObjectClassModelViewMode;