"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ParentsElementViewMode = void 0;

var _react = _interopRequireDefault(require("react"));

var _BaseSchemaElementViewMode = require("./BaseSchemaElementViewMode");

var _PropertiesComponentViewMode = require("./PropertiesComponentViewMode");

var _Accordion = require("../../../form/Accordion");

var _graphObjectContext = require("../../hook/graphObjectContext");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var ParentsElementViewMode = function ParentsElementViewMode(props) {
  var _GraphContextObj = (0, _graphObjectContext.GraphContextObj)(),
      mainGraphObj = _GraphContextObj.mainGraphObj,
      selectedNodeObject = _GraphContextObj.selectedNodeObject,
      changeCurrentNode = _GraphContextObj.changeCurrentNode;

  var getParentElement = function getParentElement() {
    var parentElementArr = selectedNodeObject.parents;
    var parents = [];
    var displayAll = props.displayAll === false ? false : true;

    if (parentElementArr) {
      parents = parentElementArr.map(function (parentName, index) {
        var elementData = mainGraphObj.getElement(parentName);
        return /*#__PURE__*/_react["default"].createElement(_Accordion.Accordion, {
          titleClassName: "tdb__accordion__head--green",
          leftIconClassName: "custom-img-inherit-line",
          title: elementData.label,
          tooltip: elementData.comment,
          key: "parent__".concat(parentName)
        }, /*#__PURE__*/_react["default"].createElement(_BaseSchemaElementViewMode.BaseSchemaElementViewMode, {
          changeCurrentNode: changeCurrentNode,
          idLink: true,
          currentNodeJson: elementData
        }));
      });
    }

    return parents;
  };

  var parentsElementArr = props.parentsElementArr || [];
  var parentsElements = getParentElement(parentsElementArr);
  return /*#__PURE__*/_react["default"].createElement("div", null, parentsElements);
};

exports.ParentsElementViewMode = ParentsElementViewMode;