"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tree = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _d3Hierarchy = require("d3-hierarchy");

var _LinkTree = require("../link/LinkTree");

var _LinkProperty = require("../link/LinkProperty");

var _NodeTree = require("../node/NodeTree");

var _elementsName = require("../utils/elementsName");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

//import {ENTITIES_BUTTON, RELATIONSHIP_BUTTON,CLASSES_BUTTON} from '../../../constants/ObjectsName'
var Tree = function Tree(props) {
  var links = props.links || [];
  var nodes = props.nodes || [];
  var objectPropertyToRange = props.objectPropertyToRange || {};
  var nodeIndex = {};
  var nodesChildren = nodes.map(function (node, i) {
    var isSelected = false;
    if (props.selectedNode === node.data.name) isSelected = true;

    if (node.data.type === _elementsName.CLASS_TYPE_NAME.SCHEMA_GROUP && node.data.children.length === 0) {
      return '';
    }

    if (!nodeIndex[node.data.name]) {
      nodeIndex[node.data.name] = node;
      return /*#__PURE__*/_react["default"].createElement(_NodeTree.NodeTree, {
        setNodeAction: props.setNodeAction,
        nodeClick: props.nodeClick,
        isSelected: isSelected,
        id: node.data.name,
        node: node,
        nodex: node.x,
        nodey: node.y,
        key: 'node_' + i,
        isEditMode: props.isEditMode
      });
    }

    return '';
  });
  /*
  * CHECK MULTI PARENT
  */

  var linksChildren = [];

  var _loop = function _loop(souceName) {
    var source = nodeIndex[souceName];
    var children = source.data.allChildren || source.data.children || [];
    children.map(function (targetClass, i) {
      var isSelected = false;

      if (nodeIndex[targetClass.name]) {
        if (targetClass.name === props.selectedNode || source.data.name === props.selectedNode) {
          isSelected = true;
        }

        var linkData = {};
        linkData['target'] = nodeIndex[targetClass.name];
        linkData['source'] = source;
        var linkId = "".concat(souceName, "_").concat(targetClass.name);
        linksChildren.push( /*#__PURE__*/_react["default"].createElement("g", {
          className: "vx-group",
          transform: "translate(0, 0)",
          key: linkId
        }, /*#__PURE__*/_react["default"].createElement(_LinkTree.LinkTree, {
          link: linkData,
          isSelected: isSelected
        })));
      }
    });
  };

  for (var souceName in nodeIndex) {
    _loop(souceName);
  }
  /* let linksProperty=[];
      for (let rangeName in objectPropertyToRange){
          const target=nodeIndex[rangeName];
          let linkData={};
          //linkData['source']=source;
           const linkPropArr=objectPropertyToRange[rangeName];
           linkPropArr.forEach((property)=>{
              const source=nodeIndex[property.domain];
              linksProperty.push( 
                    <g className="vx-group" transform="translate(0, 0)" >
                        <LinkProperty label={property.label}  id={property.id} lineColor="#ff0000" source={source} target={target}/>
                    </g>)
          })
    }  */


  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("g", {
    className: "vx-group vx-tree",
    transform: "translate(0, 60)",
    id: "treeGraph"
  }, linksChildren, nodesChildren));
};

exports.Tree = Tree;