"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GraphObjectProvider = exports.GraphContextObj = exports.GraphContext = void 0;

var _react = _interopRequireWildcard(require("react"));

var _MainGraphObject = require("../MainGraphObject");

var _elementsName = require("../utils/elementsName");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var GraphContext = /*#__PURE__*/_react["default"].createContext();

exports.GraphContext = GraphContext;

var GraphContextObj = function GraphContextObj() {
  return (0, _react.useContext)(GraphContext);
};

exports.GraphContextObj = GraphContextObj;

var GraphObjectProvider = function GraphObjectProvider(_ref) {
  var _ref2;

  var mainGraphDataProvider = _ref.mainGraphDataProvider,
      children = _ref.children,
      dbName = _ref.dbName;

  var _useState = (0, _react.useState)(null),
      _useState2 = _slicedToArray(_useState, 2),
      graphDataProvider = _useState2[0],
      setGraphDataProvider = _useState2[1];

  var _useState3 = (0, _react.useState)({}),
      _useState4 = _slicedToArray(_useState3, 2),
      selectedNodeObject = _useState4[0],
      setSelectedNodeObject = _useState4[1];

  var _useState5 = (0, _react.useState)([]),
      _useState6 = _slicedToArray(_useState5, 2),
      nodePropertiesList = _useState6[0],
      setNodePropertiesList = _useState6[1];

  var _useState7 = (0, _react.useState)(false),
      _useState8 = _slicedToArray(_useState7, 2),
      isFocusOnNode = _useState8[0],
      setFocusOnNode = _useState8[1];

  var _useState9 = (0, _react.useState)({}),
      _useState10 = _slicedToArray(_useState9, 2),
      objectPropertyToRange = _useState10[0],
      setObjectPropertyToRange = _useState10[1];

  var _useState11 = (0, _react.useState)([]),
      _useState12 = _slicedToArray(_useState11, 2),
      objectChoicesList = _useState12[0],
      setObjectChoicesList = _useState12[1];

  var _useState13 = (0, _react.useState)([]),
      _useState14 = _slicedToArray(_useState13, 2),
      objectPropertyList = _useState14[0],
      setObjectPropertyList = _useState14[1];

  var _useState15 = (0, _react.useState)([]),
      _useState16 = _slicedToArray(_useState15, 2),
      objPropsRelatedToClass = _useState16[0],
      setObjPropsRelatedToClass = _useState16[1];

  var _useState17 = (0, _react.useState)(null),
      _useState18 = _slicedToArray(_useState17, 2),
      mainGraphObj = _useState18[0],
      setMainGraphObj = _useState18[1];

  var _useState19 = (0, _react.useState)(null),
      _useState20 = _slicedToArray(_useState19, 2),
      graphUpdateLabel = _useState20[0],
      setGraphUpdateLabel = _useState20[1];

  var _useState21 = (0, _react.useState)(null),
      _useState22 = _slicedToArray(_useState21, 2),
      classesListArr = _useState22[0],
      setClassesListArr = _useState22[1];

  var _useState23 = (0, _react.useState)(null),
      _useState24 = _slicedToArray(_useState23, 2),
      entitiesListArr = _useState24[0],
      setEntitiesListArr = _useState24[1];

  var _useState25 = (0, _react.useState)({}),
      _useState26 = _slicedToArray(_useState25, 2),
      availableParentsList = _useState26[0],
      setAvailableParentsList = _useState26[1];

  var _useState27 = (0, _react.useState)(false),
      _useState28 = _slicedToArray(_useState27, 2),
      needToSave = _useState28[0],
      setNeedToSave = _useState28[1];

  var _useState29 = (0, _react.useState)(),
      _useState30 = _slicedToArray(_useState29, 2),
      resetGraph = _useState30[0],
      setResetGraph = _useState30[1]; //let mainGraphObj;

  /*
  * create the mainGraphObject and format the data
  */


  (0, _react.useEffect)(function () {
    if (mainGraphDataProvider && mainGraphDataProvider.classesResult !== null) {
      var mainGraphObject = new _MainGraphObject.MainGraphObject(mainGraphDataProvider, dbName);
      setMainGraphObj(mainGraphObject);
      setGraphDataProvider(mainGraphObject.getDescendantsNode());
      setObjectPropertyList(mainGraphObject.getObjectProperties());
      setObjectChoicesList(mainGraphObject.getObjectChoices());
      setObjectPropertyToRange(mainGraphObject.objectPropertyToRange());
      resetSelection();
    }
  }, [mainGraphDataProvider, resetGraph]);

  var resetSelection = function resetSelection() {
    setSelectedNodeObject({});
    setNodePropertiesList([]);
    setObjPropsRelatedToClass([]);
    setAvailableParentsList({});
  };

  var changeCurrentNode = function changeCurrentNode(nodeId) {
    var focusOnNode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    if (selectedNodeObject.type === _elementsName.CLASS_TYPE_NAME.CHOICE_CLASS && selectedNodeObject.choices && selectedNodeObject.choices.length === 0) {
      alert("Please add at least one value at the node ".concat(selectedNodeObject.label || selectedNodeObject.id));
      return;
    }

    setFocusOnNode(focusOnNode);

    if (nodeId === null) {
      resetSelection();
    } else if (mainGraphObj && mainGraphObj.getElement(nodeId)) {
      setSelectedNodeObject(mainGraphObj.getElement(nodeId));
      setNodePropertiesList(mainGraphObj.getPropertyListByDomain(nodeId));
      setObjPropsRelatedToClass(mainGraphObj.getObjPropsRelatedToClass(nodeId));
      setAvailableParentsList(mainGraphObj.getAvailableParentsList(nodeId));
    }
  };

  var setNodeAction = function setNodeAction(actionName) {
    var nodeName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var focusOnNode = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var node_name = nodeName || selectedNodeObject.name;
    var nodeObject = mainGraphObj.nodeApplyAction(actionName, node_name);
    changeCurrentNode(nodeObject.name, focusOnNode);
  };

  var addNewProperty = function addNewProperty(propertyType, propertyRange) {
    var propertiesList = mainGraphObj.addNewPropertyToClass(selectedNodeObject.name, propertyType, propertyRange);
    setNodePropertiesList(propertiesList);
  };

  var removeElement = function removeElement(elementId, elementType) {
    switch (elementType) {
      case _elementsName.CLASS_TYPE_NAME.OBJECT_CLASS:
      case _elementsName.CLASS_TYPE_NAME.DOCUMENT_CLASS:
      case _elementsName.CLASS_TYPE_NAME.CHOICE_CLASS:
        mainGraphObj.removeElementInMainGraph(selectedNodeObject.name);
        resetSelection();
        break;

      default:
        var propertiesList = mainGraphObj.removePropertyToClass(selectedNodeObject.name, elementId);
        setNodePropertiesList(propertiesList);
    }
  };

  var updateValue = function updateValue(propName, propValue, elementDataObject) {
    mainGraphObj.changeElementDataValue(propName, propValue, elementDataObject);

    if (elementDataObject.type !== 'Property' && (propName === 'label' || propName === 'abstract')) {
      setGraphUpdateLabel(Date.now());
    }
  };

  var updateParentsList = function updateParentsList(parentName, action) {
    mainGraphObj.updateNodeParents(selectedNodeObject.name, parentName, action);
    setAvailableParentsList(mainGraphObj.getAvailableParentsList(selectedNodeObject.name));
    setGraphUpdateLabel(Date.now());
  };

  var updateChoices = function updateChoices(choicesList) {
    mainGraphObj.updateChoices(selectedNodeObject.name, choicesList);
  };

  var savedObjectToWOQL = function savedObjectToWOQL() {
    return mainGraphObj.savedObjectToWOQL();
  };

  var resetTreeModel = function resetTreeModel() {
    setResetGraph(Date.now());
  };

  return /*#__PURE__*/_react["default"].createElement(GraphContext.Provider, {
    value: (_ref2 = {
      resetTreeModel: resetTreeModel,
      mainGraphObj: mainGraphObj,
      objectPropertyToRange: objectPropertyToRange,
      graphDataProvider: graphDataProvider,
      selectedNodeObject: selectedNodeObject,
      nodePropertiesList: nodePropertiesList,
      graphUpdateLabel: graphUpdateLabel,
      changeCurrentNode: changeCurrentNode,
      setNodeAction: setNodeAction,
      updateValue: updateValue,
      addNewProperty: addNewProperty,
      removeElement: removeElement,
      objectPropertyList: objectPropertyList,
      objPropsRelatedToClass: objPropsRelatedToClass,
      savedObjectToWOQL: savedObjectToWOQL,
      updateParentsList: updateParentsList,
      availableParentsList: availableParentsList
    }, _defineProperty(_ref2, "mainGraphObj", mainGraphObj), _defineProperty(_ref2, "objectChoicesList", objectChoicesList), _defineProperty(_ref2, "updateChoices", updateChoices), _defineProperty(_ref2, "isFocusOnNode", isFocusOnNode), _defineProperty(_ref2, "needToSave", needToSave), _ref2)
  }, children) //entitiesListArr,
  //classesListArr
  ;
};

exports.GraphObjectProvider = GraphObjectProvider;