"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.modelCallServerHook = void 0;

var _react = _interopRequireWildcard(require("react"));

var _MainGraphObject = _interopRequireDefault(require("../MainGraphObject"));

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var modelCallServerHook = function modelCallServerHook(woqlClient, branch, ref) {
  var _useState = (0, _react.useState)({
    classesResult: null,
    propsResult: null,
    restResult: null
  }),
      _useState2 = _slicedToArray(_useState, 2),
      mainGraphDataProvider = _useState2[0],
      setResultMainGraph = _useState2[1];

  var _useState3 = (0, _react.useState)(null),
      _useState4 = _slicedToArray(_useState3, 2),
      reloadGraph = _useState4[0],
      setReloadGraph = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      callServerLoading = _useState6[0],
      setLoading = _useState6[1];

  var _useState7 = (0, _react.useState)(false),
      _useState8 = _slicedToArray(_useState7, 2),
      reportMessage = _useState8[0],
      setReport = _useState8[1];
  /*
  * create the mainGraphObject and format the data
  */


  (0, _react.useEffect)(function () {
    var loadGraphData = function loadGraphData() {
      setLoading(true);

      var classQuery = _terminusdbClient["default"].WOQL.lib().classesAndChoices(); //const classesResult = await woqlClient.query(classQuery);


      var propsQuery = _terminusdbClient["default"].WOQL.lib().properties(); //const propsResult = await woqlClient.query(propsQuery);


      var restictions = _terminusdbClient["default"].WOQL.quad("v:Restriction", "type", "owl:Restriction", "schema/main").quad("v:Restriction", "owl:onProperty", "v:Property", "schema/main").and(_terminusdbClient["default"].WOQL.opt().quad("v:Restriction", "owl:cardinality", "v:cardinality", "schema/main"), _terminusdbClient["default"].WOQL.opt().quad("v:Restriction", "owl:maxCardinality", "v:max", "schema/main"), _terminusdbClient["default"].WOQL.opt().quad("v:Restriction", "owl:minCardinality", "v:min", "schema/main")); //const restResult = await woqlClient.query(restictions);


      Promise.all([woqlClient.query(classQuery), woqlClient.query(propsQuery), woqlClient.query(restictions)]).then(function (results) {
        /*
        * CLEANING THE CARDINALITY NOT Linked WITH PROPERTY
        */
        cleaningCardinality().then(function (value) {//do nothing
        })["catch"](function (err) {
          console.log(err.message);
        })["finally"](function () {
          setResultMainGraph({
            classesResult: results[0],
            propsResult: results[1],
            restResult: results[2]
          });
        });
      })["catch"](function (err) {//setReport(err.message)
      })["finally"](function () {
        setLoading(false);
      });
    };

    if (woqlClient) loadGraphData(); //Promise.all([someCall(), anotherCall()]).then((results)=>{
  }, [reloadGraph, branch, ref]); //lets see how use it

  function cleaningCardinality() {
    return _cleaningCardinality.apply(this, arguments);
  }

  function _cleaningCardinality() {
    _cleaningCardinality = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var WOQL, card, result, query;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              WOQL = _terminusdbClient["default"].WOQL;
              card = WOQL.quad("v:Element", "type", "owl:Restriction", "schema/main").not().quad("v:Element", "owl:onProperty", "v:prop", "schema/main");
              _context.next = 5;
              return woqlClient.query(card);

            case 5:
              result = _context.sent;

              if (!(result && result.bindings.length > 0)) {
                _context.next = 11;
                break;
              }

              query = [];
              result.bindings.forEach(function (item, index) {
                var elementName = item.Element;
                query.push(WOQL.delete_class(elementName, "schema/main", "v:varName__".concat(index)));
                query.push(WOQL.opt(WOQL.quad("v:dom__".concat(index), "rdfs:subClassOf", "v:sub__".concat(index), "schema/main").eq("v:sub__".concat(index), "".concat(elementName)).delete_quad("v:dom__".concat(index), "rdfs:subClassOf", "v:sub__".concat(index), "schema/main")));
              });
              _context.next = 11;
              return woqlClient.query(WOQL.and.apply(WOQL, query));

            case 11:
              _context.next = 16;
              break;

            case 13:
              _context.prev = 13;
              _context.t0 = _context["catch"](0);
              console.log("__CARDINALITY__ERROR__", _context.t0);

            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 13]]);
    }));
    return _cleaningCardinality.apply(this, arguments);
  }

  var saveGraphChanges = function saveGraphChanges(query, commitMessage) {
    if (query !== undefined) {
      var ts = Date.now();
      setLoading(true);
      var commitM = commitMessage || "Update from model builder";
      woqlClient.query(query, commitM).then(function (result) {
        var msg = "Successfully updated schema graph";
        setReport({
          status: 'success',
          message: msg,
          time: Date.now() - ts
        });
        setReloadGraph(Date.now());
      })["catch"](function (err) {
        //setError(err.message)
        var rep = {
          status: 'error',
          error: err
        };
        var failureMessage = "Failed to load schema graph"; //setReport({failure: failureMessage, report: rep})

        setReport({
          status: "error",
          message: "Failed to update schema graph",
          error: err,
          time: Date.now() - ts
        });
      })["finally"](function () {
        setLoading(false);
      });
    }
  };

  var resetReport = function resetReport() {
    setReport(false);
  };

  return {
    mainGraphDataProvider: mainGraphDataProvider,
    saveGraphChanges: saveGraphChanges,
    reportMessage: reportMessage,
    callServerLoading: callServerLoading,
    resetReport: resetReport
  };
};

exports.modelCallServerHook = modelCallServerHook;