"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LinkTree = void 0;

var _react = _interopRequireDefault(require("react"));

var _d = require("d3");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var LinkTree = function LinkTree(props) {
  var getPath = function getPath() {
    return (0, _d.linkVertical)().x(function (d) {
      return d.x;
    }).y(function (d) {
      return d.y;
    });
  }; //render(){


  var strokeWidth = props.isSelected === true ? 4 : 3;
  var stroke = props.isSelected === true ? '#696969' : "#dddddd";
  var link = props.link;
  var pathData = {
    source: [link.source.x, link.source.y],
    target: [link.target.x, link.target.y]
  };
  var path = getPath();
  return /*#__PURE__*/_react["default"].createElement("path", {
    d: path(link),
    stroke: stroke,
    strokeWidth: strokeWidth,
    strokeOpacity: 1 //markerEnd= 'url(#markerSquare)'
    ,
    fill: "none"
  });
};

exports.LinkTree = LinkTree;