"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NodeMenuList = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var NodeMenuList = function NodeMenuList(props) {
  var onClick = function onClick(evt) {
    var action_name = evt.currentTarget.id;
    if (props.setNodeAction) props.setNodeAction(action_name);
  };

  var checkDisabledItem = function checkDisabledItem(itemId) {
    if (props.disabledItemsList) {
      var index = props.disabledList.findIndex(function (item) {
        return item === itemId;
      });
      if (index > -1) return true;
    }

    return false;
  };

  var addMenuItems = function addMenuItems() {
    var menuList = props.menuList || [];
    var fontSize = props.fontSize || 16;
    var fontColor = props.fontColor || '#000000';
    var startstep = 40;
    return menuList.map(function (menuItem, index) {
      var onClickEvent = {
        onClick: onClick
      };

      if (checkDisabledItem(menuItem.id)) {
        onClickEvent = {
          disabled: true
        };
      }

      return /*#__PURE__*/_react["default"].createElement("g", _extends({
        key: "item__".concat(index),
        transform: "translate(0,".concat(startstep * index, ")"),
        id: menuItem.id
      }, onClickEvent), /*#__PURE__*/_react["default"].createElement("rect", {
        fill: '#ffffff',
        x: 1,
        y: 0,
        width: "165",
        height: "39"
      }), /*#__PURE__*/_react["default"].createElement("text", {
        dx: 10,
        dy: 22,
        fontSize: fontSize,
        fill: fontColor
      }, " ", menuItem.label, " "));
    });
  };

  var menuItems = addMenuItems();
  var height = 40 * menuItems.length;
  return /*#__PURE__*/_react["default"].createElement("g", {
    transform: "translate(20,0)",
    id: "nodeTreeList"
  }, /*#__PURE__*/_react["default"].createElement("rect", {
    width: "167",
    height: height,
    stroke: 2,
    fill: '#cccccc'
  }), menuItems);
};

exports.NodeMenuList = NodeMenuList;