"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RelationshipBox = void 0;

var _react = _interopRequireDefault(require("react"));

var _NodeRel = require("./NodeRel");

var _RelationshipLine = require("./RelationshipLine");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var RelationshipBox = function RelationshipBox(props) {
  var source = props.source || {
    id: "Source",
    label: "NO Source"
  };
  var target = props.target || {
    id: "Target",
    label: "NO Target"
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__rel__box"
  }, /*#__PURE__*/_react["default"].createElement(_NodeRel.NodeRel, {
    name: source.name,
    label: source.label,
    onClick: props.sourceAction
  }), /*#__PURE__*/_react["default"].createElement(_RelationshipLine.RelationshipLine, {
    label: props.label || "Relationship"
  }), /*#__PURE__*/_react["default"].createElement(_NodeRel.NodeRel, {
    name: target.name,
    label: target.label,
    onClick: props.targetAction
  }));
};

exports.RelationshipBox = RelationshipBox;