"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RelationshipView = void 0;

var _react = _interopRequireDefault(require("react"));

var _RelationshipBox = require("./RelationshipBox");

var _graphObjectContext = require("../hook/graphObjectContext");

var _elementsName = require("../utils/elementsName");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var RelationshipView = function RelationshipView(props) {
  var _GraphContextObj = (0, _graphObjectContext.GraphContextObj)(),
      changeCurrentNode = _GraphContextObj.changeCurrentNode,
      selectedNodeObject = _GraphContextObj.selectedNodeObject,
      objPropsRelatedToClass = _GraphContextObj.objPropsRelatedToClass,
      mainGraphObj = _GraphContextObj.mainGraphObj,
      nodePropertiesList = _GraphContextObj.nodePropertiesList;
  /*
  * get all the relationship where the select node is a target
  */


  var relObjArr = objPropsRelatedToClass.map(function (complexPropertyObj, index) {
    var propType = complexPropertyObj.type === _elementsName.PROPERTY_TYPE_NAME.CHOICE_PROPERTY ? _elementsName.PROPERTY_TYPE_LABEL.CHOICE_PROPERTY : _elementsName.PROPERTY_TYPE_LABEL.OBJECT_PROPERTY;
    var domainData = mainGraphObj.getElement(complexPropertyObj.domain) || {};
    var label = complexPropertyObj.label || complexPropertyObj.id;
    return /*#__PURE__*/_react["default"].createElement(_RelationshipBox.RelationshipBox, {
      source: domainData,
      sourceAction: changeCurrentNode,
      target: selectedNodeObject,
      label: label,
      key: 'rel__' + index
    });
  });
  /*
  * get all the relationship where the select node is a source
  */

  var domainToProp = [];
  nodePropertiesList.forEach(function (propertyItem, index) {
    if (propertyItem.type === _elementsName.PROPERTY_TYPE_NAME.CHOICE_PROPERTY || propertyItem.type === _elementsName.PROPERTY_TYPE_NAME.OBJECT_PROPERTY) {
      if (propertyItem.range) {
        var label = propertyItem.label || propertyItem.id;
        var rangeElement = mainGraphObj.getElement(propertyItem.range);
        domainToProp.push( /*#__PURE__*/_react["default"].createElement(_RelationshipBox.RelationshipBox, {
          source: selectedNodeObject,
          targetAction: changeCurrentNode,
          target: rangeElement,
          label: label,
          key: 'dom__' + index
        }));
      }
    }
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__box"
  }, relObjArr, domainToProp);
};

exports.RelationshipView = RelationshipView;