"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRootIndexObj = exports.CLASS_TYPE_NAME_LABEL = exports.CLASS_TYPE_NAME = exports.PROPERTY_TYPE_LABEL = exports.getLabelByName = exports.PROPERTY_TYPE_NAME = void 0;
var PROPERTY_TYPE_NAME = {
  STRING_PROPERTY: 'StringProperty',
  NUMERIC_PROPERTY: 'NumericProperty',
  CHOICE_PROPERTY: 'ChoiceProperty',
  GEO_PROPERTY: 'GeoProperty',
  TEMPORAL_PROPERTY: 'TemporalProperty',
  OBJECT_PROPERTY: 'LinkProperty'
};
exports.PROPERTY_TYPE_NAME = PROPERTY_TYPE_NAME;

var getLabelByName = function getLabelByName(elementName) {
  switch (elementName) {
    case CLASS_TYPE_NAME.DOCUMENT_CLASS:
      return CLASS_TYPE_NAME_LABEL.DOCUMENT_CLASS;

    case CLASS_TYPE_NAME.OBJECT_CLASS:
      return CLASS_TYPE_NAME_LABEL.OBJECT_CLASS;

    case CLASS_TYPE_NAME.CHOICE_CLASS:
      return CLASS_TYPE_NAME_LABEL.CHOICE_CLASS;

    case CLASS_TYPE_NAME.OBJECT_CLASSES:
      return CLASS_TYPE_NAME_LABEL.OBJECT_CLASSES;

    case CLASS_TYPE_NAME.DOCUMENT_CLASSES:
      return CLASS_TYPE_NAME_LABEL.DOCUMENT_CLASSES;
  }
};

exports.getLabelByName = getLabelByName;
var PROPERTY_TYPE_LABEL = {
  STRING_PROPERTY: 'String Property',
  NUMERIC_PROPERTY: 'Numeric Property',
  CHOICE_PROPERTY: 'Enum Property',
  GEO_PROPERTY: 'Geo Property',
  TEMPORAL_PROPERTY: 'Temporal Property',
  OBJECT_PROPERTY: 'Link Property'
};
exports.PROPERTY_TYPE_LABEL = PROPERTY_TYPE_LABEL;
var CLASS_TYPE_NAME = {
  SCHEMA_ROOT: 'ROOT',
  SCHEMA_GROUP: 'Group',
  OBJECT_CLASS: 'Object',
  CHOICE_CLASS: "ChoiceClass",
  DOCUMENT_CLASS: "Document",
  DOCUMENT_CLASSES: "DocumentClasses",
  OBJECT_CLASSES: "ObjectClasses",
  CHOICE_CLASSES: "ChoiceClasses"
};
exports.CLASS_TYPE_NAME = CLASS_TYPE_NAME;
var CLASS_TYPE_NAME_LABEL = {
  SCHEMA_ROOT: 'Schema',
  SCHEMA_GROUP: 'Group',
  OBJECT_CLASS: 'Object',
  CHOICE_CLASS: "Enum",
  DOCUMENT_CLASS: "Document",
  DOCUMENT_CLASSES: "Documents",
  OBJECT_CLASSES: "Objects ",
  CHOICE_CLASSES: "Enums"
};
exports.CLASS_TYPE_NAME_LABEL = CLASS_TYPE_NAME_LABEL;

var getRootIndexObj = function getRootIndexObj(dbName) {
  var _rootIndexObj = [];
  _rootIndexObj[CLASS_TYPE_NAME.SCHEMA_ROOT] = {
    name: CLASS_TYPE_NAME.SCHEMA_ROOT,
    type: CLASS_TYPE_NAME.SCHEMA_ROOT,
    label: "".concat(dbName, " ").concat(CLASS_TYPE_NAME_LABEL.SCHEMA_ROOT),
    children: [],
    comment: CLASS_TYPE_NAME_LABEL.SCHEMA_ROOT
  };
  _rootIndexObj[CLASS_TYPE_NAME.OBJECT_CLASSES] = {
    name: CLASS_TYPE_NAME.OBJECT_CLASSES,
    parents: [],
    type: CLASS_TYPE_NAME.SCHEMA_GROUP,
    label: CLASS_TYPE_NAME_LABEL.OBJECT_CLASSES,
    children: [],
    comment: CLASS_TYPE_NAME_LABEL.OBJECT_CLASSES
  };
  _rootIndexObj[CLASS_TYPE_NAME.DOCUMENT_CLASSES] = {
    name: CLASS_TYPE_NAME.DOCUMENT_CLASSES,
    parents: [],
    type: CLASS_TYPE_NAME.SCHEMA_GROUP,
    label: CLASS_TYPE_NAME_LABEL.DOCUMENT_CLASSES,
    children: [],
    comment: CLASS_TYPE_NAME_LABEL.DOCUMENT_CLASSES
  };
  _rootIndexObj[CLASS_TYPE_NAME.CHOICE_CLASSES] = {
    name: CLASS_TYPE_NAME.CHOICE_CLASSES,
    parents: [],
    type: CLASS_TYPE_NAME.SCHEMA_GROUP,
    label: CLASS_TYPE_NAME_LABEL.CHOICE_CLASSES,
    children: [],
    comment: CLASS_TYPE_NAME_LABEL.CHOICE_CLASSES
  };
  return _rootIndexObj;
};

exports.getRootIndexObj = getRootIndexObj;