"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.treeModelApplyAction = exports.getNewNodeTemplate = exports.removeElementToArr = void 0;

var NODE_ACTION_NAME = _interopRequireWildcard(require("./actionType"));

var _terminusdbClient = require("@terminusdb/terminusdb-client");

var _this = void 0;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var removeElementToArr = function removeElementToArr(arrayList, elementName) {
  if (!arrayList) return undefined;
  var index = arrayList.findIndex(function (item) {
    return item === elementName || item.name === elementName;
  });

  if (index > -1) {
    arrayList.splice(index, 1);
    return elementName;
  }

  return undefined;
};

exports.removeElementToArr = removeElementToArr;

var getNewNodeTemplate = function getNewNodeTemplate() {
  var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var label = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "NEW NODE";
  var comment = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "";
  var nodeId = name ? _terminusdbClient.UTILS.shorten(name) : "";
  var nodeName = name || "CLASS_".concat(new Date().getTime());
  var newObj = {
    name: nodeName,
    id: nodeId,
    label: label,
    comment: comment,
    parents: [],
    newElement: true,
    children: [],
    type: type,
    allChildren: [],
    "abstract": false
  };
  if (name !== null) newObj['newElement'] = false;
  return newObj;
};

exports.getNewNodeTemplate = getNewNodeTemplate;

var treeModelApplyAction = function treeModelApplyAction(nodeName, actionName, graphData, nodeIndex) {
  if (!nodeName) return false; //const newName='new_'+index_newObj++;

  var currentNode = _this.state.graphData[nodeName];
  var currentDataProviderNode = _this.nodeIndex[nodeName];

  var indexNewObj = _defineProperty({
    name: newName,
    "label": "NEW NODE",
    type: 'node'
  }, "type", currentNode.data.type);

  if (actionName === NODE_ACTION_NAME.ADD_NEW_ENTITY) {
    indexNewObj.type = 'EntityClass';
    actionName = NODE_ACTION_NAME.ADD_CHILD;
  } else if (actionName === NODE_ACTION_NAME.ADD_NEW_CLASS) {
    indexNewObj.type = 'OrdinaryClass';
    actionName = NODE_ACTION_NAME.ADD_CHILD;
  } //else if(actionName===NODE_ACTION_NAME.ADD_NEW_RELATIONSHIP){
  // indexNewObj.type='Relationship';
  // actionName=NODE_ACTION_NAME.ADD_CHILD;
  //}
  //this.nodeIndex[newName]=indexNewObj;


  switch (actionName) {
    case NODE_ACTION_NAME.ADD_CHILD:
      newObj.parent = currentNode;
      newObj.data = indexNewObj; //{"name": newName, "label": "NEW NODE"}

      newObj.depth = currentNode.depth + 1;
      newObj.x = currentNode.x - 100;
      newObj.y = currentNode.y + 100;
      if (!currentNode.children) currentNode.children = [];
      currentNode.children.push(newObj);
      _this.state.graphData[newName] = newObj;
      if (!currentDataProviderNode.children) currentDataProviderNode.children = [];
      currentDataProviderNode.children.push(indexNewObj);
      _this.nodeIndex[newName] = indexNewObj;
      _this.state.dataEdges[currentNode.data.name + '_' + newObj.data.name] = {
        source: currentNode.data.name,
        target: newObj.data.name
      };

      _this.state.nodes.push(newObj);

      break;

    case NODE_ACTION_NAME.ADD_PARENT:
      var parentObj = currentNode.parent; //const parentObj=this.state.graphData[parentName];

      parentObj.children.push(indexNewObj);

      _this._removeLink(currentNode.parent, currentNode);

      newObj.data = indexNewObj; //{"name": newName, "label": "NEW NODE"}

      newObj.depth = currentNode.depth;
      newObj.x = currentNode.x - 100;
      newObj.y = currentNode.y - 100;
      newObj.children = [];
      newObj.children.push(currentNode);
      newObj.parent = currentNode.parent;
      currentNode.parent = newObj;
      currentNode.depth = newObj.depth + 1;
      _this.state.graphData[newName] = newObj; //currentDataProviderNode

      var currentParentDatap = _this.nodeIndex[currentDataProviderNode.parent];
      /*remove the old choldren*/

      var currentParentDatapTmp = currentParentDatap.children.filter(function (dataItem) {
        return dataItem.name !== nodeName;
      });
      currentParentDatap.children = currentParentDatapTmp;
      currentParentDatap.children.push(indexNewObj);
      indexNewObj.children = [];
      indexNewObj.children.push(currentDataProviderNode);
      _this.nodeIndex[currentNode.parent] = currentParentDatapTmp;
      _this.nodeIndex[newName] = indexNewObj;

      if (_this.state.dataEdges[parentObj.data.name + '_' + currentNode.data.name]) {
        delete _this.state.dataEdges[parentObj.data.name + '_' + currentNode.data.name];
      }

      _this.state.dataEdges[newObj.data.name + '_' + currentNode.data.name] = {
        source: currentNode.data.name,
        target: newObj.data.name
      };
      _this.state.dataEdges[parentObj.data.name + '_' + newObj.data.name] = {
        source: parentObj.data.name,
        target: newObj.data.name
      };

      _this.state.nodes.push(newObj);

      break;
  }
};

exports.treeModelApplyAction = treeModelApplyAction;